/* @(#) er_handi.h  version:1.14  dated:84/12/03 */
/*
 * SCCS file:	SCCS/s.er_handi.h
 * SCCS id :	er_handi.h 1.14
 * Last edited:	12/3/84 11:18:46
 */

extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	GksState gkstate;
extern	Gksd	*gksd;
extern	Gkse	*gkse;
extern	Bhead	*lastbh;

#define MSGLNGTH 36 /*msg filename not longer than MSGLNGTH*/
char		_msgfile[MSGLNGTH];
static File	*_msgfp = NULL;
Bool		_msgonfile = FALSE;

Bool	getfentry();

Bool
open_msgfile(filename)
String filename;
{
	/* A file is opened to write messages.
	 * This function is called in open_gks().
	 * The filename_string is a parameter of open_gks().
	 * A second opening of this file in the same application 
	 * disturbs the old contents of the file.
	 * Therefore, after closing GKS, a reopening of GKS in the same
	 * application needs another filename.
	 */
	File *fp;

	if (strlen(filename) >= MSGLNGTH) filename[MSGLNGTH-1] = '\0';

	if ((fp = fopen(filename, "w")) == NULL)  {
		/* return(FALSE); and give in open_gks error 200 */
		/* however another approach is followed: */
		char tmpfile[MSGLNGTH+10];
		sprintf(tmpfile, "/tmp/%s", filename);
		fp = fopen(tmpfile, "w");
	}
	if (fp == NULL) return(FALSE);

	setbuf(fp, (char *)NULL);

	strcpy(_msgfile, filename);
	_msgfp = fp;

	return(TRUE);
}

/*VARARGS1*/
mssge(fmt, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16)
String 	fmt;
{
	if (_msgfp) {
		fprintf(_msgfp, fmt, a1,a2,a3,a4,a5,a6,a7,a8,a9,a10, a11, a12, a13, a14, a15, a16);
		fflush(_msgfp);

		_msgonfile = TRUE;
	}
}

/*
 *print a message on stderr (=screen) (var nr of args)
 */
/*VARARGS1*/
err_msg(fmt, a1, a2, a3, a4, a5, a6, a7, a8)
String 	fmt;
{	fprintf(stderr, fmt, a1, a2, a3, a4, a5, a6, a7, a8);
}

/*
 *print a message on standard output file (var nr of args)
 */
/*VARARGS1*/
out_msg(fmt, a1, a2, a3, a4, a5, a6, a7, a8)
String 	fmt;
{ 	printf(stdout, fmt, a1, a2, a3, a4, a5, a6, a7, a8);
	fflush(stdout);
}

/*
 *rep_er() performs the actions a), b), c) and d) from page 79 (7.2).
 */
rep_er(erc, rout)
Ercode erc;
Int rout;
{
	/*a)*/
	gkse->ge_erstate = TRUE;

	/*b)*/
	if (gkse->ge_erh != NULL)
		(*gkse->ge_erh)(erc, rout);
	else	er_hand(erc, rout);

	/*c)*/
	gkse->ge_erstate = FALSE;

	/*d)*/
	err_react(erc);
}

err_react(erc)
Ercode	erc;
{	char err_class = 'c';
#ifdef LONG_ERR
	char 	ext_ermsg[140];

	if (getfentry(CGKSERRORS, (Int)erc, ext_ermsg) == TRUE)
		err_class = ext_ermsg[0];
#endif
	switch (err_class) {
	case 'a':
		break;
	case 'b':
	case 'c':
		/*here the erorr reaction includes a 
	 	 *call of 'emergency close GKS' and exit, so
	 	 *no return to calling GKS procedure. 
	 	 */
		emer_actions();
		exit((int)erc);
		break;
	}
}

#define SEPARATOR ':'

Bool
getfentry(filename, code, strptr)
String	filename;
Int	code;
char	*strptr;
{	File	*fp;
	register Int i;
	char 	*cptr = strptr;
	int	c;

	if ((fp = fopen(filename, "r")) != NULL) {
		do {	i = 0;
			while ((c=getc(fp)) != SEPARATOR && c != EOF)
				i = 10 * i + (c - '0');
			if ((i == 0 || i == code) && c == SEPARATOR) 
				while ((c=getc(fp)) != '\n' && c != EOF)
					*cptr++ = c;
			else	while (c != '\n' && c != EOF)
					c = getc(fp);
		} while (i != 0 && i != code && c != EOF);
		fclose(fp);
	}
	*cptr = '\0';
	if (strlen(strptr) != 0) return (TRUE);
	else 	return(FALSE);
}

/* If the message file is created in open_gks(),
 * i.e. open_gks() had a 4th parameter, and this file is empty,
 * the file is deleted:
 */
rm_msgfile()
{
/*if you don't have the `unlink' function leave the 
 *function body empty
 */
	if (_msgfp != NULL && _msgonfile == FALSE 
	    && strlen(_msgfile) != 0) {
		unlink(_msgfile);
		_msgfile[0] = '\0';
		_msgfp = NULL;
	}
}

