/* @(#) ev_trmat.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.ev_trmat.c
 * SCCS id :	ev_trmat.c 1.4
 * Last edited:	10/19/84 13:59:24
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*EVALUATE TRANSFORMATION MATRIX*/

#define GKS 9
#define GKS9

#include "cgksincl.h"

Tmat *
ev_trmat(p, shift, rot, scale, wcoord)
Real	*p;
Real	*shift;
Real	rot;
Real	*scale; 
Bool	wcoord; /*TRUE if WC coordinates, FALSE if NDC coordinates*/
{
	Tmat *tmat, tmrel, tmrot, tmsc, tm1, tm2;
	Nc   np, nshift;

	if (ch_state(8, EV_TRMAT) != 0) return(NULL);
	MALLOC(tmat, Tmat, sizeof(Tmat), EV_TRMAT)

	if (wcoord == TRUE) {
		ensure(EV_TRMAT);
		ntransf((Wc *)p, &np);
		ntransf((Wc *)shift, &nshift);
	}
	else {	ASS(np, *((Nc *)p))
		ASS(nshift, *((Nc *)shift))
	}

	tmrel[0][0] = tmrel[1][1] = 1.0;
	tmrel[0][1] = tmrel[1][0] = 0.0;
	tmrel[0][2] = -np.n_x; tmrel[1][2] = -np.n_y;

	tmsc[0][1] = tmsc[0][2] = tmsc[1][0] = tmsc[1][2] = 0.0;
	tmsc[0][0] = *scale; tmsc[1][1] = *(scale+1);

	tmrot[0][0] = tmrot[1][1] = cos(rot);
	tmrot[0][1] = -sin(rot);
	tmrot[1][0] = sin(rot);
	tmrot[0][2] = tmrot[1][2] = 0.0;

	matmat(tmsc,  tmrel, &(tm1[0][0]));
	matmat(tmrot, tm1,   &(tm2[0][0]));

	tmrel[0][2] = np.n_x + nshift.n_x;
	tmrel[1][2] = np.n_y + nshift.n_y;
	matmat(tmrel, tm2,   (Real *)tmat);

	return(tmat);
}
