/* @(#) footek.c  version:1.4.1.1  dated:84/12/03 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.footek.c
 * SCCS id :	footek.c 1.4.1.1
 * Last edited:	12/3/84 13:14:36
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * The function f4711() calls a function that installs the address
 * of the created structure of type Screen
 * in the workstation description table belonging
 * to type "foo".
 * The name of this function, f4711, can now be taken as the
 * workstation-type parameter of open_ws().
 */
#include	"cgksincl.h"

Bool foolerase(), footerase(), fooclose();
Bool foopline(), foomark(), foohard(), foocell();
Bool foogdp(), foopixels(), foorle(), foorect();
Bool foolatt(), foomatt(), footatt(), foofatt();
Bool fooscol(), foocoltable();
int foocursor(), fookeyboard();
Bool foohili(), foomessage(), foocliprect(), fooescape(), fooinqpix();

/*Screen g_footek[1] = {*/
Screen	g_footek[] = {
	512, 480,	/* Main screen size */
	9, 12,		/* Character box */
	6,		/* character height of a lower cast 'x' */

	/* the following 6 fields are used internally */
	0, 0,		/* Hit location */
	0,		/* s_code: Hit code. not (yet) used */
	0,		/* Colour */
	S_CHANGED,	/* s_flag ; status. field not (yet) used*/
	'\0',		/* s_timo;time out. field not (yet) used */
	footerase,	/* Total erase ; open ws*/
	foolerase,	/* set line erase mode*/
	fooclose,	/* close ws*/
	foocliprect,	/* Setting of clipping rectangle */
	foomessage,	/* Send a GKS message to device */
	fooescape,	/* GKS escape capability */

	foopline,	/* Line drawing */
	foomark,	/* Polymark */
	foohard,	/* Hard characters */
	foopixels,	/* horizontal pixel run */
	foorle,		/* run length encoding */
	foocell,	/* directly cellarray to device */
	foogdp,		/* no gdp's */
	foorect,	/* filled rectangle drawing*/

	foolatt,	/* Polyline representation */
	foomatt, 	/* Polymark repr. */
	footatt,	/* Text attributes */
	foofatt,	/* Fill area represention */
	fooscol,	/* Set Colour */
	foocoltable,	/* Set Colour Table */

	fooinqpix,	/* inquire pixel, and inq pixel array */
	foocursor,	/* Input from cursor */
	fookeyboard,	/* Input from keyboard */
	foohili,	/* Hilight output primitive*/
	};

Screen *fooscrn = g_footek;

int f4711()
{
	return(inst_scr("foo", fooscrn));
}

/*
code is generated to set line erase mode on or off. specific
for tek-like terminals not capable of drawing in (background)colour,
but capable of doing selective erase.
*/
Bool
foolerase(ws, on_or_off)
Wss	*ws;
Bool	on_or_off;
{
	fprintf(ws->ws_ofile,"f4711 foolerase ");
	fprintf(ws->ws_ofile," : pars: %s \n",
		(on_or_off == TRUE) ? "TRUE" : " FALSE");
	return(TRUE);
}

/*
 * clear screen; take some initial actions when opening the workstation 
 */
Bool  footerase(ws)
Wss	*ws;
{
	fprintf(ws->ws_ofile,"f4711 footerase \n");
	return(TRUE);
}

/*
 * actions to be taken when closing the workstation
 */
Bool
fooclose(ws)
Wss	*ws;
{
	fprintf(ws->ws_ofile,"f4711 fooclose \n");
	return(TRUE);
}

/*
 *If the device is able of doing the clipping itself set the
 *clipping rectangle (not yet used)
 */
Bool foocliprect(ws)
Wss	*ws;
{
	fprintf(ws->ws_ofile,"f4711 foocliprect");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
 * send a message consisting of a string s, from the 
 * GKS message function, to ws
 */
Bool foomessage(ws, s)
Wss	*ws;
String	s;
{
	fprintf(ws->ws_ofile,"f4711 foomessage");
	fprintf(ws->ws_ofile," : pars: string %s \n", s);
	return(TRUE);
}

/*
if possible execute the escape function ef with data ep on
a ws specific way
*/
Bool fooescape(ws, ef, ep)
Wss	*ws;
Es_func	ef;
Es_data	*ep;
{
	fprintf(ws->ws_ofile,"f4711 fooescape");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
 *generates code to draw n - 1 linepieces 
 *with points in array start,
 *using ltype and lwidth on your Footek
 */
Bool
foopline(ws, n, start, ltype, lwidth)
Wss	*ws;
Size	n;
Ic	*start;
Ltype	ltype; /*line type */
Lwidth	lwidth; /*line width */
{
	Int i;
	fprintf(ws->ws_ofile,"f4711 foopline ");
	fprintf(ws->ws_ofile,": pars: ");
	fprintf(ws->ws_ofile,"ltype = %d; ",ltype);
	fprintf(ws->ws_ofile,"lwidth = %f\n",lwidth);
	fprintf(ws->ws_ofile,"\t%d points:",n);
	for (i = 0; i < n; i++)  {
		if ((i%8) == 7) fprintf(ws->ws_ofile, "\n\t\t");
		fprintf(ws->ws_ofile,"(%d, %d) ",
			(start+i)->i_x,(start+i)->i_y);
	}
	fprintf(ws->ws_ofile,"\n");
	return(TRUE);
}

/*
generate code to draw or erase (depending on eras)
n markers of type marktyp on positions s with size marksize
*/
Bool
foomark(ws, n, s, marksize, marktyp, eras)
Wss	*ws;
Size	n;
Ic	*s;
Msize	marksize;
Mtype	marktyp;
Bool	eras;
{
	fprintf(ws->ws_ofile,"f4711 foomark");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
 *generate Footekcode to draw a hard character string s on place ic
 */
Bool
foohard(ws, s, ic)
Wss	*ws;
String	s;
Ic	*ic;
{
	fprintf(ws->ws_ofile,"f4711 foohard ");
	fprintf(ws->ws_ofile,": with ");
	fprintf(ws->ws_ofile,"string %s at pos: (%d,%d)\n",
		s,ic->i_x,ic->i_y);
	return(TRUE);
}


/*
this function generates Footek code 
for a horizontal run of lngth pixels.
The run starts in ic and draws the lngth 
pixels either all in colour s_col from the Screen if onecolor == TRUE,
or in lngth different colours, represented by the values of an array of
length lngth, pointed to by color.
*/
Bool
foopixels(ws, ic, lngth, color, onecolor)
Wss	*ws;
Ic	*ic;
Int	lngth;
Cindex	*color;
Bool	onecolor; 
{
	fprintf(ws->ws_ofile,"f4711 foopixels");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
Draw a horizontal run of pixels starting in ic.
Run starts with runs[0] pixels of colour cols[0], followed by
runs[1] pixels of colour cols[1], etc. last is runs[nr-1] pixels
of colour cols[nr-1].
*/
Bool
foorle(ws, ic, nr, runs, cols)
Wss	*ws;
Ic	*ic; /* starting point */
Int	nr; /* number of couples of lengths and colours */
Int	*runs; /* pointer to nr runs */
Cindex	*cols; /* pointer to nr colourindices */
{
	fprintf(ws->ws_ofile,"f4711 foorle");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
Draw a cellarray on screen of n by m pixels with upper left in ul. 
The n*m pixels are filled with colours according to indices in 
the one-dimensional array ccols. ccols[0] is colourindex of pixel 
at ul.
*/
Bool
foocell(ws, ul, n, m, ccols)
Wss	*ws;
Ic	*ul; /* upper left of cellarray */
Size	n, m; /*height and width */
Cindex	*ccols; /* pointer to n*m colourindices */
{
	fprintf(ws->ws_ofile,"f4711 foocell");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

Bool
foogdp(ws, id, n, ic, lrep, mrep, trep, frep, m, gdr)
Wss	*ws;
Gdpi	id;   	/* gdp identifier. for example CIRCLE */
Size	n;    	/* number of Ic */
Ic	*ic;  	/* gdp coordinates */
LineRep	*lrep;	/* may be NULL */
MarkRep	*mrep;	/* may be NULL */
TextRep	*trep;	/* may be NULL */
AreaRep	*frep;	/* may be NULL */
Size	m;    	/* size of gdr */
Grecord	*gdr; 	/* additional data, gdp_id dependent */
{
	fprintf(ws->ws_ofile,"f4711 foogdp");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
generate code to draw filled rectangle (filled with
current colour if colour available)with lowerleftcorner 
at ll, and upperrightcorner at ur.
if workstation is not capable of drawing filled rectangles this
functionfield may be used to erase 
rectangles (if the ws has this capability).
*/
Bool
foorect(ws, ll, ur)
Wss	*ws;
Ic	*ll, *ur;
{
	fprintf(ws->ws_ofile,"f4711 foorect");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}


/*
install line attributes from linerep on ws
*/
Bool
foolatt(ws, lrep)
Wss	*ws;
LineRep	lrep;
{
	fprintf(ws->ws_ofile,"f4711 foolatt");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
install attributes from markrep on ws
*/
Bool
foomatt(ws, mrep)
Wss	*ws;
MarkRep	mrep;
{
	fprintf(ws->ws_ofile,"f4711 foomatt");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
install attributes from textrep on ws (other attributes will be added)
*/
Bool
footatt(ws, trep)
Wss	*ws;
TextRep	trep;
{
	fprintf(ws->ws_ofile,"f4711 footatt");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
install attributes from fillrep on ws
*/
Bool
foofatt(ws, frep)
Wss	*ws;
AreaRep	frep;
{
	fprintf(ws->ws_ofile,"f4711 foofatt");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
 * make colix the colour to be used when drawing primitives on screen
 */
Bool
fooscol(ws, colix)
Wss	*ws;
Cindex	colix;
{
	fprintf(ws->ws_ofile,"f4711 fooscol");
	fprintf(ws->ws_ofile," : col index = %d\n",colix);
	if (WsScrn->s_ccol != colix){
		 WsScrn->s_ccol = colix;
	}
	return(TRUE);
}

/*
install the colourtable in your Footek; colp points 
to the first of all the colours
*/
Bool
foocoltable(ws, colp)
Wss	*ws;
Colour	*colp;
{
	fprintf(ws->ws_ofile,"f4711 foocoltable");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
inqpixels() gets pixelvalues from area starting at (dx, dy)
in upperleft corner, and with sizes ix by iy.
Values are returned in ci.
*/
Bool
fooinqpix (ws, ix, iy, dx, dy, inv, ci)
Wss	*ws;
int	ix, iy;
Int	dx, dy;
Bool	*inv;
Cindex	*ci;
{
	fprintf(ws->ws_ofile,"f4711 fooinqpix");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}

/*
makes your Footek return the char which activated 
the cursor, and its position s  in screen space.
Pet 1 is a default type, type 2 is cross hair.
*/
int
foocursor(ws, s, pet)
Wss	*ws; /* pointer to workstationstatelist of Footek*/
Ic	*s;
Pet	*pet; /* prompt/echo type */
{
	char ch = ' ', c = ' ';
	fprintf(ws->ws_ofile,"f4711 foocursor");
	fprintf(ws->ws_ofile," : pars: \n");
	fprintf(ws->ws_ofile,"\tpet = %d\n",pet);
	fprintf(ws->ws_ofile,"give me 2 integers: ");
	fscanf(ws->ws_ifile,"%d %d", &(s->i_x), &(s->i_y));
	fprintf(ws->ws_ofile,"thanx for giving %d and %d\n",
		s->i_x,s->i_y);

	/*skip characters untill '\n' */
	do {	fscanf(ws->ws_ifile,"%c",&ch);
	} while (ch != '\n');

	return(c);
}

/*
function to get character from keyboard;
hit is current position in screen space
*/
int
fookeyboard(ws, s, hit)
Wss	*ws;
Ic	*s, *hit;
{
	char  c, ch;
	fprintf(ws->ws_ofile,"f4711 fookeyboard");
	fprintf(ws->ws_ofile," : pars: \n");
	fprintf(ws->ws_ofile,"give me a character\n ");
	fprintf(ws->ws_ofile,"(the carriage-return character ");
	fprintf(ws->ws_ofile,"is represented by an empty string)\n");

	fscanf(ws->ws_ifile,"%c", &c);
	fprintf(ws->ws_ofile,"thanx for giving char '%c'\n",c);
	ch = c;

	while (ch != '\n') {
		/*skip until newline char */
		fscanf(ws->ws_ifile,"%c", &ch);
	}

	return(c);
}

/*
 * hilights n points ic on screen
 */
Bool
foohili(ws, n, ic)
Wss	*ws;
Int	n;
Ic	*ic;
{
	fprintf(ws->ws_ofile,"f4711 foohili");
	fprintf(ws->ws_ofile," : pars: \n");
	return(TRUE);
}
