/* @(#) inssegi.h  version:1.8  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.inssegi.h
 * SCCS id :	inssegi.h 1.8
 * Last edited:	10/19/84 13:57:19
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


/*
 *INSERT SEGMENT 
 */

/*
 * If a segment is open during insert segment, all the info is
 * also stored in this open segment, as indicated in GKS 7.2.
 * As the info is taken from a segment lazy evaluation is
 * superfluous, because this mechanism is already applied
 * during the storage of the origional segment.
 * However, at this moment, to make the use of existing code
 * possible, this mechanism is applied again when inserting the
 * segment.
 */

/*todo: combine segment matrix and insert matrix*/
#define GKS1
#define GKS2
#define GKS3
#define GKS4
#define GKS5

#include "cgksincl.h"

extern GksState	gkstate;
extern Gks	*_gkss;
extern Gksd	*gksd;
extern Gksi	*gksis;
extern Int	attmark[];
extern Tmat 	u_mat;

Nc	*sg_sp_pr();
Nc	*nc_trans();	/*funcode in u_defacts.c*/
Nc 	* nc_insert();
char 	*find_rep();
Bool	unit_mat();
	vecrotate();

static	Bool	unitboth, segstore;
static	Tmat	tmatboth;

extern	Bool	b_insseg;
	/*
	 * b_insseg is TRUE only during insertion in ins_sg_all_ws().
	 * It is defined in u_wsprim.c, and checked in pr_to_all_ws().
	 * (for this purpose also the variable _gksfun could be used)
	 */


ins_sg_all_ws(seg, tmat)
Seg	*seg;
Tmat 	*tmat;
{
	register Bhead	*bhead, *bh2;
	Gks	gksold;
	Gksi	gksisold;
	Nc	*nc_vec, nc_vec2, nc_vec3, *nctr;
	Int	i, n, ncsize = sizeof(Nc);
	Size	*sptr;
	Bool	dofree;
	Wss	*ws;

	/* save old states to reinstall after while loop: */
	/*not necessary to copy whole statelist */
	ASS(gksold , *_gkss)
	ASS(gksisold , *gksis)

	bhead	= seg->sg_firstbh;

	matmat(*tmat, seg->sg_mat, &tmatboth[0][0]);

	i = 0;
	while ((ws = _gkss->gk_actv[i++]) != NULL) {
	    	if (ws->ws_wsd->wd_cat != WISS) {
		    /*active ws can't be of MI/INPUT type*/
			ws->ws_wsis->wi_sgmat = 
				(Tmat *)(&tmatboth[0][0]);
		}
  	}
	/*
	 *this matrix is used (among others?) to calculate
	 *for cellarray, and fillarea-patterns in which 
	 *grid cell the pixels belong.
	 */

	unitboth = unit_mat(&tmatboth[0][0]);

	segstore = (Bool)(gkstate == SGOP && gksis->gki_sgact == TRUE);
	dofree = (Bool)(segstore == FALSE && unitboth == FALSE);

	b_insseg = TRUE; /*TRUE only during insertion*/

	while (bhead != NULL) {/**begin while*********/
	  bh2 = bhead + 1;
	  switch(bhead->sb_typ) {/**begin switch*****/
	  case SG_PID:
		_gkss->gk_pikid = *((Pickid *)(bhead + 1));
		sg_mark(bhead->sb_typ);
		/*this MARK causes the PID to be restored
		 *in ensure, if segment is open
		 */
		break;
	  case SG_CLP:
		/* stored clipping rectangle is not interpreted,
		 * and not restored in the open segment!
		 */
		break;
	  case POL:
		ensure(POL);
		n = bhead->sb_sz / ncsize;
		nctr = nc_insert((Nc *)(bhead + 1), n, POL);
		pr_to_all_ws(n, (Size *)NULL, (String)NULL, nctr, POL);
		cl_mark(PLATT);

		if (dofree == TRUE) FREE(nctr)
		break;
	  case POM:
		ensure(POM);
		n = bhead->sb_sz / ncsize;
		nctr = nc_insert((Nc *)(bhead + 1), n,POM);
		pr_to_all_ws(n, (Size *)NULL, (String)NULL, nctr, POM);
		cl_mark(PMATT);
		if (dofree == TRUE) FREE(nctr)
		break;
	  case TXT:
		ensure(TXT);
		nctr = nc_insert((Nc *)(bhead + 1), 1, TXT);
		if (segstore == TRUE)
			sg_st_str((String)(bhead->sb_link + 1), TXT);
		pr_to_all_ws(1, (Size *)NULL, 
				(String)(bhead->sb_link+1), nctr, TXT);
		cl_mark(TXATT);
	
		if (dofree == TRUE) FREE(nctr)

		bhead = bhead->sb_link;
		break;
	  case FAR:
		ensure(FAR);
		n = bhead->sb_sz / ncsize;
		nctr = nc_insert((Nc *)(bhead + 1), n, FAR);
		pr_to_all_ws(n, (Size *)NULL, (String)NULL, nctr, FAR);
		cl_mark(FAATT);
		if (dofree == TRUE) FREE(nctr)

		break;
	  case CELL:
		ensure(CELL);
		nctr = nc_insert((Nc *)(bhead + 1), 4, CELL);
		sptr = (Size *)(bhead->sb_link + 1);
		if (segstore == TRUE) 
		      sgsp_cells(*sptr, *(sptr+1), (Cindex *)(sptr+2));

		pr_to_all_ws(4, sptr, (String)NULL, nctr, CELL);

		if (dofree == TRUE) FREE(nctr)

		cl_mark(PMATT);

		bhead = bhead->sb_link;
		break;
	  case GDP:
		/*still to do*/
		break;

	 /* more cases for attributes setting etc ? */

	  case SG_ASF:
	  case S_ASF:
		_s_asflags(*((Asflags *)bh2));
		break;

	  case SG_PLI :
		_gkss->gk_line = *((Bindex *)bh2);
		ch_mark(PLATT);
		sg_mark(SG_PLI);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_spli)(ws,_gkss->gk_line);
		}

#endif
		break;
	  case SG_LT :
		_gkss->gk_lrlt = *((Ltype *)bh2);
		ch_mark(PLATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sln)(ws,_gkss->gk_lrlt);
		}

#endif
		break;
	  case SG_LW :
		_gkss->gk_lrlw = *((Lwidth *)bh2);
		ch_mark(PLATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_slwsc)(ws,_gkss->gk_lrlw);
			}

#endif
		break;
	  case SG_LCI :
		_gkss->gk_lrci = *((Cindex *)bh2);
		ch_mark(PLATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_splci)(ws,_gkss->gk_lrci);
			}

#endif
		break;

	  case SG_PMI :
		_gkss->gk_mark = *((Bindex *)bh2);
		ch_mark(PMATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_spmi)(ws,_gkss->gk_mark);
			}

#endif
		break;
	  case SG_MT :
		_gkss->gk_mrmt = *((Mtype *)bh2);
		ch_mark(PMATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_smk)(ws,_gkss->gk_mrmt);
			}

#endif
		break;
	  case SG_MSZ :
		_gkss->gk_mrms = *((Msize *)bh2);
		ch_mark(PMATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_smksc)(ws,_gkss->gk_mrms);
			}

#endif
		break;
	  case SG_MCI :
		_gkss->gk_mrci = *((Cindex *)bh2);
		ch_mark(PMATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_spmci)(ws,_gkss->gk_mrci);
			}

#endif
		break;

	  case SG_TXI :
		_gkss->gk_text = *((Bindex *)bh2);
		ch_mark(TXATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_stxi)(ws,_gkss->gk_text);
			}

#endif
		break;
	  case SG_TXFP:
		ASS(_gkss->gk_txfp , *((FoPr *)bh2))
		ch_mark(TXATT);
		if (gkstate == SGOP) ch_mark(SG_TXFP);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_stxfp)(ws,_gkss->gk_txfp);
			}

#endif
		break;
	  case SG_CHSP :
		_gkss->gk_chsp = *((Charsp *)bh2);
		ch_mark(TXATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_schsp)(ws,_gkss->gk_chsp);
			}

#endif
		break;
	  case SG_CHEF:
		_gkss->gk_chef = *((Charef *)bh2);
		ch_mark(TXATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_schxp)(ws,_gkss->gk_chef);
			}

#endif
		break;
	  case SG_TXCI:
		_gkss->gk_txci = *((Cindex *)bh2);
		ch_mark(TXATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_stxci)(ws,_gkss->gk_txci);
			}

#endif
		break;
	  case SG_CHV :
		/*the following 2 segment blocks contain high and width
		 *vector in NDC coordinates
		 */
		nc_vec = (Nc *)bh2;
		vecrotate(&nc_vec2.n_x,&nc_vec->n_x,&seg->sg_mat[0][0]);
		vecrotate(&nc_vec3.n_x, &nc_vec2.n_x, (Real *)tmat);
		ASS(gksis->gki_chvec , nc_vec3)

		bhead = bhead->sb_link;
		bh2 = bhead + 1;
		nc_vec = (Nc *)bh2;
		vecrotate(&nc_vec2.n_x,&nc_vec->n_x,&seg->sg_mat[0][0]);
		vecrotate(&nc_vec3.n_x, &nc_vec2.n_x, (Real *)tmat);
		ASS(gksis->gki_cwvec , nc_vec3)
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_schup)
			   (ws,gksis->gki_chvec,gksis->gki_cwvec);
		}

#endif
		attmark[SG_CHV] &= ~CH;
		attmark[SG_CHV] &= ~TR; /*to prevent recalculation of 
				         *gksis->gki_chvec and 
					 *gksis->gki_cwvec in 
					 *ensure(TXT) */
		st_mark(SG_CHV); /*for both height and width vector*/
		ch_mark(TXATT);
		msk_openws(WS_CHV);
		msk_openws(WS_CWV);
		break;
	  case SG_FAI :
		_gkss->gk_area = *((Bindex *)bh2);
		ch_mark(FAATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sfai)(ws,_gkss->gk_area);
			}

#endif
		break;
	  case SG_FAIS :
		_gkss->gk_fais = *((Istyle *)bh2);
		ch_mark(FAATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sfais)(ws,_gkss->gk_fais);
			}

#endif
		break;
	  case SG_FASI :
		_gkss->gk_fasi = *((Sindex *)bh2);
		ch_mark(FAATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sfasi)(ws,_gkss->gk_fasi);
			}

#endif
		break;
	  case SG_FACI :
		_gkss->gk_faci = *((Cindex *)bh2);
		ch_mark(FAATT);
		sg_mark(bhead->sb_typ);
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sfaci)(ws,_gkss->gk_faci);
			}

#endif
		break;
	  case SG_PASZ :
		/*2 blocks are stored in the segment for this value!*/
		nc_vec = (Nc *)bh2;
		vecrotate(&nc_vec2.n_x,&nc_vec->n_x,&seg->sg_mat[0][0]);
		vecrotate(&nc_vec3.n_x, &nc_vec2.n_x, (Real *)tmat);
		ASS(gksis->gki_xpatsiz , nc_vec3)

		bhead = bhead->sb_link;
		bh2 = bhead + 1;
		nc_vec = (Nc *)bh2;
		vecrotate(&nc_vec2.n_x,&nc_vec->n_x,&seg->sg_mat[0][0]);
		vecrotate(&nc_vec3.n_x, &nc_vec2.n_x, (Real *)tmat);
		ASS(gksis->gki_ypatsiz , nc_vec3)

#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_spa)
			   (ws,gksis->gki_xpatsiz,gksis->gki_ypatsiz);
		}

#endif
		attmark[SG_PASZ] &= ~CH;
		attmark[SG_PASZ] &= ~TR; /*to prevent recalculation of 
				         *gksis->gki_xpatsiz and 
					 *gksis->gki_ypatsiz in 
					 *ensure(FAR) */
		st_mark(SG_PASZ); /*for both vectors*/
		msk_openws(WS_PASZ);
		break;
	  case SG_PARP :
		nc_vec = (Nc *)bh2;
		vecmat(&nc_vec2.n_x,&nc_vec->n_x,&seg->sg_mat[0][0]);
		vecmat(&nc_vec3.n_x, &nc_vec2.n_x, (Real *)tmat);
		ASS(gksis->gki_patref , nc_vec3)
#ifdef METAFILE
/*
*		item is routed to metafile
*/
		if (ws->ws_wsd->wd_cat == MO){
			(*MfScrn->m_sparf)(ws,gksis->gki_patref);
		}
#endif
		attmark[SG_PARP] &= ~CH;
		attmark[SG_PARP] &= ~TR; 
		st_mark(SG_PARP);
		msk_openws(WS_PARP);
		break;

	  default:
	       /*
		 *mssge( "default; case %d\n",bhead->sb_typ);
		 */
		break;
	  }/******end switch****************************/

	  bhead = bhead->sb_link;
	} /*****end while loop***************************/
	 
	b_insseg = FALSE;
	/*
	 * now force an eventual neccessary implicit regeneration
	 * on all workstations
	 * by calling ws_irg() via pr_to_all_ws() :
	 */
	pr_to_all_ws(0, (Size *) NULL, (String)NULL, (Nc *)NULL, IN_SG);

	/*
	 *to force attributes to be reinstalled in workstation
	 *internal statelist, when calling an output function:
	 */
	ch_mark(PLATT);
	ch_mark(PMATT);
	ch_mark(FAATT);
	ch_mark(TXATT);

	msk_openws(WS_MAT);
	/* 
	 * via this setting also WS_CLP and WS_CHV are set 
	 * in ws_ensure()
	 */

	i = 0;
	while ((ws = _gkss->gk_actv[i++]) != NULL) {
		if (ws->ws_wsd->wd_cat != WISS) {
			ws->ws_wsis->wi_sgmat = 
				(Tmat *)(&u_mat[0][0]);
	  	}
	} 

	ASS(*_gkss , gksold)
	ASS(*gksis , gksisold)
	 
	/* now set all flags on,
	 * i.e ch_mark(SG_PID);	 etc.
	 * to allow old attributes to be stored again in segment.
	 * Is used if primitive is called
	 * (only to do if segment is open) :
	 */
	if (gkstate == SGOP)  s_sgmarks();/*fun in newsegi.h*/

}

/*transform Nc coordinates with segment and insert transformation.
 *store coordinates if a segment is open
 */
static
Nc *
nc_insert(nc, n, prt)
Nc	*nc;
Size 	n;
Int	prt;
{
	Nc	*ncnew, *ncseg;
	Int	i;

	if (segstore == TRUE) {
		ncnew = ncseg = sg_sp_pr(n, prt);

		if (unitboth == TRUE) {
			for (i = 0; i < n; i++) ASS(*(ncseg++), *(nc++))
		}
		else {
			for (i = 0; i < n; i++) {
				vecmat((Real *)ncseg, (Real *)nc,
					tmatboth); 
				ncseg++; nc++;
			}
		}
	}
	else {
		if (unitboth == TRUE) ncnew = nc;
		else	ncnew = nc_trans(tmatboth, nc, n, IN_SG);
	}
	return(ncnew);
}
