/* @(#) intrp_itm.c  version:1.3  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.intrp_itm.c
 * SCCS id :	intrp_itm.c 1.3
 * Last edited:	11/9/84 14:40:35
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
/*
 *	interpret item
 */
#define GKS1
#define GKS7
#define GKS 7

#include	"mi_itp.h"

/*
 * Interpret metafile item
 */
intrp_itm(type,lrec,datrec)
Itmtp	type;
Size	lrec;
char	*datrec;
{
#ifdef METAFILE
	Wss	*ws, *ws_mi_conn();
	Gks	gksstmp; /* temporary copy of Gks Statelist	*/
	Gksi	gksistmp; /* temp. copy of Gks Internal Statelist */

	Ch_State(7,IP_IT_GKSM);

	if (type > 100)
		Rep_Er(167,IP_IT_GKSM);

	ws = ws_mi_conn(type,lrec,datrec);


/*
*	not yet active
	ASS(gksstmp,*_gkss)
	ASS(*_gkss,*(MiGks))

	ASS(gksistmp,*gksis)
	ASS(*gksis,*(MiGksi))


*/

	datrec[lrec] = '\0';

	switch (type) {

	case M_CLWK:
		i_clwk(lrec,&datrec); /* end item	*/
		ws->ws_wsis->wi_miend = TRUE;
		break;

	case M_CLRWK:
		i_clrwk(lrec,&datrec); /* clear workstation	*/
		break;

	case M_RSGWK:
		i_rsgwk(lrec,&datrec); /* redraw all segments on w.s.*/

		break;

	case M_UWK:
		i_uwk(lrec,&datrec); /* update w.s.	*/
		break;

	case M_SDS:
		i_sds(lrec,&datrec); /* set deferral state	*/
		break;

	case M_MSG:
		i_msg(lrec,&datrec); /* message	*/
		break;

	case M_ESC:
		i_esc(lrec,&datrec); /* escape	*/
		break;


	case M_PL:
		i_pl(lrec,&datrec); /* polyline	*/
		break;

	case M_PM:
		i_pm(lrec,&datrec); /* polymarker	*/
		break;

	case M_TX:
		i_tx(lrec,&datrec); /* text	*/
		break;

	case M_FA:
		i_fa(lrec,&datrec); /* fill area	*/
		break;

	case M_CA:
		i_ca(lrec,&datrec); /* cell array	*/
		break;

	case M_GDP:
		i_gdp(lrec,&datrec); /* general drawing primitive*/
		break;

	case M_SPLI:
		i_spli(lrec,&datrec); /* set polyline index	*/
		break;

	case M_SLN:
		i_sln(lrec,&datrec); /* set line type	*/
		break;

	case M_SLWSC:
		i_slwsc(lrec,&datrec); /* set linewidth scale factor*/
		break;

	case M_SPLCI:
		i_splci(lrec,&datrec); /* set polyline colour index*/
		break;

	case M_SPMI:
		i_spmi(lrec,&datrec); /* set polymarker index	*/
		break;

	case M_SMK:
		i_smk(lrec,&datrec); /* set marker type	*/
		break;

	case M_SMKSC:
		i_smksc(lrec,&datrec); /* set marker size scale fac*/
		break;

	case M_SPMCI:
		i_spmci(lrec,&datrec); /* set marker colour index*/
		break;

	case M_STXI:
		i_stxi(lrec,&datrec); /* set text index*/
		break;

	case M_STXFP:
		i_stxfp(lrec,&datrec); /* set text font and precision*/
		break;

	case M_SCHXP:
		i_schxp(lrec,&datrec); /* set character expansion fac*/
		break;

	case M_SCHSP:
		i_schsp(lrec,&datrec); /* set character spacing*/
		break;

	case M_STXCI:
		i_stxci(lrec,&datrec); /* set text colour index*/
		break;

	case M_SCHUP:
		i_schup(lrec,&datrec); /* set character up vector*/
		break;

	case M_STXP:
		i_stxp(lrec,&datrec); /* set text path	*/
		break;

	case M_STXAL:
		i_stxal(lrec,&datrec); /* set text alignment	*/
		break;

	case M_SFAI:
		i_sfai(lrec,&datrec); /* set fill area index	*/
		break;

	case M_SFAIS:
		i_sfais(lrec,&datrec); /* set fill area int style*/
		break;

	case M_SFASI:
		i_sfasi(lrec,&datrec); /* set fill area style index*/
		break;

	case M_SFACI:
		i_sfaci(lrec,&datrec); /* set fill area colour index*/
		break;

	case M_SPA:
		i_spa(lrec,&datrec); /* set pattern size	*/
		break;

	case M_SPARF:
		i_sparf(lrec,&datrec); /* set pattern reference point*/
		break;

	case M_SASF:
		i_sasf(lrec,&datrec); /* set ASPECT SOURCE FLAGs*/
		break;

	case M_SPKID:
		i_spkid(lrec,&datrec); /* set pick identifier	*/
		break;

	case M_SPLR:
		i_splr(lrec,&datrec); /* set poyline representation*/
		break;

	case M_SPMR:
		i_spmr(lrec,&datrec); /* set polymark representation */
		break;

	case M_STXR:
		i_stxr(lrec,&datrec); /* set text representation*/
		break;

	case M_SFAR:
		i_sfar(lrec,&datrec); /* set f area representation*/
		break;

	case M_SPAR:
		i_spar(lrec,&datrec); /* set pattern representation*/
		break;

	case M_SCR:
		i_scr(lrec,&datrec); /* set colour representation*/
		break;

	case M_SCLPR:
		i_sclpr(lrec,&datrec); /* set clipping rectangle*/
		break;

	case M_SWKWN:
		i_swkwn(lrec,&datrec); /* set workstation window*/
		break;

	case M_SWKVP:
		i_swkvp(lrec,&datrec); /* set workstation viewport*/
		break;

	case M_CRSG:
		i_crsg(lrec,&datrec); /* create segment	*/
		break;

	case M_CLSG:
		i_clsg(lrec,&datrec); /* close segment	*/
		break;

	case M_RENSG:
		i_rensg(lrec,&datrec); /* rename segment	*/
		break;

	case M_DSG:
		i_dsg(lrec,&datrec); /* delete segment	*/
		break;

	case M_SSGT:
		i_ssgt(lrec,&datrec); /* set segment transformation*/
		break;

	case M_SVIS:
		i_svis(lrec,&datrec); /* set segment visibility*/
		break;

	case M_SHLIT:
		i_shlit(lrec,&datrec); /* set segment highlighting*/
		break;

	case M_SSGP:
		i_ssgp(lrec,&datrec); /* set segment priority	*/
		break;

	case M_SDTEC:
		i_sdtec(lrec,&datrec); /* set segment detectability*/
		break;

		default:
		break;
	}


/*
*	not yet active

	ASS(*(MiGks),*_gkss)
	ASS(*_gkss,gksstmp)

	ASS(*(MiGksi),*gksis)
	ASS(*gksis,gksistmp)

	FREE(datrec)
*/

	return(0);

#endif /*METAFILE */
}
