/* @(#) mf_drive.c  version:1.10  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_drive.c
 * SCCS id :	mf_drive.c 1.10
 * Last edited:	11/12/84 11:04:39
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS2
#define GKS3
#define GKS4
#define GKS5
#define GKS7
#define GKS8

#include	"cgksincl.h"


#ifdef METAFILE
#include	"mf_drive.h"

/*
 *	control functions
 */

STATIC Bool m_hdr	();	/* metafile header	*/
STATIC Bool m_clwk	();	/* end item	*/
STATIC Bool m_clrwk	();	/* clear workstation	*/
STATIC Bool m_rsgwk	();	/* redraw all segments on w.s.*/
STATIC Bool m_uwk	();	/* update w.s.	*/
STATIC Bool m_sds	();	/* set deferral state	*/
STATIC Bool m_msg	();	/* message	*/
STATIC Bool m_esc	();	/* escape	*/

/*
 *	output functions
 */

STATIC Bool m_pl	();	/* polyline	*/
STATIC Bool m_pm	();	/* polymarker	*/
STATIC Bool m_tx	();	/* text	*/
STATIC Bool m_fa	();	/* fill area	*/
STATIC Bool m_ca	();	/* cell array	*/
STATIC Bool m_gdp	();	/* general drawing primitive*/

/*
 *	output attibute functions
 */

STATIC Bool m_spli	();	/* set polyline index	*/
STATIC Bool m_sln	();	/* set line type	*/
STATIC Bool m_slwsc	();	/* set linewidth scale factor*/
STATIC Bool m_splci	();	/* set polyline colour index*/
STATIC Bool m_spmi	();	/* set polymarker index	*/
STATIC Bool m_smk	();	/* set marker type	*/
STATIC Bool m_smksc	();	/* set marker size scale fac*/
STATIC Bool m_spmci	();	/* set marker colour index*/
STATIC Bool m_stxi	();	/* set text index*/
STATIC Bool m_stxfp	();	/* set text font and precision*/
STATIC Bool m_schxp	();	/* set character expansion fac*/
STATIC Bool m_schsp	();	/* set character spacing*/
STATIC Bool m_stxci	();	/* set text colour index*/
STATIC Bool m_schup	();	/* set character up vector*/
STATIC Bool m_stxp	();	/* set text path	*/
STATIC Bool m_stxal	();	/* set text alignment	*/
STATIC Bool m_sfai	();	/* set fill area index	*/
STATIC Bool m_sfais	();	/* set fill area int style*/
STATIC Bool m_sfasi	();	/* set fill area style index*/
STATIC Bool m_sfaci	();	/* set fill area colour index*/
STATIC Bool m_spa	();	/* set pattern size	*/
STATIC Bool m_sparf	();	/* set pattern reference point*/
STATIC Bool m_sasf	();	/* set ASPECT SOURCE FLAGs*/
STATIC Bool m_spkid	();	/* set pick identifier	*/

/*
 *	workstation attibute functions
 */

STATIC Bool m_splr	();	/* set poyline representation*/
STATIC Bool m_spmr	();	/* set polymarker repres*/
STATIC Bool m_stxr	();	/* set text representation*/
STATIC Bool m_sfar	();	/* set f area representation*/
STATIC Bool m_spar	();	/* set pattern representation*/
STATIC Bool m_scr	();	/* set colour representation*/

/*
 *	transformation functions
 */

STATIC Bool m_sclpr	();	/* set clipping rectangle*/
STATIC Bool m_swkwn	();	/* set workstation window*/
STATIC Bool m_swkvp	();	/* set workstation viewport*/

/*
 *	segment functions
 */

STATIC Bool m_crsg	();	/* create segment	*/
STATIC Bool m_clsg	();	/* close segment	*/
STATIC Bool m_rensg	();	/* rename segment	*/
STATIC Bool m_dsg	();	/* delete segment	*/

/*
 *	segment attribute functions
 */

STATIC Bool m_ssgt	();	/* set segment transformation*/
STATIC Bool m_svis	();	/* set segment visibility*/
STATIC Bool m_shlit	();	/* set segment highlighting*/
STATIC Bool m_ssgp	();	/* set segment priority	*/
STATIC Bool m_sdtec	();	/* set segment detectability*/

Mf_screen	g_mfile1[] = {
	m_hdr	,	/* 	metafile header	*/
	m_clwk	,	/*	end item	*/
	m_clrwk	,	/*	clear workstation	*/
	m_rsgwk	,	/*	redraw all segments on w.s.	*/
	m_uwk	,	/*	update w.s.	*/
	m_sds	,	/*	set deferral state	*/
	m_msg	,	/*	message	*/
	m_esc	,	/*	escape	*/

	m_pl	,	/*	polyline	*/
	m_pm	,	/*	polymarker	*/
	m_tx	,	/*	text	*/
	m_fa	,	/*	fill area	*/
	m_ca	,	/*	cell array	*/
	m_gdp	,	/*	general drawing primitive	*/

	m_spli	,	/*	set polyline index	*/
	m_sln	,	/*	set line type	*/
	m_slwsc	,	/*	set linewidth scale factor	*/
	m_splci	,	/*	set polyline colour index	*/
	m_spmi	,	/*	set polymarker index	*/
	m_smk	,	/*	set marker type		*/
	m_smksc	,	/*	set marker size scale factor	*/
	m_spmci	,	/*	set marker colour index	*/
	m_stxi	,	/*	set text index	*/
	m_stxfp	,	/*	set text font and precision	*/
	m_schxp	,	/*	set character expansion factor	*/
	m_schsp	,	/*	set character spacing	*/
	m_stxci	,	/*	set text colour index	*/
	m_schup	,	/*	set character up vector	*/
	m_stxp	,	/*	set text path	*/
	m_stxal	,	/*	set text alignment	*/
	m_sfai	,	/*	set fill area index	*/
	m_sfais	,	/*	set fill area interior style	*/
	m_sfasi	,	/*	set fill area style index	*/
	m_sfaci	,	/*	set fill area colour index	*/
	m_spa	,	/*	set pattern size	*/
	m_sparf	,	/*	set pattern reference point	*/
	m_sasf	,	/*	set ASPECT SOURCE FLAGs	*/
	m_spkid	,	/*	set pick identifier	*/

	m_splr	,	/*	set poyline representation	*/
	m_spmr	,	/*	set polymarker representation	*/
	m_stxr	,	/*	set text representation	*/
	m_sfar	,	/*	set fill area representation	*/
	m_spar	,	/*	set pattern representation	*/
	m_scr	,	/*	set colour representation	*/

	m_sclpr	,	/*	set clipping rectangle	*/
	m_swkwn	,	/*	set workstation window	*/
	m_swkvp	,	/*	set workstation viewport	*/

	m_crsg	,	/*	create segment	*/
	m_clsg	,	/*	close segment	*/
	m_rensg	,	/*	rename segment	*/
	m_dsg	,	/*	delete segment	*/

	m_ssgt	,	/*	set segment transformation	*/
	m_svis	,	/*	set segment visibility	*/
	m_shlit	,	/*	set segment highlighting	*/
	m_ssgp	,	/*	set segment priority	*/
	m_sdtec		/*	set segment detectability	*/
	} ;

Mf_screen *mf1scrn = g_mfile1;



#include "mf_contr.h"
#include "mf_outpr.h"
#include "mf_platt.h"
#include "mf_pmatt.h"
#include "mf_txatt.h"
#include "mf_etcatt.h"
#include "mf_repr.h"
#include "mf_trans.h"
#include "mf_segfns.h"
#include "mf_route.h"

#endif


int
mo()
{
#ifdef METAFILE
	return(inst_mfscr("mo", mf1scrn));
#else 
	return(0);
#endif /*METAFILE */
}
