/* @(#) mf_outpr.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_outpr.h
 * SCCS id :	mf_outpr.h 1.4
 * Last edited:	11/27/84 12:22:25
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *
 *	polyline
 *
 */
STATIC
Bool
m_pl(ws, n, nc)
Wss	*ws;
Size n;
Nc *nc;
{
	route_ndc(ws, M_PL, n, nc);
}

/*
 *
 *	polymarker
 *
 */
STATIC
Bool
m_pm(ws, n, nc)
Wss	*ws;
Size n;
Nc *nc;
{
	route_ndc(ws, M_PM, n, nc);
}

/*
 *
 *	text
 *
 */
STATIC
Bool m_tx(ws,nc,text)	/*	text	*/
Wss	*ws;
Nc *nc;
String text;
{
	Size n = 0;
	Size lrec;
	char *datrec, *drecloc;
	Int i;

	while (text[n] != '\0') n++;

	lrec = n*sizeof(char) + 2* RBYTE + IBYTE;
	CR_DATREC(datrec,lrec,TXT)
	drecloc = datrec;

	PUT_REAL(drecloc,nc->n_x)
	PUT_REAL(drecloc,nc->n_y)
	PUT_INT(drecloc,(Int)n)

	for (i = 0; i<n; i++){
		*drecloc = text[i];
		drecloc += sizeof(char);
	}
	route_item(ws, M_TX, lrec,datrec);

	FREE(datrec)
}

/*
 *
 *	fill area	
 *
 */
STATIC
Bool m_fa(ws, n, nc)	/*	fill area	*/
Wss	*ws;
Size n;
Nc *nc;
{
	route_ndc(ws, M_FA, n, nc);
}

/*
 *
 *	cell array	
 *
 */
STATIC
Bool m_ca(ws, p, q, r, nrow, ncol, ct)	/*	cell array	*/
Wss	*ws;
Nc	p, q, r;
Size nrow, ncol;
Cindex	*ct;
{
	Size lrec;
	char *datrec, *drecloc;

	Int i, j;
	Cindex *ctloc;

	lrec = 6*RBYTE + (2 + nrow*ncol)*IBYTE;

	CR_DATREC(datrec,lrec,CELL)
	drecloc = datrec;

	PUT_REAL(drecloc,p.n_x)
	PUT_REAL(drecloc,p.n_y)
	
	PUT_REAL(drecloc,q.n_x)
	PUT_REAL(drecloc,q.n_y)
	
	PUT_REAL(drecloc,r.n_x)
	PUT_REAL(drecloc,r.n_y)

	PUT_INT(drecloc,nrow)
	PUT_INT(drecloc,ncol)

	ctloc = ct;

	for (i = 0; i<nrow; i++)
	for (j = 0; j<ncol; j++) 
	{
		PUT_INT(drecloc,*ctloc)
		ctloc++;
	}
	route_item(ws, M_CA, lrec,datrec);

	FREE(datrec)
}
	
/*
 *
 *	general drawing primitive
 *
 */
STATIC
Bool m_gdp	()	/*	general drawing primitive	*/
{}
/*
 *	utility function to generate item data record for
 *	polyline/polymarker/fill area and route it to the
 *	Metafile
 */

route_ndc(ws, type, n, nc)
Wss	*ws;
Itmtp 	type;
Size n;
Nc *nc;
{
	Size lrec ;
	char *datrec, *drecloc;
	Int 	i;
	Nc	*pr;

	lrec = IBYTE + 2*n*RBYTE;

	CR_DATREC(datrec,lrec,POL)
	drecloc = datrec;
	
	PUT_INT(drecloc,(Int)n)

	pr = nc;

	for (i = 0; i<n; i++){
		PUT_REAL(drecloc,pr->n_x)
		PUT_REAL(drecloc,pr->n_y)
		pr++;
	}
	
	route_item(ws, type, lrec,datrec);

	FREE(datrec)
}
