/* @(#) mf_repr.h  version:1.5  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_repr.h
 * SCCS id :	mf_repr.h 1.5
 * Last edited:	11/27/84 12:22:33
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set polyline representation
 */
STATIC
Bool m_splr	(ws,i,lr)
Wss	*ws;
LineRep	*lr;
Bindex i;
{
	Size lrec;
	char *drecloc;

	lrec = 3*IBYTE + RBYTE; 

	drecloc = drecconst;

	PUT_INT(drecloc,(Int)i)
	PUT_INT(drecloc,(Int)lr->lr_lt)
	PUT_REAL(drecloc,(Real)lr->lr_lw)
	PUT_INT(drecloc,(Int)lr->lr_ci)

	route_item(ws,M_SPLR,lrec,drecconst);

}

/*
 *	set polymarker representation
 */
STATIC
Bool m_spmr	(ws,i,mr)
Wss	*ws;
MarkRep	*mr;
Bindex i;
{
	Size lrec;
	char *drecloc;

	lrec = 3*IBYTE + RBYTE; 

	drecloc = drecconst;

	PUT_INT(drecloc,(Int)i)
	PUT_INT(drecloc,(Int)mr->mr_mt)
	PUT_REAL(drecloc,(Real)mr->mr_ms)
	PUT_INT(drecloc,(Int)mr->mr_ci)

	route_item(ws,M_SPMR,lrec,drecconst);

}

/*
 *	set fill area representation
 */
STATIC 
Bool m_sfar	(ws,i,fa)
Wss	*ws;
AreaRep	*fa;
Bindex i;
{

	idata[0] = (Int)i;
	idata[1] = (Int)fa->fa_is;
	idata[2] = (Int)fa->fa_si;
	idata[3] = (Int)fa->fa_ci;
	
	write_irdata(ws,M_SFAR,idata,4,rdata,0);

}

/*
 *	set pattern representation
 */
STATIC 
Bool m_spar	(ws,bi,pr)
Wss	*ws;
PattRep	*pr;
Bindex bi;
{
	Size lrec;
	char *datrec, *drecloc;

	Int mr, nc, i, j;

	mr = pr->pa_m;
	nc = pr->pa_n;

	lrec = (mr*nc + 3)*IBYTE;

	CR_DATREC(datrec,lrec,S_PN_R)
	drecloc = datrec;

	PUT_INT(drecloc,(Int)bi)
	PUT_INT(drecloc,(Int)mr)
	PUT_INT(drecloc,(Int)nc)

	for (i = 0; i<mr; i++)
	for (j = 0; j<nc; j++) {
		PUT_INT(drecloc,(Int)pr->pa_ci[j + i*nc])
	}
	route_item(ws,M_SPAR,lrec,datrec);

	FREE(datrec)
}

/*
 *	set colour representation
 */
STATIC 
Bool	m_scr(ws,ci,cr)	
Wss	*ws;
Colour	*cr;
Cindex ci;
{
	idata[0] = (Int)ci;
	rdata[0] = (Real)cr->c_red;
	rdata[1] = (Real)cr->c_green;
	rdata[2] = (Real)cr->c_blue;

	write_irdata(ws,M_SCR,idata,1,rdata,3);

}

/*
 *	set text representation
 */
STATIC
Bool m_stxr	(ws,i,tr)	/*	set text representation	*/
Wss	*ws;
TextRep	*tr;
Bindex i;
{
	Size lrec;
	char *drecloc;

	lrec = 4*IBYTE + 2*RBYTE;

	drecloc = drecconst;
	
	PUT_INT(drecloc,(Int)i)
	PUT_INT(drecloc,(Int)tr->tx_fp.fp_fo)
	PUT_INT(drecloc,(Int)tr->tx_fp.fp_pr)
	PUT_REAL(drecloc,(Real)tr->tx_chef)
	PUT_REAL(drecloc,(Real)tr->tx_chsp)
	PUT_INT(drecloc,(Int)tr->tx_ci)

	route_item(ws,M_STXR,lrec,drecconst);

}
