/* @(#) mf_segfns.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_segfns.h
 * SCCS id :	mf_segfns.h 1.4
 * Last edited:	11/27/84 12:22:54
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	create segment
 */
STATIC
Bool m_crsg(ws,seg)
Wss *ws;
Segname seg;
{


	idata[0] = (Int)seg;

	write_irdata(ws,M_CRSG,idata,1,rdata,0);

}

/*
 *	close segment
 */
STATIC
Bool m_clsg	(ws)	
Wss	*ws;
{
	route_item(ws,M_CLSG,0,(char *)NULL);
}

/*
 *	rename segment
 */
STATIC
Bool m_rensg	(ws,old, new)
Wss	*ws;
Segname	old, new;
{


	idata[0] = (Int)old;
	idata[1] = (Int)new;

	write_irdata(ws,M_RENSG,idata,2,rdata,0);

}

/*
 *	delete segment
 */
STATIC
Bool m_dsg	(ws,seg)
Wss	*ws;
Segname	seg;
{


	idata[0] = (Int)seg;

	write_irdata(ws,M_DSG,idata,1,rdata,0);

}

/*
 *	set segment transformation
 */
STATIC
Bool m_ssgt	(ws,seg,mat)
Wss	*ws;
Segname	seg;
Tmat	*mat;
{
 
	Real a00, a01, a20, a10, a11, a21;
	Real *matloc;

	matloc = (Real *)mat;


	a00 = *matloc++;
	a10 = *matloc++;
	a20 = *matloc++;

	a01 = *matloc++;
	a11 = *matloc++;
	a21 = *matloc;

	idata[0] = (Int)seg;

	rdata[0] = a00;
	rdata[1] = a10;
	rdata[2] = a20;
	rdata[3] = a01;
	rdata[4] = a11;
	rdata[5] = a21;

	write_irdata(ws,M_SSGT,idata,1,rdata,6);

}

/*
 *	set segment visibility
 */
STATIC
Bool m_svis	(ws,seg,vis)
Wss	*ws;
Segname	seg;
Bool	vis;
{


	idata[0] = (Int)seg;
	idata[1] = (Int)vis;

	write_irdata(ws,M_SVIS,idata,2,rdata,0);

}

/*
 *	set segment highlighting
 */
STATIC
Bool m_shlit	(ws,seg,hlit)
Wss	*ws;
Segname	seg;
Bool	hlit;
{


	idata[0] = (Int)seg;
	idata[1] = (Int)hlit;

	write_irdata(ws,M_SHLIT,idata,2,rdata,0);

}

/*
 *	set segment priority
 */
STATIC
Bool m_ssgp	(ws,seg,pr)
Wss	*ws;
Segname	seg;
Segpri	pr;
{


	idata[0] = (Int)seg;
	rdata[0] = (Real)pr;

	write_irdata(ws,M_SSGP,idata,1,rdata,1);

}

/*
 *	set segment detectability
 */
STATIC
Bool m_sdtec	(ws,seg,dtec)
Wss	*ws;
Segname	seg;
Bool	dtec;
{


	idata[0] = (Int)seg;
	idata[1] = (Int)dtec;

	write_irdata(ws,M_SDTEC,idata,2,rdata,0);

}
