/* @(#) open_gks.c  version:1.10  dated:84/12/03 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.open_gks.c
 * SCCS id :	open_gks.c 1.10
 * Last edited:	12/1/84 00:31:45
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS 1
/*#define SHOWSD /*define if you want to check contents of wsd's ;
		  *this option leads to the inclusion of the 
		  *function showwsd() on file showwsd.h 
		  *that prints wsd contents on file msgf
		  */

#include "cgksincl.h"
#include "open_gksi.h"

/*VARARGS3*/
Gks *open_gks(erh, era, s, msgfile)
Ercode	(*erh)();
Erarea	*era;
Size	s;
String	msgfile; /*optional 4th parameter*/
{
	Gks	*gks;
	Int	i, erc;

	MALLOC(gkse, Gkse, sizeof(Gkse), O_GKS)
	/*gks error statelist*/
	gkse->ge_erh = erh; /*may be NULL */
	gkse->ge_erstate = FALSE;

	if (msgfile != NULL) {
		if (strlen(msgfile) == 0 ||
		    open_msgfile(msgfile) == FALSE) {
			rep_er(200);
			return(NULL);
		}
	}
	/*Temporary test file for debugging. 
	 *to use instead of stderr, that may disturb screen.
	 *For code of open_msgfile() see er_handi.h.
	 */

	if (ch_state(1, O_GKS) != 0) return(NULL);
	gkstate = GKOP;

	MALLOC(gksd, Gksd, sizeof(Gksd), O_GKS)
	gksd_init(gksd);

	MALLOC(gks, Gks, sizeof(Gks), O_GKS)
	gkss_init(gks);

	CALLOC(gksis->gki_wsd, Wsd *, gksd->gd_nrwt, O_GKS)
#ifdef SHOWSD
	out_msg("ws description tables installed for ");
#endif
	for (i = 0; i < gksd->gd_nrwt; i++) {
		if (wsd_creat(&(gksis->gki_wsd[i]), gksd->gd_avwt[i]) 
			!= 0) return(NULL);
#ifdef SHOWSD
		showwsd(gksis->gki_wsd[i],i);
		out_msg("%s", gksd->gd_avwt[i]);
#endif
	}

	_gkss = gks;/*gkss is gkss statelist ptr in use by the system;
		    *user gets his own pointer via returned value
		    */
	return(gks);
}

close_gks()
{	Ch_State(2, C_GKS);

	gkstate = GKCL;
	free_gkslists(); /*code in u_free.c */
	rm_msgfile(); /*code in u_free.c*/
	return(0);
}
