/* @(#) open_gksi.h  version:1.16  dated:84/12/03 */
/*
 * SCCS file:	SCCS/s.open_gksi.h
 * SCCS id :	open_gksi.h 1.16
 * Last edited:	12/3/84 11:29:24
 */

/* the following file contains the global description table values*/
#include "cgksgksd.h"


extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gkse	*gkse;
extern	Gksd	*gksd;
extern	Gksi	*gksis;
extern	Int	_gksfun;

Wrect	wr = {0.0,0.0,1.0,1.0};
static	Nrect nr = {0.0,0.0,1.0,1.0};

Bool	open_msgfile();

/*
 *Global_state error checking.
 *
 *This function also sets the global _gksfun to 
 *the integer identifying the GKS routine.
 */
int
ch_state(erc, rout)
Ercode erc;
Int rout;
{
	_gksfun  = rout - 100;

	switch(erc) {
	case 1:	if(gkstate == GKCL) return(0);
		break;
	case 2:	if(gkstate == GKOP)  return(0);
		break;
	case 3:	if(gkstate == WSAC)  return(0);
		break;
	case 4:	if(gkstate == SGOP)  return(0);
		break;
	case 5:	if(gkstate == WSAC || gkstate == SGOP)  return(0);
		break;
	case 6:	if(gkstate == WSOP || gkstate == WSAC)  return(0);
		break;
	case 7:	if(gkstate != GKOP && gkstate != GKCL)  return(0);
		break;
	case 8:	if(gkstate != GKCL)  return(0);
		break;
	}
	rep_er(erc, rout);
	return(erc);
}

/*
 * set the global variable _gksfun back to 0 when
 * leaving the GKS function:
 */
gksfun_ret()
{
	_gksfun = 0;
}

/*gksd_init() inits global description table.
* values are macros from file cgksgksd.h.
 *In the future this table must be filled in the same 
 *way as the wsd's: by reading a file
 */
gksd_init(gkd)
Gksd *gkd;
{	
	gkd->gd_lev.op_lev = OP_LEV;
	gkd->gd_lev.ip_lev = IP_LEV;
	gkd->gd_nopws = NOPWS;
	gkd->gd_nactv = NACTV;
	gkd->gd_nwsas = NWSAS;
	gkd->gd_nntran = NNTRAN;

	inst_avwt(gkd); /* code of this fun in file cgks_ws.c */
}

/*gkss_init() initializes the global statelist
 */
gkss_init(gks)
register Gks *gks;
{
	Int i;

	MALLOC(gksis, Gksi, sizeof(Gksi), O_GKS)

	CALLOC(gks->gk_opws, Wss *, (gksd->gd_nopws + 1), O_GKS)
	CALLOC(gks->gk_actv, Wss *, (gksd->gd_nactv + 1), O_GKS)
	/* 
	 * at both calloc()'s 1 is added to be sure at least 1 pointer
	 * (the last, unused, one) is always NULL
	 */
	/*
	 * according to the UNIX manual the space is supposed to
	 * be filled with zeros ( see malloc(3) )
	 */

	gks->gk_patref.w_x = gks->gk_patref.w_y = 0.0;
	gks->gk_patsiz.w_x = gks->gk_patsiz.w_y = 1.0;
	for (i = 0; i< gksd->gd_nopws; i++)
		gks->gk_opws[i] = gks->gk_actv[i] = NULL;

	CALLOC(gks->gk_ntran, Ntran *, gksd->gd_nntran, O_GKS)

	for (i = 0; i< gksd->gd_nntran; i++){
		MALLOC(gks->gk_ntran[i], Ntran, sizeof(Ntran), O_GKS)
		ASS(gks->gk_ntran[i]->nt_wind , wr)
		ASS(gks->gk_ntran[i]->nt_view , nr)
	}

	gks->gk_curnt= gks->gk_ntran[0];
	CALLOC(gksis->gki_ntp, Int, gksd->gd_nntran, O_GKS)
	for (i = 0; i < gksd->gd_nntran; i++) gksis->gki_ntp[i] = i;
	gks->gk_clip = TRUE;

	s_idmatrix((Real *)(&(gksis->gki_mat[0][0])));

	gks->gk_asf = 00;

	gks->gk_line = gks->gk_lrlt = gks->gk_lrci = 1;
	gks->gk_lrlw = 1.0;

	gks->gk_mark = gks->gk_mrci = 1;	
	gks->gk_mrmt = 3;
	gks->gk_mrms = 1.0;

	gks->gk_text = gks->gk_txci = 1;
	gks->gk_txfp.fp_fo = 1;
	gks->gk_txfp.fp_pr = STR;
	gks->gk_chef = 1.0;
	gks->gk_chsp = 0.0;
	gks->gk_chht = 0.01;
	gks->gk_chup.w_x = 0.0;
	gks->gk_chup.w_y = 1.0;
	gks->gk_path = RIGHT;
	gks->gk_txal.ta_hor = ALEFT;
	gks->gk_txal.ta_ver = BASE;

	gks->gk_area = gks->gk_fasi =	gks->gk_faci = 1;
	gks->gk_fais = HOLLOW;
	gks->gk_pikid = 0;

	gks->gk_segs = NULL;
}




#ifdef SHOWSD
#include "showwsd.h"
#endif
