/* @(#) open_ws.c  version:1.9  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.open_ws.c
 * SCCS id :	open_ws.c 1.9
 * Last edited:	11/15/84 13:25:38
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS 1

#include "cgksincl.h"

extern GksState	gkstate;
extern Gks	*_gkss;
extern Gksi	*gksis;
extern Gksd	*gksd;

#include "open_wsi.h"

Wss *
open_ws(ifile, ofile, wstype)
File	*ifile, *ofile; /*connection id's*/
int	(* wstype)();
{	Wss	*ws;
	Int	wscat;
	Int	i, typenr;

	if (ch_state(8, O_WS) != 0) return(NULL);

	if (gkstate == GKOP) gkstate = WSOP;

	MALLOC(ws, Wss, sizeof(Wss), O_WS)

	/* wstype() installs Screen pointer in wsd*/
	if ((typenr = (*wstype)()) == 0) {
		rep_er(23, O_WS);
		return(NULL);
	}
	else	ws->ws_wsd = gksis->gki_wsd[typenr - 1]; 

	wscat = ws->ws_wsd->wd_cat;

	if (ifile != NULL)    ws->ws_ifile = ifile;
	else if (wscat != MI) ws->ws_ifile = stdin;
	else {
		rep_er(21, O_WS); /* need a filepointer for MI */
		return(NULL);
	}	

	if (ofile != NULL)    ws->ws_ofile = ofile;
	else if (wscat != MO) ws->ws_ofile = stdout;
	else {
		rep_er(21, O_WS); /* need a filepointer for MO */
		return(NULL);
	}

	for (i = 0; i < gksd->gd_nopws; i++) 
		if (_gkss->gk_opws[i] == 0) break;

	if (i == gksd->gd_nopws) {
		rep_er(24, O_WS);
		return(NULL);
		/*wrong error message. however 
		 *no other message available
		 */
	}
	_gkss->gk_opws[i] = ws;
	/* later on the index i of the place in gk_opws[] that contains
	 * ws can change in case other workstations are closed (see
	 * close_ws() )
	 */

	wssfromwsd(ws);
	wssinit(ws);

	if (wscat != WISS && wscat != MI && wscat != MO) {
		/*need a driver for WISS , MO, MI? */
		if (WsScrn->s_tera)	(*WsScrn->s_tera)(ws);
	}
#ifdef METAFILE
	if (wscat == MO){
		(*MfScrn->m_hdr) (ws); /* metafile header */
		(*MfScrn->m_clrwk) (ws,FALSE); /* clear ws, if necessary*/
	}
	if (wscat == MI) {
		pmi_hdr(ws); /* is mi_hdr(ws); get metafile header */
	}
#endif
	return(ws);
}

close_ws(ws)
Wss *ws;
{
	Int	i = 0, wscat = ws->ws_wsd->wd_cat;

	Ch_State(7, C_WS);
	if (ws->ws_actv == TRUE) Rep_Er(29, C_WS)

	while (i < gksd->gd_nopws && _gkss->gk_opws[i] != ws) i++;
	/*if (i < gksd->gd_nopws) _gkss->gk_opws[i] = NULL;*/
	if (i == gksd->gd_nopws) Rep_Er(25, C_WS)

	/*
	 * now shift remaining open workstations to the 'left' :
	 * (the code presumes that the last index is always NULL)
	 */
	do {
		_gkss->gk_opws[i] = _gkss->gk_opws[i + 1]; 
	} while (_gkss->gk_opws[i++] != NULL);

	if (wscat != WISS && wscat != MO && wscat != MI) {
/*
 *not necessary for MO?
 */
		s_curw(ws);
		s_curv(ws);
		mark_ws(ws, WS_MAT);

		/* part of update ws:*/
		if (ws->ws_ofile != NULL)
			fflush(ws->ws_ofile);
	}
	
	/*free all entries of ws gained with [mc]alloc() */
	free_wss(ws);

	if (_gkss->gk_opws[0] == NULL) gkstate = GKOP;

	if (wscat != WISS && wscat != MO && wscat != MI) {
		if (WsScrn->s_clos) (*WsScrn->s_clos)(ws);
	}
#ifdef METAFILE
	if (wscat == MO) {
	(*MfScrn->m_clwk)(ws); /* route end item to metafile */
}
#endif

	FREE(ws)
	return(0);
}
