/* @(#) open_wsi.h  version:1.14.1.1  dated:85/01/11 */
/*
 * SCCS file:	SCCS/s.open_wsi.h
 * SCCS id :	open_wsi.h 1.14.1.1
 * Last edited:	1/11/85 12:45:46
 */

Bool	fr_segi();

/*Pointers to functions ws_pline(), ws_pmark() etc. See u_defacts.c*/
Fun	pws_pline	= NULL;
Fun	pws_pmark	= NULL;
Fun	pws_farea	= NULL;
Fun	pws_text	= NULL;
Fun	pws_cells	= NULL;
Fun	pws_gdp		= NULL;

#ifdef METAFILE
/* pointer to function mi_hdr(). see mi_drive.c */
Fun	pmi_hdr	= NULL;
#endif

static Nrect nr = {0.0, 0.0, 1.0, 1.0};

Tmat 	u_mat = {1.0, 0.0, 0.0, 0.0, 1.0, 0.0 };

/*
 *ch_er_ws() checks (some of) the errors concerning the ws type.
 */
Int
ch_er_ws(ws, erc, rout)
Wss	*ws;
Ercode	erc;
Int	rout;
{
	/*prevent double checking on 25 for case 3, 4, 5*/
	Int	i = 0;

	/*25; no checking on 25 for open_ws() */
	if (rout != O_WS) {
		while (i < gksd->gd_nopws && _gkss->gk_opws[i] != ws)
			i++;
		if (i == gksd->gd_nopws) {
			rep_er(25, rout);
			return(25);
		}
	}

	switch(erc) {
	case 0: /*only 25*/
		return(0);
		break;
	case 1: /*27*/
		if (ch_27(rout) == 0) return(0);
		break;
	case 2: /*33, 35*/
		if(ws->ws_wsd->wd_cat != MI &&
			ws->ws_wsd->wd_cat != INPUT) return(0);
		break;
	case 3: /*33, 35, 36*/
		if(ws->ws_wsd->wd_cat == WISS) break;
		return(ch_er_ws(ws, 2, rout));
	case 4: /*27, 33, 35*/
		if(ch_27(rout) == 0)
			return(ch_er_ws(ws, 2, rout));
		break;
	case 5: /*27, 33, 35, 36*/
		if (ch_27(rout) == 0)
			return(ch_er_ws(ws, 3, rout));
		break;
	case 6: /*34*/
		if(ws->ws_wsd->wd_cat == MI) return(0);
		break;
	case 7: /*38*/
		if (ws->ws_wsd->wd_cat != INPUT &&
		    ws->ws_wsd->wd_cat != OUTIN) break;
		return(0);
	case 8: /*30, 32*/
		if(ws->ws_actv == TRUE && ws->ws_wsd->wd_cat == MO)
			return(0);
		break;
	}
	rep_er(erc + WS_ER_OFF, rout);
	return(erc + 41);
}

/*a check on GKS error 27 */
int
ch_27(rout)
Int rout;
{
	int i = 0;

	while (_gkss->gk_opws[i] != NULL) {
		if (_gkss->gk_opws[i++]->ws_wsd->wd_cat == WISS) {
			return(0);
		}
	}
	return(27);
}

/*take the contents for the ws statelist from the ws descr. table.
 *(as far as possible)
 */
wssfromwsd(ws)
register Wss	*ws;
{
	/*fill ws with wsd dependent code: */
	register	Wsd	*wsd = ws->ws_wsd;
	register 	Int i;
	Int	ii, k, wscat = wsd->wd_cat;
	Size	sz;
	Idevice	*idev;
	Colour	*colptr, col0;

	if (wscat == MO) {
		;
	}

	if (wscat == OUTPUT || wscat == OUTIN) {
		ws->ws_defr = wsd->wd_defr;
		ws->ws_waitr = wsd->wd_waitr;
		ASS(ws->ws_reqv , wsd->wd_maxsurf)
		s_curv(ws);

		ws->ws_nline = wsd->wd_nline;
		CALLOC(ws->ws_line, LineRep, ws->ws_nline, O_WS)
		for(i = 0; i<ws->ws_nline; i++) 
			ASS(ws->ws_line[i] , wsd->wd_line[i])

		ws->ws_nmark = wsd->wd_nmark;
		CALLOC(ws->ws_mark, MarkRep, ws->ws_nmark, O_WS)
		for (i = 0; i<ws->ws_nmark; i++)
			ASS(ws->ws_mark[i] , wsd->wd_mark[i])

		ws->ws_ntext = wsd->wd_ntext;
		CALLOC(ws->ws_text, TextRep, ws->ws_ntext, O_WS)
		for(i = 0; i<ws->ws_ntext; i++)
			ASS(ws->ws_text[i] , wsd->wd_text[i])

		ws->ws_narea = wsd->wd_narea;
		CALLOC(ws->ws_area, AreaRep, ws->ws_narea, O_WS)
		for(i = 0; i<ws->ws_narea; i++)
			ASS(ws->ws_area[i] , wsd->wd_area[i])

/*not yet complete:*/
		ws->ws_npatt = wsd->wd_npatt;
		if (ws->ws_npatt != 0) {
			CALLOC(ws->ws_patt, PattRep, ws->ws_npatt, O_WS)
		}
		for(i = 0; i<ws->ws_npatt; i++) {
			ASS(ws->ws_patt[i] , wsd->wd_patt[i])
			/*also copy pattern array!*/
			/*it is not possible to just copy the
			 *address of wsd->wd_patt[i] as you may change
			 *the contents of pattern i
			 */
		}

		ws->ws_ncolr = wsd->wd_ncix;
		CALLOC(ws->ws_colr, Colour, ws->ws_ncolr, O_WS)
		colptr = &(ws->ws_colr[0]);
		col0.c_red = col0.c_green = col0.c_blue = 0.0;
		for(i = 0; i < ws->ws_ncolr; i++){
			ASS(*colptr, col0)
			colptr++;
		}
		ws->ws_colr[1].c_red = 1.0;
	}
	
	if (wscat == INPUT || wscat == OUTIN) {
	 for (ii = 0; ii < 6; ii++) {
	  CALLOC(ws->ws_devs[ii], Idevice, wsd->wd_ndevs[ii], O_WS)
	  for ( k = 0; k < wsd->wd_ndevs[ii]; k++){
		idev = &(ws->ws_devs[ii] [k]);
		idev->id_clas = (Iclass)ii;
		idev->id_mode = REQUEST;
		idev->id_echo = TRUE;
		idev->id_pet  = 1;
		ASS(idev->id_area ,
			wsd->wd_ddesc[ii] [k].idd_idev.id_area)
		switch (ii) {
		case 0:
		   idev->id_ival.ev_loc.loc_nt = _gkss->gk_ntran[0];
		   ASS(idev->id_ival.ev_loc.loc_pt ,
		   wsd->wd_ddesc[ii] [k].idd_idev.id_ival.ev_loc.loc_pt)
		   break;
		case 1:
		   break;
		case 2:
		   idev->id_ival.ev_val = 
		     wsd->wd_ddesc[ii] [k].idd_idev.id_ival.ev_val;
		   ASS(idev->id_drec , 
			wsd->wd_ddesc[ii] [k].idd_idev.id_drec)
		case 3:
		   idev->id_ival.ev_cho = 0; break;
		case 4:
		   break;
		case 5:
		   ASS(idev->id_drec,
			wsd->wd_ddesc[ii] [k].idd_idev.id_drec)
		   sz = idev->id_drec.str_rec.str_size; 
		   MALLOC(idev->id_ival.ev_str, char,(Int)sz, O_WS)
		   idev->id_ival.ev_str[0] = '\0'; 
		   break;
		}
	   }
	 }
	}/*end cat*/
}

/*initialize the ws statelist*/
wssinit(ws)
register Wss	*ws;
{	Int 	wscat = ws->ws_wsd->wd_cat;

	ws->ws_actv = FALSE;
	ws->ws_segs = NULL;

	if (wscat == OUTPUT || wscat == OUTIN || wscat == MO) {
		ws->ws_empty = TRUE;
		ws->ws_newfr = ws->ws_trupd = FALSE;
		ASS(ws->ws_reqw , nr)
		s_curw(ws);
	}
	if (wscat == OUTPUT || wscat == OUTIN ||
	    wscat == MO || wscat == MI) {
		/*no need for (part of) wsis on WISS ?*/
		/*no need for (part of) wsis on INPUT ?*/
		/*need for (part of) wsis on MO */
		MALLOC(ws->ws_wsis, Wsis, sizeof(Wsis), O_WS)
		wsisinit(ws);
	}
}

/*initialize the ws initernal statelist*/
wsisinit(ws)
Wss	*ws;
{
	Wsis *wis = ws->ws_wsis;
/*
*	code added by Miente
*/
	if (ws->ws_wsd->wd_cat == MO ||
	    ws->ws_wsd->wd_cat == MI ) {
		;
/*
 *	allocation of space for the Metafile header field;
 *	this allocation was forgotten in the previous version
 */
#ifdef METAFILE
		MALLOC(wis->wi_mfhdr,Mfhdr,sizeof(Mfhdr),O_WS)
#endif
	}

	if (ws->ws_wsd->wd_cat == MI) {;
#ifdef METAFILE
/*
*		allocation of space and initialization of
*		some fields only relevant to MI workstations
*/
		MALLOC(wis->wi_gkss,Gks,sizeof(Gks),O_WS)
		MALLOC(wis->wi_gksis,Gksi,sizeof(Gksi),O_WS)
		MALLOC(wis->wi_item,Item,sizeof(Item),O_WS)

		ASS(*(wis->wi_gkss),*_gkss)
		ASS(*(wis->wi_gksis),*gksis)

#endif
/*
*	end code added by Miente
*/
	}
	else { /* wscat != MI */
		wis->wi_attm = 000;
		/* take the  reps with index 1,
		 * or take the current values via the _gkss 
		 */
		ASS(wis->wi_lrep , *ws->ws_line)
		ASS(wis->wi_mrep , *ws->ws_mark)
		ASS(wis->wi_frep , *ws->ws_area)
		ASS(wis->wi_trep , *ws->ws_text)
		wis->wi_prep = ws->ws_patt;

		mark_ws(ws, WS_MAT);
		mark_ws(ws, WS_CLP);
		mark_ws(ws, WS_CHV);
		mark_ws(ws, WS_CWV);
		wis->wi_sgmat = (Tmat *)(&u_mat[0][0]);
	}
}

/*mark_ws() marks that the attribute indicated with typ
 *is subject to the attribute_lazy_evalution_mechanism
 */
mark_ws(ws, typ)
Wss *ws;
Int typ;
{	if (ws->ws_wsd->wd_cat != WISS &&	
	    ws->ws_wsd->wd_cat != MI)
		ws->ws_wsis->wi_attm |= typ;
}

msk_openws(typ)
Int typ;
{
	Int	i = 0;
	Wss	*ws;

	while ((ws = _gkss->gk_opws[i++]) != NULL) {
		if (ws->ws_wsd->wd_cat != WISS &&
		    ws->ws_wsd->wd_cat != MI) {
			mark_ws(ws, typ);
		}
	}
}

ws_trupdate(ws)
Wss	*ws;
{
	if (ws->ws_trupd == TRUE) {
		s_curw(ws);
		s_curv(ws);
		mark_ws(ws, WS_MAT);
		mark_ws(ws, WS_CLP);
		ws->ws_trupd == FALSE;
	}
}

s_curw(ws)
Wss	*ws;
{
	ASS(ws->ws_curw, ws->ws_reqw)
	/*here driver call to install new window */
}

s_curv(ws)
Wss	*ws;
{
	ASS(ws->ws_curv, ws->ws_reqv)
	/*here driver call to install new viewport on device*/
}


