/* @(#) pxl_arr.c  version:1.7  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pxl_arr.c
 * SCCS id :	pxl_arr.c 1.7
 * Last edited:	10/19/84 13:55:08
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * This file contains an inquiry function that is not
 * implemented as a macro
 */

#define GKS8

#include "cgksincl.h"

/*INQUIRE PIXEL ARRAY*/
Bool
pxl_arr(ws, p, sz, inv, arr)
Wss 	*ws;
Wc	*p;
ArrSiz	*sz;
Bool	*inv;
Cindex	*arr;
{	Screen	*scr = WsScrn;
	Nc	nc;
	Dc	dc;
	int 	ulx, uly;

	if (ch_state(7, IQU_PA) != 0)  return(FALSE);

	if (scr->s_ipix == NULL) {
		rep_er(40, IQU_PA);
		return(FALSE);
	}
	ensure(IQU_PA);
	ws_ensure(ws, IQU_PA);

	ntransf(p, &nc); 
	ws_transf(ws, &nc, &dc); 
	ulx = dc.d_x;
	uly = dc.d_y;

	/*if dc.d_y lies on an exact pixel boundary uly is taken 1 less.
	 *This is done to be compatible with cellarray():
	 *a cellarray from (0.0, 0.0) to (10.0, 10.0) with n = m = 10
	 *will map on pixels from (0,0) to (9,9). (10 by 10)
	 *So at cellarray upper left (0.0, 10.0) maps to pixel (0,9).
	 */
	if (fabs (uly - dc.d_y) < 1.0e-4) uly -= 1;

	if (uly < 0 ||
	    uly - (int)sz->as_ysz + 1 > (int)WsScrn->s_size.i_y ||
	    ulx + (int)sz->as_xsz - 1 < 0 ||
	    ulx > (int)WsScrn->s_size.i_x) {
		return(FALSE); /*no pixel on device*/
	}

	(*scr->s_ipix)(ws, ulx, uly, sz->as_xsz, sz->as_ysz, &inv, arr);
	return(TRUE);
}
