/* @(#) req_loc.c  version:1.14  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_loc.c
 * SCCS id :	req_loc.c 1.14
 * Last edited:	11/7/84 09:18:00
 *
 * Authors:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

#define BREAK '\0'

Int	gt_loc_ntran();
Bool	ic_in_drect();

extern	Gksd	*gksd;
extern	Gks	*_gkss;
extern	Gksi	*gksis;

#include "req_loci.h"

/* REQUEST LOCATOR */
Bool
req_loc(ws,dn,val)
Wss	*ws;
Devno	dn;
Locate	*val; 
{
	register Idevice *idev;
	Ic	ic0, ic;
	Nc	nc;
	Dc	dc;
	Wc	wc;
	Drect	wsview;
	Bool	no_brk;
	Int	j;
	Tmat	iwsmat, mat;
	Pet	pet;
	Locate	*in_loc;
	
	if (ch_state(7, RQ_LOC) != 0) return(FALSE);
	if (ch_er_ws(ws, 7, RQ_LOC) != 0) return(FALSE);

	if (ch_devno(ws, LOCATOR, dn, RQ_LOC) != 0) return(FALSE);

	idev = &(ws->ws_devs[0] [dn - 1]);
	in_loc = &(idev->id_ival.ev_loc);

	if (idev->id_mode != REQUEST) {
		rep_er(141, RQ_LOC);
		return(FALSE);
	}

	ensure(RQ_LOC);
	ws_ensure(ws, RQ_LOC);

	ASS(wsview.d_ll , ws->ws_curv.d_ll)
	ws_transf(ws, &ws->ws_curw.n_ur, &wsview.d_ur);
	/* wsview is (part of) current ws viewport into which the
	 * current ws window is mapped by ws transformation.
	 */

#ifndef	HIGH_INPUT
	invers_mat(ws->ws_wsis->wi_mat, &iwsmat[0][0], RQ_LOC);

	if (idev->id_drec.loc_rec.loc_col != 0) /*bg colour*/
		show_l_pet(ws, idev);

	switch(idev->id_pet) {
	case (1):
	case (2):
	default :
		pet = idev->id_pet ;
		/* ic contains initial locator position
		 * transformed to screen coordinates via loc_nt :
		 */
		set_mat((Real *)(&in_loc->loc_nt->nt_wind),
			(Real *)(&in_loc->loc_nt->nt_view),
			&mat[0][0], FALSE);
		nc.n_x = in_loc->loc_pt.w_x * mat[0][0] + mat[0][2];
		nc.n_y = in_loc->loc_pt.w_y * mat[1][1] + mat[1][2];
		ws_transf(ws, &nc, &dc);
		ic0.i_x = dc.d_x;
		ic0.i_y = dc.d_y;

		do {
			ASS(ic, ic0)
			no_brk = (Bool)((*WsScrn->s_inpc)
				(ws, &ic, pet, in_loc) != BREAK);
		} while (no_brk == TRUE &&
			 ic_in_drect(&wsview, &ic) == FALSE);
		/*
		 * The 4th parameter in s_inpc() is new.
		 *
		 * It is nowhere stated that the returned location has
		 * to be inside the echo area, so no check on that.
		 *
		 * However, 
		 * the locator position must be within that part of the
		 * current ws viewport into which the current ws window
		 * is mapped. (Enderle 273) 
		 */

		break;
	}

	if (no_brk == TRUE) {
		TRANS(iwsmat,(Real)ic.i_x,(Real)ic.i_y,nc.n_x,nc.n_y)
		j = gt_loc_ntran(&nc);
		val->loc_nt = _gkss->gk_ntran[j];

		if (j != 0) {
		    setinvnmat(val->loc_nt);
		    TRANS(gksis->gki_imat,nc.n_x,nc.n_y, wc.w_x, wc.w_y)
		    ASS(val->loc_pt , wc)
		}
		else { /* wc = nc */
		    val->loc_pt.w_x = nc.n_x;
		    val->loc_pt.w_y = nc.n_y;
		}

	}

	/*fade_l_pet(ws, idev);*/
	return (no_brk);

#else
/*
 * high level driver available;
 * all input done on device
 */
	return( (Bool)(*WsScrn->s_gtlc)(ws, devno, REQUEST, val) );
#endif
}
