/* @(#) req_pik.c  version:1.7  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_pik.c
 * SCCS id :	req_pik.c 1.7
 * Last edited:	10/19/84 13:54:05
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS2
#define GKS3
#define GKS4
#define GKS5
#define GKS6
#define GKS 6

#include "cgksincl.h"

Bool	nc_in_nrect();
Bool	ic_in_drect();

extern	Gks  *_gkss;

static	Real maxdist = 0.02;
/*
#define MAXDEV 0.018
*/
#define	BREAK	'\0'

#include "req_piki.h"

/* REQUEST PICK */
/*a returned Bool value of FALSE means NONE*/
/*a returned Bool value of TRUE and  val->pik_seg == 0 means NOPICK*/
/*a returned Bool value of TRUE and  val->pik_seg != 0 means OK*/

Bool
req_pik(ws,dn,val)
Wss	*ws;
Devno	dn;
Pick	*val; 
{	register Idevice *idev;
	Ic	ic;
	Nc	nc;
	Dc	dc;
	Bool	inwwindow = FALSE, no_br = TRUE, found;
	Tmat	inversmat;
	
	if (ch_state(7, RQ_PCK) != 0) return(FALSE);
	if (ws->ws_wsd->wd_cat != OUTIN) {
		rep_er(37, RQ_PCK);
		return(FALSE);
	}

	if (ch_devno(ws, PICK, dn, RQ_PCK) != 0) return(FALSE);
	idev = &(ws->ws_devs[(Int)PICK] [dn - 1]);
	if (idev->id_mode != REQUEST) {
		rep_er(141, RQ_PCK);
		return(FALSE);
	}

	ensure(RQ_PCK);
	ws_ensure(ws, RQ_PCK);

	invers_mat(ws->ws_wsis->wi_mat, &inversmat[0][0], RQ_PCK);
	/*if (idev->id_echo) show_p_area(ws, idev);*/
	switch(idev->id_pet) {
	case (1):
	default :
		while (inwwindow == FALSE) {
			if ((*WsScrn->s_inpc)(ws, &ic, 0) == BREAK) {
				no_br = FALSE;
				break;
			}
			dc.d_x = (Real)ic.i_x;
			dc.d_y = (Real)ic.i_y;
			TRANS(inversmat, dc.d_x, dc.d_y, nc.n_x, nc.n_y)

			/*first check if position inside window*/
			inwwindow = nc_in_nrect(&(ws->ws_curw), &nc);

		}

		if (no_br == TRUE &&
		    ic_in_drect(&idev->id_area, &ic) == TRUE) {
			maxdist = idev->id_drec.pik_rec.pik_rat *
		  	 (ws->ws_curw.n_ur.n_x - ws->ws_curw.n_ll.n_x);
			val->pik_seg = NULL;
			found = get_pick(ws, val, &nc);
		}
		break;
	}

	if (no_br == FALSE)	return(FALSE);		/*NONE*/	
	else {
		if (found == TRUE) { 			/*OK*/
			if (idev->id_echo == TRUE) {
				switch(idev->id_pet) {
				case (1):
				default:
					hili(ws, nr_hili, nc_hili);
				break;
				}
			}
		}
		else ;					/*NO PICK*/

		return(TRUE);
	}
}
