/* @(#) req_piki.h  version:1.4  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.req_piki.h
 * SCCS id :	req_piki.h 1.4
 * Last edited:	10/19/84 13:53:53
 */

/*
 * At this moment as soon as a primitive in a segment is met
 * that is near enough the pick position pikfound becomes TRUE.
 * However in the remaining part of the segment another primitive
 * with a different pickid may as well be near enough, or even closer.
 * Therefore the remaining part of the segment must be checked as well.
 */

Bool unit_mat();
Bool p_at_q();
Bool p_at_line();
Bool near_pl();
Bool near_pm();
Bool near_tx();
Bool near_fa();
Bool near_gd();
Bool near_ca();
Bool in_txtrect();
Nc   *nc_trans();
Nc   *clp_dots();

static	Int	ncsize;
static	Bool	pikfound;
static	Int	nr_hili;
static	Nc	*nc_hili;

Bool
get_pick(ws, val, nc) /*inspect all visible segments on ws*/
Wss	*ws;
Pick	*val;
Nc	*nc;
{
	Seginst *segi = ws->ws_segs;
	Seg	*seg;

	pikfound = FALSE;

	if (segi != NULL) {
	   ncsize = sizeof(Nc);
	   while (segi->si_next != NULL)
		segi = segi->si_next;
	   /*now segi is Seginst with highest prio*/

	   while (pikfound == FALSE && segi != NULL) {
		seg = segi->si_this;
		if (seg->sg_vis == TRUE && seg->sg_det == TRUE) {
		    	find_pik(ws, seg, val, nc);
		}
		if (pikfound == FALSE)	segi = segi->si_prev;
		else  {
			val->pik_seg = seg;
		}
	   }
	}
	return(pikfound);
}

find_pik(ws, seg, val, nc) /*inspect segment named seg */
Wss	*ws;
Seg	*seg;
Pick	*val;
Nc	*nc;
{	
	register Bhead *bh = seg->sg_firstbh;
	Int	n, nr_pik;
	Nc	nctr, *ncpik, *nc_sgtr;
	Nrect	nclipw, nrect_hili;
	Pickid	curpikid;
	Bool	touched  = FALSE;

	if (unit_mat(&seg->sg_mat[0][0]) == TRUE) ASS(nctr, *nc)
	else {
		Tmat	inversmat;
		invers_mat(seg->sg_mat, &inversmat[0][0], RQ_PCK);
		TRANS(inversmat, nc->n_x, nc->n_y, nctr.n_x, nctr.n_y)
	}

	while (bh != NULL) {
		switch(bh->sb_typ){
	   	case SG_CLP:
			Concat(&nclipw, &(ws->ws_curw), (Nrect *)(bh+1))
			break;
		case SG_PID:
			curpikid = *((Pickid *)(bh + 1));
			break;
		case POL:
			n = bh->sb_sz / ncsize; 
			touched = near_pl(n, (Nc *)(bh + 1), &nctr);
			break;
		case (POM):
			n = bh->sb_sz / ncsize; 
			touched = near_pm(n, (Nc *)(bh + 1), &nctr);
			break;
		case (TXT):
			/*Calculate text ext rectangle in Nc, and then:
			 *touched = in_txtrect(ncter, &nctr);
			 *As there is no text ext rect in segment
			 *at this moment only pickable at textposition
			 */
			n = 1;
			touched = near_tx((Nc *)(bh + 1), &nctr);

			/* currently text() caused 2 blocks to be
			 * stored in the segment. Therefore
			 * skip the segment block with the string:
			 */
			bh = bh->sb_link;

			break;
		case (FAR):
			n = bh->sb_sz / ncsize; 
			touched = near_fa(n, (Nc *)(bh + 1), &nctr) ;
			break;
		case (CELL):
			/*
			touched = near_ca( &nctr) ;
			*/
			break;
		case (GDP):
			/*
			touched = near_gd( &nctr) ;
			*/
			break;
		default: /*not an output bundle; however still */
			/*to add: save FAR style index*/
			/*        etc*/
			break;
		}
		if (touched == TRUE){
			nr_pik = n;
			ncpik = (Nc *)(bh + 1);
			ASS(nrect_hili , nclipw)
			val->pik_pid = curpikid;
			pikfound = TRUE;
			touched = FALSE;
		}
		bh = bh->sb_link;
	}

	if (pikfound == TRUE) {
		/*transform positions of primitive by segment transf*/
		nc_sgtr = nc_trans(&seg->sg_mat[0][0], ncpik,
				    nr_pik, RQ_PCK);
		/*clip positions against clip rectangle */
		nc_hili =
		   clp_dots(&nrect_hili, &nr_hili, nr_pik, nc_sgtr);
		/*now nr_hili positions pointed to by
		 *nc_hili, all positioned in clip rectangle,
		 *can be highlighted
		 */
	}
}

Nc *
clp_dots(nrect, n, nold, ncold)
Nrect	*nrect;
Int	*n, nold;
Nc	*ncold;
{
	Nc	*ncnew, *nctmp;

	CALLOC(ncnew, Nc, nold, RQ_PCK) 
	nctmp = ncnew;
	*n = 0;
	while (nold-- != 0) {
		if (nc_in_nrect(nrect, ncold) == TRUE) {
			ASS(*nctmp , *ncold)
			nctmp++;
			(*n)++;
		}
		ncold++;
	}
	return(ncnew);
}

Bool
near_pl(n, ncpl, ncpik)
Size	n;
Nc	*ncpl, *ncpik;
{	Bool picked ;

	if (n > 1)
	do {  	picked = p_at_line(ncpik, ncpl, ncpl + 1);
	}
	while 	(picked == FALSE && (--n != 1) && ncpl++);
	return (picked);
}

Bool
near_pm(n, ncpm, ncpik)
Size	n;
Nc	*ncpm, *ncpik;
{	Bool picked;

	if (n)
	do 	picked = p_at_q(ncpm, ncpik);
	while 	(picked == FALSE && (--n != 0) && ncpm++);

	return(picked);
}

Bool
near_tx(ncpm, ncpik)
Nc	*ncpm, *ncpik;
{	Bool picked;

	picked = p_at_q(ncpm, ncpik);
	return(picked);
}

Bool
near_fa(n, ncfa, ncpik)
Size	n;
Nc	*ncfa, *ncpik;
{
	Bool	picked ;
	Nc	*nc1 = ncfa;
	if (n > 1)
	do { 	picked = p_at_line(ncpik, ncfa, ncfa + 1);
	}
	while (picked == FALSE && ncfa++ && (--n != 1));
	if (picked == FALSE)
	 	picked = p_at_line(ncpik, ncfa, nc1);
	return(picked);
}

static
Real
lineside(ncb, nce, ncpik)
Nc	*ncb, *nce, *ncpik;
{
	return( (nce->n_y - ncb->n_y) * ncpik->n_x +
	     	(ncb->n_x - nce->n_x) * ncpik->n_y +
	     	(nce->n_x * ncb->n_y - ncb->n_x * nce->n_y)
	      );
}

Bool
in_txtrect(nctxtrct, ncpik)
register Nc *ncpik;
Nc	*nctxtrct;
{
	register Nc *nc1 = nctxtrct, *nc2 = nctxtrct+1,
	   	*nc3 = nctxtrct+2, *nc4 = nctxtrct+3;

	if (lineside(nc1, nc4, ncpik) * lineside(nc3, nc2, ncpik) > 0.0)
		return(FALSE);
	if (lineside(nc3, nc4, ncpik) * lineside(nc1, nc2, ncpik) > 0.0)
		return(FALSE);

	return(TRUE);
}

Bool
near_ca()
{
}

Bool
near_gd()
{
}

Bool
p_at_q(nc1, nc2)
register Nc	*nc1, *nc2;
{
	return((Bool) (fabs(nc1->n_x - nc2->n_x) < maxdist &&
	    fabs(nc1->n_y - nc2->n_y) < maxdist));
}

Bool
p_at_line(nc1, ncb, nce)
register Nc	*nc1, *ncb, *nce;
{
	register Real a, b, c/*line repr*/;

	if ((((ncb->n_y <  nc1->n_y + maxdist) && 
	      (nc1->n_y <= nce->n_y + maxdist)) ||
	     ((nce->n_y <  nc1->n_y + maxdist) &&
	      (nc1->n_y <= ncb->n_y + maxdist)))
	    &&
	    (((ncb->n_x <  nc1->n_x + maxdist) && 
	      (nc1->n_x <= nce->n_x + maxdist)) ||
	     ((nce->n_x <  nc1->n_x + maxdist) &&
	      (nc1->n_x <= ncb->n_x + maxdist)))
	   ) {
	     a = nce->n_y            - ncb->n_y;
	     b = ncb->n_x            - nce->n_x;
	     c = nce->n_x * ncb->n_y - nce->n_y * ncb->n_x;

	     if (b != 0) {
		if (fabs(nc1->n_y + ((c + a * nc1->n_x) / b)) <
			maxdist)
			return(TRUE);
	     }
	     if (a != 0) {
		if (fabs(nc1->n_x + ((c + b * nc1->n_y) / a)) <
			maxdist)
			return(TRUE);
	     }
	}
	return(FALSE);
}

hili(ws, nr_hili, nc_hili)
Wss	*ws;
Int	nr_hili;
Nc	*nc_hili;
{
	Int	i;
	Dc	dc;
	Ic	*ic, *icptr;

	if (WsScrn->s_hili) {
		CALLOC(ic, Ic, nr_hili, RQ_PCK)
		icptr = ic;
		for (i = 0; i < nr_hili; i++) {
			ws_transf(ws, nc_hili, &dc);
			icptr->i_x = dc.d_x;
			icptr->i_y = dc.d_y;
			nc_hili++; icptr++;

		}
		(*WsScrn->s_hili)(ws, nr_hili, ic);
		FREE(nc_hili)
		FREE(ic)
	}
}
