/* @(#) req_ske.c  version:1.11.2.1  dated:84/12/21 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_ske.c
 * SCCS id :	req_ske.c 1.11.2.1
 * Last edited:	12/21/84 16:33:17
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

#define	SKE_BREAK	'\0'
#define	SKE_STOP 'q'

Bool	nc_in_nrect();
Bool	ic_in_drect();
extern Gksd	*gksd;

extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	Gksd	*gksd;


/* REQUEST STROKE */
Bool
req_ske(ws,dn,val)
Wss	*ws;
Devno	dn;
Stroke	*val; 
{
	register Idevice *idev;
	register Drecord *drecord;
	Stroke	*in_stk;	/*stroke to be returned*/
	char	ret_ch; 	/*char to be returned*/
	Wc	wc, *buf_ptr, *buf_edpos, *initpt, *wcptr;
	Ic	ic;
	Nc	nc, *nc_curr_stk;
	Drect	wsview;
	Bool	no_brk = TRUE, full_buf = FALSE;
	Size	bufsize;
	Int	editpos, i;
	Tmat	iwsmat;
	Int	ntpix, ntrix, ntrixold;
	

	if (ch_state(7, RQ_STK) != 0) return(FALSE);
	if (ch_er_ws(ws, 7, RQ_STK) != 0) return(FALSE);

	if (ch_devno(ws, STROKE, dn, RQ_STK) != 0) return(FALSE);

	idev = &(ws->ws_devs[(Int)STROKE] [dn - 1]);

	if (idev->id_mode != REQUEST) {
		rep_er(141, RQ_STK);
		return(FALSE);
	}

	ensure(RQ_STK);
	ws_ensure(ws, RQ_STK);

	/*
	 * wsview will be (part of) current ws viewport into which the
	 * current ws window is mapped by ws transformation.
	 */
	ASS(wsview.d_ll , ws->ws_curv.d_ll)
	ws_transf(ws, &ws->ws_curw.n_ur, &wsview.d_ur);

	drecord = &(idev->id_drec);
	in_stk = &(idev->id_ival.ev_stk);

	/* as we do not know yet how many points the final stroke
	 * will contain, a temporary buffer is made for the
	 * measure process of size bufsize:
	 */
	bufsize = drecord->stk_rec.stk_bufsz;
	CALLOC(val->stk_pt, Wc, bufsize, RQ_STK)

	/*
	 * initial stroke, containing in_stk->stk_no of
	 * points, is copied into buffer;
	 */
	/* in_stk->stk_no can't be greater than bufsize  (error
	 * in init_stroke() ), so no check on that.
	 */
	val->stk_no = in_stk->stk_no;
	initpt = in_stk->stk_pt;
	buf_edpos = val->stk_pt;
	for (i = 0; i++ < val->stk_no; ) {
		ASS(*buf_edpos++, *initpt++) 
	}


	/* for the di/dd interface entry an array of Nc coordinates is
	 * used to represent the current measure state
	 */
	CALLOC(nc_curr_stk, Nc, bufsize, RQ_STK)

	/* transform current stroke from Wc to Nc;
	 * is stored in nc_curr_stk: */
	nc_stroke(in_stk, nc_curr_stk);


	/*
	 * set the editing position in buffer to point to
	 * initial editing buffer position, being
	 * drecord->stk_rec.stk_posn .
	 * This position is supposed to be at least 1:
	 * (editpos counts up from 1!)
	 */
	if (drecord->stk_rec.stk_posn == 0)
		drecord->stk_rec.stk_posn = 1;
	buf_edpos = val->stk_pt + drecord->stk_rec.stk_posn - 1;
	editpos = drecord->stk_rec.stk_posn;


	/* set both the inverse matrices: */
	invers_mat(ws->ws_wsis->wi_mat, &iwsmat[0][0], RQ_STK);
	setinvnmat(in_stk->stk_nt);


	/* get the index of the initial norm transformation: 
	 * (validity of ntrans pointer already checked in init_ske() )
	 */
	ntrix = 0;
	while (in_stk->stk_nt != _gkss->gk_ntran[ntrix] &&
		ntrix < gksd->gd_nntran - 1) 
			ntrix++;

	/* get the index of ntrix in the vip array: */
	ntpix = 0;
	while (gksis->gki_ntp[ntpix] != ntrix) 
		ntpix++;

	if (drecord->loc_rec.loc_col != 0) { /*bg colour*/
		/*
		show_sk_pet(ws, idev);
		*/;
	}

	val->stk_nt = in_stk->stk_nt;

	do {
		if (editpos > bufsize) {
			/* a request to get another position while the
			 * edit buffer is full. therefore:
			 */
			full_buf = TRUE;
			continue;
		}

		switch(idev->id_pet) {
		case 1:
			/* prompt with a cross asking for a position*/
			ret_ch = (*WsScrn->s_inpc)(ws,&ic, 1, 0,NULL,0);
			break;
		case 4:
			/*cgks-echotype 6 is a rubber band showing
			 *the current stroke 
			 *(may be drawn in a special bitplane)
			 */
			ret_ch = (*WsScrn->s_inpc)(ws, &ic, 6,
				     nc_curr_stk, val->stk_no, editpos);
			break;
		default : 
			break;
		}

		if (ret_ch == SKE_STOP) continue;
		if (ret_ch == SKE_BREAK) {
			no_brk = FALSE;
			continue;
		}
		if (ic_in_drect(&wsview, &ic) == FALSE)
			continue;

		/* so now no speciale case; therefore add ic to
		 * stroke value:
		 */

		/*ic to nc: */
		TRANS(iwsmat,(Real)ic.i_x,(Real)ic.i_y,
				nc.n_x,nc.n_y)

		/*get ntrans viewport in which nc falls,
		 *starting in vip list at ntpix:
		 *(if ntrix == 0 than no other ntr is possible)
		 */
		ntrixold = ntrix;
		if (ntrix != 0) {
			ntrix = gt_loc_ntran(&nc, ntpix);
			if (ntrix != ntrixold) {
			     /* a new ntransf */
			     /*get new vip nr */
			     while (gksis->gki_ntp[ntpix] !=
				    ntrix) 
			     ntpix++;
			     setinvnmat(_gkss->gk_ntran[ntrix]);

			     val->stk_nt = _gkss->gk_ntran[ntrix];

			     nc_stroke(val, nc_curr_stk);
			}
		}

		/* add new nc point in nc_curr_stk: */
		ASS(nc_curr_stk[editpos-1] , nc)

		/*nc -> wc: */
		if (ntrix == 0) {
			wc.w_x = nc.n_x;
			wc.w_y = nc.n_y;
		}
		else {
			TRANS(gksis->gki_imat, nc.n_x, nc.n_y,
				wc.w_x, wc.w_y)
		}

		if (editpos > val->stk_no) val->stk_no = editpos;

		ASS(*buf_edpos, wc)

		buf_edpos++;
		editpos++;
	} while (full_buf == FALSE      /*was room to fill pos  */
		 && no_brk == TRUE      /*no break facility used*/
		 && ret_ch != SKE_STOP);/*not the stop char used*/


	buf_ptr = val->stk_pt;
	/* in following  val->stk_pt will get other value: */

	if (no_brk == TRUE) {
		if (full_buf == TRUE) {
			/*give a message on screen: */
			if (WsScrn->s_msge)
			    (*WsScrn->s_msge)(ws, "stroke buffer full");
		}

		if (val->stk_no != 0) {
			buf_edpos = val->stk_pt;
			CALLOC(val->stk_pt, Wc, val->stk_no, RQ_STK)
			wcptr = val->stk_pt;
			/*copy old buffer into new space:*/
			for (i = 0; i < val->stk_no; i++) {
				ASS(*wcptr++, *buf_edpos++)
			}
		}
	}
	else {
		val->stk_no = 0;
		val->stk_pt = NULL;
		val->stk_nt = NULL;
	}

	FREE(buf_ptr) 
	FREE(nc_curr_stk) 
		
	return(no_brk);
}


nc_stroke(stroke, ncptr)
Stroke	*stroke;
Nc	*ncptr;
{
	Wc	*wcptr = stroke->stk_pt;
	Int	i;
	Tmat	tmat;

	set_mat((Real *)(&stroke->stk_nt->nt_wind),
		(Real *)(&stroke->stk_nt->nt_view),
		&tmat[0][0], FALSE);

	for (i = 0; i++ < stroke->stk_no; ) {
		ncptr->n_x   = wcptr->w_x   * tmat[0][0] + tmat[0][2];
		ncptr++->n_y = wcptr++->w_y * tmat[1][1] + tmat[1][2];
	}
}
