/* @(#) s_asflags.c  version:1.8  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_asflags.c
 * SCCS id :	s_asflags.c 1.8
 * Last edited:	10/19/84 13:53:01
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS3
#define GKS 3

#include "cgksincl.h"

extern Gks	*_gkss;
extern Gksd	*gksd;
extern Gksi	*gksis;
extern GksState	gkstate;

#define CONDMARK(OCT, INDX) \
	if ((oldmask ^ mask) & OCT) ch_mark(INDX);

/*
 * set all attribute source flags according to bits in mask.
 * The parameter mask is an integer of which the 13 lowest 
 * bits indicate the 13 aspect source flags.
 *
 * A 0 bit means BUNDLED, a 1 bit means INDIVIDUAL.
 * The order of the flag bits is as follows:
 * 01: linetype ASF
 * 02: linewidth scalefactor ASF
 * 04: polyline col index ASF
 * 010: marker type ASF
 * 020: marker size scale factor ASF
 * 040: polymarker colour index ASF 
 * 0100: text font and precision ASF
 * 0200: character expansion factor ASF
 * 0400: character spacing ASF
 * 01000: text colour index ASF
 * 02000: fill area interior style ASF
 * 04000: fillarea style index ASF
 * 010000: fill area colour index ASF
 */
s_asflags(mask)
Asflags mask;
{	
	Ch_State(8, S_ASF);
	_s_asflags(mask);
	return(0);
}

/*
 * the following function does the actual setting of the
 * flags in the field in the global statelist.
 * _s_asflags() is also used in insseg.c
 */
_s_asflags(mask)
Asflags mask;
{
	Int oldmask = _gkss->gk_asf;

	/*
	 * Check if there are new flag settings concerning the
	 * attributes for each primitive.
	 * If so mark the attribute flagbits for that primitive
	 * in attmark[]. (attmark[] in u_globals.c)
	 */
	if (mask != oldmask) {
		_gkss->gk_asf = mask;
#ifdef METAFILE
		MF_ATTENSURE(m_sasf,gk_asf)
#endif
		CONDMARK(07, PLATT)
		CONDMARK(070, PMATT)
		CONDMARK(01700, TXATT)
		CONDMARK(016000, FAATT)

		/*
		 * if segment is open mark that new flags
		 * are to be stored.
		 * (storing is done in ensure() in u_ensure.c)
		 */
		if (gkstate == SGOP) {
			ch_mark(SG_ASF);
		}
	}
}

/* nowhere used:
Int
flag_val(att)
Int att;
{	if ((_gkss->gk_asf & att) ) return (INDIV);
	else return(BUNDL);
}
*/
