/* @(#) t4014.c  version:1.15  dated:84/11/21 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.t4014.c
 * SCCS id :	t4014.c 1.15
 * Last edited:	11/21/84 14:31:18
 *
 * Author:	David Rosenthal
 *		Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/* driver for t4014 */

#define	TRMTYP	4014
#include	"cgksincl.h"
#include	<signal.h>

#ifdef vax
#include	<errno.h>
#else
#define EINTR 4
#endif

#include	<sgtty.h>
#include	<setjmp.h>
#include	"defns.h"
#include	"t4014.h"

static int	cursor(), keyboard();
static Bool	tekerase(), drawline(), drawhard();
static Bool	drawmark();
static Bool	erasel(), eraser();
/*
static Bool	setlatt(), setmatt(), settatt(), setfatt();
*/

Screen	g_t4014[] = {
	MAXX, MAXY,	/* Main screen size */
	CHARX, CHARY,	/* Hard character size */
	CHARHT,		/* Hard character height */
	0, 0,		/* Hit location */
	0,		/* Hit code */
	0,		/* Colour */
	S_CHANGED,
	'\0',
	tekerase,	/* Total erase */
	erasel,		/* line erase */
	NULL,
	NULL,		/* Set clip rectangle */
	NULL,		/* GKS message*/
	NULL,		/* Escape */

	drawline,	/* Line drawing */
	drawmark,	/* Polymark */
	drawhard,	/* Hard characters */
	NULL,		/* no rasterscan for t4014 */
	NULL,		/* no pixel facility */
	NULL,		/* no cellarray facility */
	NULL,		/* gdp */
	eraser,		/* rectangle erase */

	NULL,		/* Set polyline att*/
	NULL,		/* Set polymark att*/
	NULL,		/* Set text att*/
	NULL,		/* Set fill area att*/
	NULL,		/* No Colour */
	NULL,		/* No colour table */
	NULL,		/* Inquire pixel */
#ifndef	HIGH_INPUT /*for a simple device, with only request input:*/
	cursor,		/* Input from cursor */
	keyboard,	/* Input from cursor */
#else
	NULL, /*init loc,val,cho,pik,str or stk inp dev*/
	NULL, /*set loc,val,cho,pik,str or stk idev mod*/
	NULL, /*get req. or sample input from loc dev */
	NULL, /*get req. or sample input from val dev */
	NULL, /*get req. or sample input from cho dev */
	NULL, /*get req. or sample input from str dev */
	NULL, /*get req. or sample input from stke dev */
	NULL, /*get req. or sample input from pick dev */
	NULL, /*await event*/
#endif
	NULL,		/* hilite primitive*/
	} ;

Screen *tekscrn = g_t4014;

int
t4014()
{	return(inst_scr("tek", tekscrn));
}

#include	"tek.h"
#include	"tekdraw.h"
#include 	"tekgks.h"
#include 	"tekatt.h"
