/* @(#) tek.h  version:1.7  dated:84/11/21 */
/*
 * SCCS file:	SCCS/s.tek.h
 * SCCS id :	tek.h 1.7
 * Last edited:	11/21/84 14:30:54
 */


	/*
	 * The lowest level routines for Tek-like terminals.
	 */

File *TekOUT = stdout;
File *TekIN  = stdin;

#undef	putchar
#undef	getchar
#define	putchar(X)	fputc(X,TekOUT);

extern int	errno;
static jmp_buf	Quit;

static 
int getchar()
{
	register int	c;

	if ((c = fgetc(TekIN)) == EOF && errno == EINTR)
		longjmp(Quit,-1);
	else
		return(c);
}

#define command putchar
#define prefix  putchar
#define Aaargh(s)	abort()

static int
catchit(sig)
{
}

static struct sgttyb ggttyb;
static int	oldxhi = -1;	/* Last coordinate bytes */
static int	oldxlo = -1;
static int	oldyhi = -1;
static int	oldylo = -1;
#if	(TRMTYP == 4014 || TRMTYP == 512)
static int	oldxtr = -1;
#define	MASK2	03
#endif
static Ic	beam = { 0, 0};		/* Beam position */
static Screen	*scr = NULL;
static Bool	continew = FALSE;
static Bool	inited = FALSE;
static Bool	graphmode = FALSE;

static
breakline()	/* Start or break a polyline */
{
	putchar(GS);
	graphmode = TRUE;
	continew = FALSE;
#if	(TRMTYP != 512)
	flush(LINED);
#endif
}


static
alphamode()	/* Switch to alphamode */
{
	if (graphmode) {
		breakline();
		transmit(&beam);
	}
	putchar(US);
	graphmode = FALSE;
	continew = FALSE;
}


static
Bool
atbeam(s)	/* True if s at current beam posn. */
Ic *s;
{
	return((Bool)((s->i_x == beam.i_x) && (s->i_y == beam.i_y)));
}


static
Bool
tekerase(ws)		/* Erase screen s */
Wss	*ws;
{
	Screen *sc = WsScrn;
	if(inited == FALSE) {
		initial();
		inited = TRUE;
	}
	if (scr != sc) selscr(sc);
#if	(TRMTYP == 4002)
	putchar(FF);
#else
	putchar(ESC);
	putchar(FF);
#endif
	flush(ERASED);
}


static
selscr(sc)
Screen	*sc;
{
	if (sc == scr) return(0);
#if	(TRMTYP == 4002 || TRMTYP == 4012)
	alphamode();
#if	(TRMTYP == 4002)
	putchar(BEL);
#endif
#if	(TRMTYP == 4012)
	putchar(ESC);
	putchar('0');
#endif
	putchar((sc == g_t4014) ? SCR1 : SCR2);
#endif
	scr = sc;
	return(0);
}


static
movebeam(s)	/* Update beam posn. */
Ic *s;
{
	ASS(beam, *s)
}


static
transmit(s)	/* Send coordinate bytes for screenpoint s */
Ic *s;
{
	register int newxhi,newxlo,newyhi,newylo;
#if	(TRMTYP == 4014 || TRMTYP == 512)
	register int newxtr;
#endif
	/* N.B. Assumes graphmode set */
	if(s->i_x > MAXX || s->i_y > MAXY)
		return;
#if	(TRMTYP == 4014 || TRMTYP == 512)
	newxhi = (s->i_x >> 7) & MASK5;
	newxlo = (s->i_x >> 2) & MASK5;
	newyhi = (s->i_y >> 7) & MASK5;
	newylo = (s->i_y >> 2) & MASK5;
	newxtr = ((s->i_y & MASK2) << 2) | (s->i_x & MASK2);
#else
	newxhi = (s->i_x >> 5) & MASK5;
	newxlo = s->i_x & MASK5;
	newyhi = (s->i_y >> 5) & MASK5;
	newylo = s->i_y & MASK5;
#endif
	if (continew == TRUE && (newyhi == oldyhi)) {
#if	(TRMTYP == 4014 || TRMTYP == 512)
		if (newxtr != oldxtr) {
			putchar(YLOBITS | newxtr);
			oldxtr = newxtr;
		}
#endif
		putchar(YLOBITS | newylo);
		oldylo = newylo;
	}
	else {
		putchar(YHIBITS | newyhi);
		oldyhi = newyhi;
#if	(TRMTYP == 4014 || TRMTYP == 512)
		if (newxtr != oldxtr) {
			putchar(YLOBITS | newxtr);
			oldxtr = newxtr;
		}
#endif
		putchar(YLOBITS | newylo);
		oldylo = newylo;
	}
#if	(TRMTYP == 4014 || TRMTYP == 512)
	if (newxtr != oldxtr) {
		putchar(YLOBITS | newxtr);
		oldxtr = newxtr;
		putchar(YLOBITS | newylo);
		oldylo = newylo;
	}
#endif
	if ( !(continew == TRUE && (newxhi == oldxhi))) {
		putchar(XHIBITS | newxhi);
		oldxhi = newxhi;
	}
	putchar(XLOBITS | newxlo);
	oldxlo = newxlo;
	continew = TRUE;
	flush(LINED);
	ASS(beam , *s)
}

static
int cursor(ws,s,pet)	/* Returns the char which activated the cursor,
		and the position in screen space */
Wss	*ws;
Ic	*s;
Pet	pet;
{
	register int	ch;
	Screen *sc = WsScrn;
	int	(*fintr)();

	selscr(sc);
	if (pet != 0) s_pet(pet);
	if (setjmp(Quit) != 0) {
		alphamode();
#if	(TRMTYP == 500)
		putchar(CR);
#endif
		signal(SIGALRM,SIG_IGN);
		if (sc->s_timo != 0) {
			ASS(*s , sc->s_hit)
			return(sc->s_code);
		}
		else if (errno == EINTR) return('\0');
	}
	while(TRUE) {
		alphamode();
		putchar('\0');
#if	(TRMTYP == 4002)
		putchar(DC1);
#else
		putchar(ESC);
		putchar(SUB);
#if	(TRMTYP == 500)
		putchar(CR);
#else
		putchar(BEL);
#endif
#endif
		flush(CURSED);
		if (sc->s_timo != 0) {
			signal(SIGALRM,catchit);
			alarm(sc->s_timo);
		}
		fintr = signal(SIGINT, catchit);
		ch = getchar() & MASK7;
		signal(SIGINT, fintr);
		signal(SIGALRM,SIG_IGN);
		beam.i_x = getcoord();
		beam.i_y = getcoord();
		alphamode();
		if ((getchar() & MASK7) == '\n') {
#if	(TRMTYP == 4002)
			flush(CURSED);
#endif
#if	(TRMTYP == 500)
			putchar(CR);
#endif
			ASS(*s , beam)
			ASS(sc->s_hit , *s)
			sc->s_code = ch;
			return(ch);
		}
		else {
#if	(TRMTYP == 4002)
			flush(CURSED);
#endif
#if	(TRMTYP == 500)
			putchar(CR);
#endif
			while((getchar() & MASK7) != '\n')
					;
			return(-1);
		}
	}
}


static
getcoord()	/* Decode cursor coordinate */
{
	register int	temp;
	temp = (getchar() & MASK5) << 5;
	temp += (getchar() & MASK5);
#if	(TRMTYP == 4014 || TRMTYP == 512)
	temp *= 4;
#endif
	return(temp);
}

/* Redundant routine follows
getpoint(s)
Ic	*s;
{
	register int ch;
	alphamode();
	putchar('\0');
#if	(TRMTYP == 4002)
	putchar(ENQ);
#endif
#if	(TRMTYP == 4012)
	putchar(ESC);
	putchar(ENQ);
#endif
	ch = getchar();
	s->i_x = getcoord();
	s->i_y = getcoord();
	alphamode();
	putchar('\0');
	if((getchar() & MASK7)  == '\n')
		return(ch);
	else
		return(-1);
}
*/

#if	(TRMTYP == 4012)
static
int gettablt(ws,s)	/* Get single coordinate from tablet */
Wss	*ws;
register Ic	*s;
{
	register int ch;
	struct sgttyb	tty;
	Screen *sc = WsScrn;

	if (sc != g_t4014 + TABLET) {
		Aaargh("Not the tablet");
		}
	flush(TABLETD);
	tty = ggttyb;
	tty.sg_flags &= ~CBREAK;
	tty.sg_flags |= RAW;
#ifdef	TIOCSETA
	ioctl(fileno(TekOUT),TIOCSETA,&tty);
#else
	ioctl(fileno(TekOUT),TIOCSETP,&tty);
#endif	TIOCSETA
	alphamode();
	putchar(BEL);
	putchar('\0');	/* To avert gremlins */
	putchar(ESC);
	putchar('!');
	putchar(TABENB);
	flush(TABLETD);
	/* Tablet now enabled */
	while ((ch = (getchar() & MASK7)) != GS && ch != SUB) {
		if(ch == ETX) {
			killtab();
			return(-1);
		}
	}
	/* Start of coordinate sequence detected */
	s->i_y = (getchar() & MASK5) << 7;
	ch = getchar();
	s->i_y |= (ch & 014) >> 2;
	s->i_x = ch & 3;
	s->i_y |= (getchar() & MASK5) << 2;
	s->i_x |= (getchar() & MASK5) << 7;
	s->i_x |= (getchar() & MASK5) << 2;
	putchar(BEL);
	killtab();
	/* Tablet now disabled */
	sc->s_hit = *s;
	alphamode();
	return(sc->s_code);
}

static
Bool
killtab()
{
	putchar(ESC);
	putchar('!');
	putchar(TABDIS);
#ifdef	TIOCSETA
	ioctl(fileno(TekOUT),TIOCSETA,&ggttyb);
#else
	ioctl(fileno(TekOUT),TIOCSETP,&ggttyb);
#endif	TIOCSETA
	flush(TABLETD);
}
#endif


static
initial()
{
	setbuf(TekOUT,(char *) NULL);
	setbuf(TekIN,(char *) NULL);
#ifdef	TIOCSETA
	ioctl(fileno(TekOUT), TIOCGETA, &ggttyb);
#else
	ioctl(fileno(TekOUT), TIOCGETP, &ggttyb);
#endif
#ifdef	TIOCSETA
	ggttyb.sg_width = 0;
	ggttyb.sg_length = 0;
	ggttyb.sg_crdly = 0;
	ggttyb.sg_nldly = 0;
#endif	TIOCSETA
	ggttyb.sg_flags &= ~ECHO;
	ggttyb.sg_flags |= (CBREAK|ODDP|EVENP|TANDEM);
	ggttyb.sg_flags &= ~ALLDELAY;
#ifdef	TIOCSETA
	ioctl(fileno(TekOUT),TIOCSETA,&ggttyb);
#else
	ioctl(fileno(TekOUT),TIOCSETP,&ggttyb);
#endif	TIOCSETA
#if	(TRMTYP == 4014 || TRMTYP == 2000 || TRMTYP == 512)
	/* Make hard characters small */
	putchar(ESC);
#if	(TRMTYP == 4014 || TRMTYP == 512)
	putchar(DEL);
#else
	putchar(FF);
	putchar(ESC);
#endif
	putchar(';');
#endif
#if	(TRMTYP == 500)
	/* Enter Graphics Mode */
	putchar(FF);
	putchar(GS);
#endif
}


static
flush(i)
int	i;
{
	while (i--)
		putchar('\0');
#ifdef	TIOCSETA
	/*
	 * The BELL tty driver interprets FLUSH to mean
	 * DISCARD as applied to output characters.
	 * This can only be a symptom of severe brain
	 * damage.
	 */
	ioctl(fileno(TekOUT),TIOCFLUSH,(struct sgttyb *) NULL);
#endif
}

#define	ERASEON		DLE
#define	ERASEOFF	SOH

static	Bool erasel(ws,on)
Wss	*ws;
Bool	on;
{
	register char	ch;
	Screen *sc = WsScrn;

	selscr(sc);
	alphamode();
	putchar(ESC);
	ch = on ? ERASEON : ERASEOFF;
	putchar(ch);
}

static Bool eraser(ws,ll,ur)
Wss	*ws;
Ic	*ll;
Ic	*ur;
{
	Screen *sc = WsScrn;
	selscr(sc);
	alphamode();
	putchar(ESC);
	putchar(ERASEON);
	putchar(ESC);
	putchar('\002');
	breakline();
	transmit(ll);
	transmit(ur);
	alphamode();
	putchar(ESC);
	putchar('\003');
	putchar(ESC);
	putchar(ERASEOFF);
}

static int
keyboard(ws,s,hit)
Wss	*ws;
Ic	*s, *hit;
{
	register int	ch;
	Screen *sc = WsScrn;
	int	(*fintr)();

	if (setjmp(Quit) != 0) {
		return('\0');
	}
	/*
	moveto(hit); ?
	*/
	alphamode();
	fintr = signal(SIGINT, catchit);
	ch = getchar() & MASK7;
	signal(SIGINT, fintr);
	s->i_x = sc->s_size.i_x/2;
	s->i_y = sc->s_size.i_y/2;
	return (ch);
}


static
s_pet(pet)
Pet	pet;
{
}
