/* @(#) tekdraw.h  version:1.5  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.tekdraw.h
 * SCCS id :	tekdraw.h 1.5
 * Last edited:	10/19/84 13:47:00
 */


	/* This file contains the basic device independent routines
	for drawing in screen space, written by David Rosenthal*/

#if (TRMTYP!=4012 && TRMTYP != 4014 && TRMTYP != 2000 && TRMTYP != 512)
static char	dotted[]	= "\002\006";
static char	dashed[]	= "\012\004";
static char	dotdash[]	= "\012\004\004\004";
#endif

static
Bool drawline(ws, n, s,ltype,lwidth)	/* Draw line in screen space */
Wss	*ws;
Size	n;
Ic	*s;
Ltype	ltype;
Lwidth	lwidth;
{
	Ic *s1, *s2, s3[2];
	Screen *sc = WsScrn;
	selscr(sc);

	while (--n) {
	s1 = s;
	s++;
	s2 = s;
	if ((s1->i_x == s2->i_x) && (s1->i_y == s2->i_y)) continue;
	switch (ltype) {
	case DOUBLE:	/* N.B. not a good way of doing it */
		s3[0].i_x = (s1->i_x != 0) ? s1->i_x-1 : 0;
		s3[0].i_y = (s1->i_y != 0) ? s1->i_y-1 : 0;
		s3[1].i_x = (s2->i_x != 0) ? s2->i_x-1 : 0;
		s3[1].i_y = (s2->i_y != 0) ? s2->i_y-1 : 0;
		drawline(ws,2,s3,SOLIDL,lwidth);
		s3[0].i_x += 2;
		s3[1].i_x += 2;
		drawline(ws,2,s3,SOLIDL,lwidth);
		s3[0].i_x = s1->i_x;
		s3[0].i_y += 2;
		s3[1].i_x = s2->i_x;
		s3[1].i_y += 2;
		drawline(ws,2,s3,SOLIDL,lwidth);
		break;
	case DOTTED:
#if	(TRMTYP!=4012 && TRMTYP != 4014 && TRMTYP != 2000 && TRMTYP != 512)
		pattern(ws,s1,s2,dotted);
		break;
#endif
	case DASHED:
#if	(TRMTYP!=4012 && TRMTYP != 4014 && TRMTYP != 2000 && TRMTYP != 512)
		pattern(ws,s1,s2,dashed);
		break;
#endif
	case DOTDASH:
#if	(TRMTYP!=4012 && TRMTYP != 4014 && TRMTYP != 2000 && TRMTYP != 512)
		pattern(ws,s1,s2,dotdash);
		break;
#endif
	case SOLIDL:
#if	(TRMTYP==4012 || TRMTYP == 4014 || TRMTYP == 2000 || TRMTYP == 512)
		setltyp(ltype);
#endif
		if(graphmode == TRUE && (atbeam(s1) == TRUE)) { 
			transmit(s2);
			}
		else if(graphmode == TRUE && (atbeam(s2) == TRUE)) {
			transmit(s1);
			}
		else {
			breakline();
			transmit(s1);
			transmit(s2);
			}
		break;
	}
	}
}

static
Bool drawhard(ws,st,s)	/* Draw hard char str st at s in screen space */
Wss	*ws;
Ic	*s;
String	st;
{
	register char c;
	char *s2 = st;
	Ic	q;
	Screen *sc = WsScrn;

	/*Set_Out(ws->ws_ofile)*/
	selscr(sc);
	if ((atbeam(s) == FALSE) || graphmode == TRUE) {
		breakline();
		transmit(s);
	}
	ASS(beam, *s)
	if (graphmode == TRUE) alphamode();
	while((c = *s2++) != '\0') {
		if (c > US) {
			putchar(c);
			beam.i_x += sc->s_chsz.i_x;
		}
	}
	movebeam(&beam);
}

#if	(TRMTYP != 4014 && TRMTYP != 2000 && TRMTYP != 512)

static
pattern(ws,s1,s2,pat)	/* Draw pattern from pat from s1 to s2 */
Wss *ws;
Ic	*s1,*s2;
char	pat[];
{
	Ltype	lt;
	Ic	s3,s4;
	int	i,j,n,xch,ych;
	float	rem,slope,dx,dy;
	double	fabs();
	i = j = 0;
	lt = SOLIDL;
	s3.i_x = s4.i_x = s1->i_x;
	s3.i_y = s4.i_y = s1->i_y;
	dx = s2->i_x - s1->i_x;
	dy = s2->i_y - s1->i_y;
	rem = 0.5;
	xch = (dx > 0.0) ? 1 : -1;
	ych = (dy > 0.0) ? 1 : -1;
	if (fabs(dx) > fabs(dy)) {
		slope = fabs(dy)/fabs(dx);
		for (n = 1; n <= fabs(dx); ++n) {
			rem += slope;
			if (rem >= 1.0) {
				s4.i_y += ych;
				rem -= 1.0;
			}
			s4.i_x += xch;
			if (++i == pat[j]) {
				if (pat[++j] == '\0') j = 0;
				i = 0;
				drawline(ws,&s3,&s4,lt,1);
				s3.i_x = s4.i_x;
				s3.i_y = s4.i_y;
				if (lt == SOLIDL)
					lt = BLANK;
				else
					lt = SOLIDL;
				}
			}
		}
	else {
		slope = fabs(dx)/fabs(dy);
		for (n = 1; n <= fabs(dy); ++n) {
			rem += slope;
			if (rem >= 1.0) {
				s4.i_x += xch;
				rem -= 1.0;
			}
			s4.i_y += ych;
			if (++i == pat[j]) {
				if (pat[++j] == '\0') j = 0;
				i = 0;
				drawline(ws,&s3,&s4,lt,1);
				s3.i_x = s4.i_x;
				s3.i_y = s4.i_y;
				if (lt == SOLIDL) lt = BLANK;
				else		  lt = SOLIDL;
			}
		}
	}
}
#endif


#define CODE 1

/*
 * Send a value8
 */

static
value8(x)
Int	x;
{
#if	(CODE == 7)
	putchar((x & LO_MASK) >> 7);
	putchar(x & LO_MASK);
#endif
#if	(CODE == 8)
	putchar(x & LO_MASK);
#endif
#if	(CODE == 1)
	printf("%d ",x&0377);
#endif
}

/*
 * Send a 16 bit value
 */
static
value16(x)
int	x;
{
#if	(CODE == 7)
	putchar((x >> 7) & MASK7);
	putchar(x & MASK7);
#endif
#if	(CODE == 8)
	putchar((x >> 8) & LO_MASK);
	putchar(x & LO_MASK);
#endif
#if	(CODE == 1)
	printf("%d ",x&0177777);
#endif
}
