/* @(#) textext.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.textext.c
 * SCCS id :	textext.c 1.5
 * Last edited:	10/19/84 13:46:27
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*This file contains an inquiry function that is not
 *implemented as a macro.
 */

/*to add : interpret text alignment and path*/

#define GKS8
#define GKS2

#include "cgksincl.h"

extern Gks *_gkss;
extern Gksi *gksis;

#ifdef BERKFONT
#include <vfont.h>

Bool charfont();

struct	FontFileInfo {
	int	fileid;
	String	fontname;
	int	nominalup;
};

struct	dispatch disptable[256];
extern 	struct FontFileInfo	currfont;
extern	String GKSfonts[];
extern	Real rathx, rathy, ratvx, ratvy;
#endif

/*INQUIRE TEXT EXTENT*/
Bool
textext(ws, pt, st, cat, ter)
Wss	*ws;
Wc	*pt; /*text position*/
String	st;
Wc	*cat;/*concat. point*/
Wc	*ter; /*text extent rectangle*/
{
	Wc	w_up, w_width, w_space;
	Int	nrspaces = 0;
	Real	uplngth;
	char	*c = st;
	TextRep	*trep = &ws->ws_wsis->wi_trep;
	Tprec	prec = trep->tx_fp.fp_pr;
	int	l=0, r=0, u=0, d=0;
	int	umax=0, dmax=0, width=0, left=0, right=0, next=0;
	Int 	fontindex;
	Nc	nc;
	Dc	dc;
	Ic	ic;
	Tmat	iwsmat;

	if (ch_state(7, IQU_TX_XT) != 0) return(FALSE);
	ensure(TXT);
	ws_ensure(ws, TXT);

	switch(trep->tx_fp.fp_fo) {
	case (1):
		/*hard character set of workstation*/
		/*no clipping*/
#ifndef	BERKFONT
	default:
#endif
		ntransf(pt, &nc);
		ws_transf(ws, &nc, &dc);
		dc_to_ic(&ic, &dc);
		/*calculate lower left: */
		ic.i_y += (WsScrn->s_chht - WsScrn->s_chsz.i_y);
		dc.d_x = (Real)ic.i_x;
		dc.d_y = (Real)ic.i_y;
		invers_mat(ws->ws_wsis->wi_mat,&iwsmat[0][0],IQU_TX_XT);
		TRANS(iwsmat, dc.d_x, dc.d_y, nc.n_x, nc.n_y)
		setinvnmat(_gkss->gk_curnt);
		TRANS(gksis->gki_imat, nc.n_x, nc.n_y,
			ter[0].w_x, ter[0].w_y)

		/*calculate upper right: */
		ic.i_x += (strlen(st) * WsScrn->s_chsz.i_x); 
		ic.i_y += WsScrn->s_chsz.i_y ; 
		dc.d_x = (Real)ic.i_x;
		dc.d_y = (Real)ic.i_y;
		invers_mat(ws->ws_wsis->wi_mat,&iwsmat[0][0],IQU_TX_XT);
		TRANS(iwsmat, dc.d_x, dc.d_y, nc.n_x, nc.n_y)
		setinvnmat(_gkss->gk_curnt);
		TRANS(gksis->gki_imat, nc.n_x, nc.n_y,
			ter[2].w_x, ter[2].w_y)

		ter[1].w_x = ter[2].w_x;
		ter[1].w_y = ter[0].w_y;
		ter[3].w_x = ter[0].w_x;
		ter[3].w_y = ter[2].w_y;
		ASS(*cat, ter[1])
	    	break;
#ifdef	BERKFONT
	case (2):
	case (3):
	case (4):
	case (5):
	case (6):
	case (7):
	case (8):
	case (9):
	case (10):
	case (11):
	default:
	    fontindex = (trep->tx_fp.fp_fo <= 11) ?
		(Int)trep->tx_fp.fp_fo - 1 : 10;
	    s_curfont(GKSfonts[fontindex]);

	    if (prec != STR) {
	    	ASS(w_up, _gkss->gk_chup)
	    	uplngth = _gkss->gk_chht /
	         sqrt((double)(w_up.w_x*w_up.w_x + w_up.w_y*w_up.w_y));
	    	w_up.w_y *= uplngth;
		w_up.w_x *= uplngth;
	    	w_space.w_x =  w_up.w_y * ws->ws_wsis->wi_trep.tx_chsp;
	    	w_space.w_y = -w_up.w_x * ws->ws_wsis->wi_trep.tx_chsp;
	    }
	    else {
	    	w_up.w_y = _gkss->gk_chht;
		w_up.w_x = 
	    	w_space.w_x = w_space.w_y = 0.0;
	    }

	    w_up.w_x = w_up.w_x / (Real)currfont.nominalup;
	    w_up.w_y = w_up.w_y / (Real)currfont.nominalup;
	    w_width.w_x =  w_up.w_y;
	    w_width.w_y = -w_up.w_x;
	    w_width.w_x *= ws->ws_wsis->wi_trep.tx_chef;
	    w_width.w_y *= ws->ws_wsis->wi_trep.tx_chef;

	    while (*c && (Bool)charfont(&currfont.fileid, disptable, *c,
			&left, &r, &umax, &dmax, &width)==FALSE) {
		c++;
	    }
	    next = width;

	    if (*c)
	      while (*++c) {
	        if ((Bool)(charfont(&currfont.fileid, disptable, *c,
			&l, &r, &u, &d, &width)) == TRUE) {
			if (u > umax) umax = u;
			if (d > dmax) dmax = d;
			next += width;
			nrspaces++;
		}
	    }

	    right = next - width + r;

	    cat->w_x = pt->w_x + next * w_width.w_x;
	    cat->w_y = pt->w_y + next * w_width.w_y;
	    cat->w_x += ((nrspaces + 1) * w_space.w_x);
	    cat->w_y += ((nrspaces + 1) * w_space.w_y);

	    ter->w_x = pt->w_x - left * w_width.w_x - dmax * w_up.w_x;
	    ter->w_y = pt->w_y - left * w_width.w_y - dmax * w_up.w_y;
	    ter++;
	    ter->w_x = pt->w_x + right * w_width.w_x - dmax * w_up.w_x;
	    ter->w_y = pt->w_y + right * w_width.w_y - dmax * w_up.w_y;
	    ter->w_x += (nrspaces * w_space.w_x);
	    ter->w_y += (nrspaces * w_space.w_y);
	    ter++;
	    ter->w_x = pt->w_x + right * w_width.w_x + umax * w_up.w_x;
	    ter->w_y = pt->w_y + right * w_width.w_y + umax * w_up.w_y;
	    ter->w_x += (nrspaces * w_space.w_x);
	    ter->w_y += (nrspaces * w_space.w_y);
	    ter++;
	    ter->w_x = pt->w_x - left * w_width.w_x + umax * w_up.w_x; 
	    ter->w_y = pt->w_y - left * w_width.w_y + umax * w_up.w_y;
	    break;
#endif
	}
	return(TRUE);
}
