/* @(#) u_cgksws.c  version:1.10  dated:84/11/30 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_cgksws.c
 * SCCS id :	u_cgksws.c 1.10
 * Last edited:	11/30/84 16:49:41
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*This file contains some code depending on the 
 *local included workstationtypes.        
 *The first two utility functions are used 
 *in open_gks.c and open_gksi.h.
 */

#define GKS1
#define GKS 1

#include "cgksincl.h"

extern Gksi *gksis;
extern Gksd *gksd;

#define	WIS_DEVICE	AVAILABLE /*workst. indep. segm. storage*/
#define	AED_DEVICE	AVAILABLE
#define	IBM_DEVICE	AVAILABLE
#define TEK_DEVICE	AVAILABLE
#define VER_DEVICE	AVAILABLE
#define FOO_DEVICE	AVAILABLE
#ifdef METAFILE
#define MO_DEVICE	AVAILABLE
#define MI_DEVICE	AVAILABLE
#else
#define MO_DEVICE	NOT_AVAILABLE
#define MI_DEVICE	NOT_AVAILABLE
#endif

/*AVWT = number of available ws types*/
#define AVWT (WIS_DEVICE + AED_DEVICE + TEK_DEVICE + VER_DEVICE + \
	FOO_DEVICE + IBM_DEVICE + MO_DEVICE + MI_DEVICE)

/*inst_avwt installs the available ws types in the gks
 *global statelist
 */
inst_avwt(gksd)
Gksd	*gksd;
{
	Int i = 0;

	CALLOC(gksd->gd_avwt, String, AVWT, O_GKS)

#if	(WIS_DEVICE == AVAILABLE)	
	gksd->gd_avwt[i] = "wis";
	i++;
#endif

#ifdef METAFILE
#if	(MO_DEVICE == AVAILABLE)	
	gksd->gd_avwt[i] = "mo";
	i++;
#endif
#if	(MI_DEVICE == AVAILABLE)	
	gksd->gd_avwt[i] = "mi";
	i++;
#endif
#endif /*METAFILE */

#if	(AED_DEVICE == AVAILABLE)	
	gksd->gd_avwt[i] = "aed";
	i++;
#endif
#if	(VER_DEVICE == AVAILABLE)
	gksd->gd_avwt[i] = "ver";
	i++;
#endif
#if	(FOO_DEVICE == AVAILABLE)
	gksd->gd_avwt[i] = "foo";
	i++;
#endif
#if	(TEK_DEVICE == AVAILABLE)
	gksd->gd_avwt[i] = "tek";
	i++;
#endif
#if	(IBM_DEVICE == AVAILABLE)
	gksd->gd_avwt[i] = "ibm";
	i++;
#endif
	gksd->gd_nrwt = i;
	return(0);
}

/*The following function is called by the drivertypefunction,
 *being a parameter of open_ws().  (see  wstype() in open_ws.c)
 *aed512() for example calls inst_scr("aed", aedscrn)
 *inst_scr() sets the wd_screen parameter of the belonging wsd.
 */
int
inst_scr(wtype, scr)
String	wtype;
Screen	*scr;
{	int	i = 0;

	while (i < gksd->gd_nrwt &&
	       strcmp(wtype, gksd->gd_avwt[i]) != 0) i++;

	if (i == gksd->gd_nrwt)  {
		rep_er(904, O_GKS);
		return(0);
	}
	else {
		gksis->gki_wsd[i]->wd_screen = scr;
		return(i+1);
	}
}

/*The wstype() function, being a parameter of open_ws(),
 *can be found in the appropriate driver file.
 *An exception is the wstype() for a workstation type 
 *without a driver, "wiss".
 *It follows below.
 */

#if	(WIS_DEVICE == AVAILABLE)	
int wis()
{	return(inst_scr("wis", NULL));
	/*NULL: no driver for WISS*/
}
#endif

#ifdef METAFILE
int
inst_mfscr(wtype, scr)
String	wtype;
Mf_screen *scr;
{	int	i = 0;

	while (i < gksd->gd_nrwt &&
	       strcmp(wtype, gksd->gd_avwt[i]) != 0) i++;

	if (i == gksd->gd_nrwt)  {
		rep_er(904, O_GKS);
		return(0);
	}
	else {	gksis->gki_wsd[i]->wd_mfscrn = scr;
		return(i+1);
	}
}
#endif
