/* @(#) u_defacts.c  version:1.8  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_defacts.c
 * SCCS id :	u_defacts.c 1.8
 * Last edited:	11/13/84 13:36:31
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS2
#define GKS3
#define GKS4
#define GKS5

#include "cgksincl.h"

#define WSCAT ws->ws_wsd->wd_cat

extern	Gks	*_gkss;
extern 	Gksd	*gksd;
extern 	Gksi	*gksis;
extern 	Int	attmark[];
extern	Tmat 	u_mat; /*unity matrix; in open_wsi.h*/

/*The following function pointer will be a pointer to the
 *function ws_pline().
 *This pointer will be set in polyline() when polyline() is called.
 *The same goes for the other pointers.
 *By using these pointers in drawsegonws() instead of the direct
 *function names an unnecessary loading of object files of
 *output primitives that are not used is prevented.
 */
extern	Fun 	pws_pline;
extern	Fun	pws_pmark;
extern 	Fun	pws_text;
extern	Fun	pws_farea;
extern	Fun	pws_cells;
extern	Fun	pws_gdp;

Nc	*nc_trans();
char 	*find_rep();
Bool	unit_mat();

def_acts(ws, fun)
Wss	*ws;
Int	fun;
{
	Seginst	*seginst;
	Seg	*seg;

	/*b)*/
	if (ws->ws_empty == FALSE) {
		(*WsScrn->s_tera)(ws);
		ws->ws_empty = TRUE;
	}
	/*c)*/
	ws_trupdate(ws);
	/*does this has right effect at redraw?*/
	/*d)*/
	ws_ensure(ws, fun);
	seginst = ws->ws_segs;
	while (seginst != NULL) {
		seg = seginst->si_this;
		if (seg->sg_vis) {
			drawsegonws(ws, seg, fun);
			ws->ws_empty = FALSE;
		}
		seginst = seginst->si_next;
	}
	/*e)*/
	ws->ws_newfr = FALSE;
}

/*
 * drawsegonws() draws segment seg on workstation ws.
 * it is called from GKS function fun.
 */
/*
 * cur_wis_fl indicates continuously whether the attributes in wi_lrep,
 * wi_mrep, wi_trep and wi_frep in wis are taken global or local.
 * if an output primitive block is met these flags are compared with 
 * the flags as they should be according to the aspect source flags.
 * if there is a difference then an update of wi_lrep, etc is made.
 * (this difference can occur either because the asp. source flags
 * are changed, or because a segblock with a new local representation
 * is completely stored in for example the wi_lrep, while at least one 
 * of the polyline attributes should be taken global.)
 */
drawsegonws(ws, seg, fun)
Wss	*ws;
Seg	*seg;
Int	fun;
{
	register Bool	unitsgmat;
	register Bhead	*bhead, *bh2;
	Gks	gksold;
	Gksi	gksisold;
	Wss	wssold;
	Wsis	wsistmp, *wis;
	Nc	*nc_vec, nc_vec2, *nctr;
	LineRep *lrep;
	MarkRep *mrep;
	AreaRep *frep;
	TextRep *trep;
	Int	cur_fl, cur_wis_fl;
	Nrect	nclipw;
	Int	n, ncsize = sizeof(Nc);
	Bool	chspacevec = TRUE;
	/* the character space vector is not in the segment.
	 * wi_cspvec must be correct when a ws_text() is called.
	 * the bool chspacevec records if a new vector is to
	 * be calculated.
	 */

	/* save old states to reinstall after while loop: */
	/*not necessary to copy whole statelist */
	ASS(gksold , *_gkss)
	ASS(gksisold , *gksis)
	ASS(wssold , *ws)

	bhead	= seg->sg_firstbh;

	/* no need to store current adress or contents of */
	/* ws->ws_wsis; see wssold and next 3 rules*/
	ASS(wsistmp , *(ws->ws_wsis))
	wis = ws->ws_wsis = &wsistmp;
	wis->wi_sgmat = (Tmat *)(&seg->sg_mat[0][0]);
	/*at the end of this fun ptr is set back to point to unity*/
	unitsgmat = unit_mat(&seg->sg_mat[0][0]);

	/*begin while loop in redraw seg\n");*/
	while (bhead != NULL) {/**begin while*********/
	   bh2 = bhead + 1;
	   switch(bhead->sb_typ) {/**begin switch*****/
	   case SG_PID:
		break;
	   case SG_CLP:
		Concat(&nclipw, &(ws->ws_curw), (Nrect *)bh2)
		ws_transf(ws, &(nclipw.n_ll),
			      &(wis->wi_clipr.d_ll));
		ws_transf(ws, &(nclipw.n_ur),
			      &(wis->wi_clipr.d_ur));
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sclpr)(ws,nclipw);
		}
#endif

		break;
	   case POL:
		if (((cur_wis_fl ^ cur_fl) & 07) != 0) {
			if ((cur_fl & 07) != 07)
				ASS(wis->wi_lrep, *lrep)
			if (cur_fl & 01)
				wis->wi_lrep.lr_lt = _gkss->gk_lrlt;
			if (cur_fl & 02)
				wis->wi_lrep.lr_lw = _gkss->gk_lrlw;
			if (cur_fl & 04)
				wis->wi_lrep.lr_ci = _gkss->gk_lrci;
			cur_wis_fl = cur_fl;
		}
		n = bhead->sb_sz / ncsize;
		if (unitsgmat == TRUE) 
			(*pws_pline)(ws, n, (Nc *)(bhead + 1));
		else {
			nctr = nc_trans(&seg->sg_mat[0][0],
				(Nc *)(bhead + 1), n, fun);
			(*pws_pline)(ws, n, nctr);
			FREE(nctr)
		}
		break;
	   case POM:
		if (((cur_wis_fl ^ cur_fl) & 070) != 0) {
			if ((cur_fl & 070) != 070)
				ASS(wis->wi_mrep, *mrep)
			if (cur_fl & 010)
				wis->wi_mrep.mr_mt = _gkss->gk_mrmt;
			if (cur_fl & 020)
				wis->wi_mrep.mr_ms = _gkss->gk_mrms;
			if (cur_fl & 040)
				wis->wi_mrep.mr_ci = _gkss->gk_mrci;
			cur_wis_fl = cur_fl;
		}
		n = bhead->sb_sz / ncsize;
		if (unitsgmat == TRUE) 
			(*pws_pmark)(ws, n, (Nc *)(bhead + 1));
		else {
			nctr = nc_trans(&seg->sg_mat[0][0],
					(Nc *)(bhead + 1), n, fun);
			(*pws_pmark)(ws, n, nctr);
			FREE(nctr)
		}
		break;
	   case TXT:
		if (((cur_wis_fl ^ cur_fl) & 01700) != 0) {
			if ((cur_fl & 01700) != 01700)
				ASS(wis->wi_trep, *trep)
			if (cur_fl & 0100) 
			 ASS(wis->wi_trep.tx_fp, _gkss->gk_txfp)
			if (cur_fl & 0200)
				wis->wi_trep.tx_chef= _gkss->gk_chef;
			if (cur_fl & 0400)
				wis->wi_trep.tx_chsp= _gkss->gk_chsp;
			if (cur_fl & 01000)
				wis->wi_trep.tx_ci = _gkss->gk_txci;
			cur_wis_fl = cur_fl;
			chspacevec = TRUE; /* can be more precise */
		}
		if (chspacevec == TRUE)  {
			s_wi_cspvec(wis);
			/*sets wis->wi_cspvec; code in u_wsensure.c*/
		}

		nctr =
		  nc_trans(&seg->sg_mat[0][0], (Nc *)(bhead+1), 1, fun);
		(*pws_text)(ws, (String)(bhead->sb_link + 1), nctr);
		FREE(nctr)
		bhead = bhead->sb_link;
		break;
	   case FAR:
		if (((cur_wis_fl ^ cur_fl) & 016000) != 0) {
			if ((cur_fl & 016000) != 016000)
				ASS(wis->wi_frep, *frep)
			if (cur_fl & 02000)
				wis->wi_frep.fa_is = _gkss->gk_fais;
			if (cur_fl & 04000)
				wis->wi_frep.fa_si = _gkss->gk_fasi;
			if (cur_fl & 010000)
				wis->wi_frep.fa_ci = _gkss->gk_faci;
			cur_wis_fl = cur_fl;
		}
		n = bhead->sb_sz / ncsize;
		if (unitsgmat == TRUE) 
			(*pws_farea)(ws, n, (Nc *)(bhead + 1));
		else {
			nctr = nc_trans(&seg->sg_mat[0][0],
				(Nc *)(bhead + 1), n, fun);
			(*pws_farea)(ws, n, nctr);
			FREE(nctr)
		}
		break;
	   case CELL:
		nctr = nc_trans(&seg->sg_mat[0][0], (Nc *)(bhead + 1), 4, fun);
		(*pws_cells)(ws, (Size *)(bhead->sb_link + 1), nctr);
		bhead = bhead->sb_link;
		FREE(nctr)
		break;
	   case GDP:
		/*still to do*/
		break;

	 /* more  cases, like attributes setting,
	     and window, viewports setting? */
	   case SG_ASF:
	   case S_ASF:
		cur_fl = *((Int *)bh2);
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sasf)(ws,cur_fl);
		}
#endif
		break;
	   case NTR:
	   /*no seg blocks for NTR */
		break;

	   case SG_PLI :
		lrep = (LineRep *)find_rep(ws->ws_line,sizeof(LineRep),
					ws->ws_nline, *((Bindex*)bh2));
		ASS(wis->wi_lrep , *lrep)
		cur_wis_fl &= ~07; 
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_spli)(ws,lrep->lr_ix);
		}
#endif
		break;
	   case SG_LT :
		_gkss->gk_lrlt = wis->wi_lrep.lr_lt = *((Ltype *)bh2);
		cur_wis_fl |= 01; 
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sln)(ws,_gkss->gk_lrlt);
		}
#endif
		break;
	   case SG_LW :
		_gkss->gk_lrlw = wis->wi_lrep.lr_lw = *((Lwidth *)bh2);
		cur_wis_fl |= 02; 
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_slwsc)(ws,_gkss->gk_lrlw);
		}
#endif
		break;
	   case SG_LCI :
		_gkss->gk_lrci = wis->wi_lrep.lr_ci = *((Cindex *)bh2);
		cur_wis_fl |= 04; 
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_splci)(ws,_gkss->gk_lrci);
		}
#endif
		break;
	   case SG_PMI :
		mrep = (MarkRep *)find_rep(ws->ws_mark,sizeof(MarkRep),
					ws->ws_nmark, *((Bindex*)bh2));
		ASS(wis->wi_mrep, *mrep)
		cur_wis_fl &= ~070;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_spmi)(ws,mrep->mr_ix);
		}
#endif
		break;
	   case SG_MT :
		_gkss->gk_mrmt = wis->wi_mrep.mr_mt = *((Mtype *)bh2);
		cur_wis_fl |= 010;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_smk)(ws,_gkss->gk_mrmt);
		}
#endif
		break;
	   case SG_MSZ :
		_gkss->gk_mrms = wis->wi_mrep.mr_ms = *((Msize *)bh2);
		cur_wis_fl |= 020;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_smksc)(ws,_gkss->gk_mrms);
		}
#endif
		break;
	   case SG_MCI :
		_gkss->gk_mrci = wis->wi_mrep.mr_ci = *((Cindex *)bh2);
		cur_wis_fl |= 040;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_spmci)(ws,_gkss->gk_mrci);
		}
#endif
		break;
	   case SG_TXI :
		trep = (TextRep *)find_rep(ws->ws_text,sizeof(TextRep),
					ws->ws_ntext, *((Bindex*)bh2));
		ASS(wis->wi_trep , *trep) 
		chspacevec = TRUE;/* can be more precise */
		cur_wis_fl &= ~01700;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_stxi)(ws,trep->tx_ix);
		}
#endif
		break;
	   case SG_TXFP:
		ASS(wis->wi_trep.tx_fp , *((FoPr *)bh2))
		ASS(_gkss->gk_txfp , *((FoPr *)bh2))
		cur_wis_fl |= 0100;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_stxfp)(ws,_gkss->gk_txfp);
		}
#endif
		break;
	   case SG_CHSP :
		_gkss->gk_chsp = wis->wi_trep.tx_chsp= *((Charsp *)bh2);
		cur_wis_fl |= 0200;
		chspacevec = TRUE;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_schsp)(ws,_gkss->gk_chsp);
		}
#endif
		break;
	   case SG_CHEF:
		_gkss->gk_chef = wis->wi_trep.tx_chef= *((Charef *)bh2);
		cur_wis_fl |= 0400;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_schxp)(ws,_gkss->gk_chef);
		}
#endif
		break;
	   case SG_TXCI:
		_gkss->gk_txci = wis->wi_trep.tx_ci = *((Cindex *)bh2);
		cur_wis_fl |= 01000;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_stxci)(ws,_gkss->gk_txci);
		}
#endif
		break;
	   case SG_CHV :
		/*2 blocks:*/
		nc_vec = (Nc *)bh2;
		vecrotate(&(nc_vec2.n_x), &(nc_vec->n_x),
			&seg->sg_mat[0][0]);
		ASS(gksis->gki_chvec , nc_vec2)
		vecrotate(&(wis->wi_chvec.d_x), &(nc_vec2.n_x),
			&wis->wi_mat[0][0]);
		chspacevec = TRUE;
		/* a new char height vector
		 * includes a new char space vector */

		bhead = bhead->sb_link;
		bh2 = bhead + 1;
		nc_vec = (Nc *)bh2;
		vecrotate(&(nc_vec2.n_x), &(nc_vec->n_x),
			&seg->sg_mat[0][0]);
		ASS(gksis->gki_cwvec , nc_vec2)
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_schup)(ws,
				gksis->gki_cwvec,gksis->gki_chvec);
		}
#endif
		vecrotate(&(wis->wi_cwvec.d_x), &(nc_vec2.n_x),
			&wis->wi_mat[0][0]);
		/*this width does not yet contain the char exp factor,
		 *as it was not yet known during storing this vector.
		 *the exp factor is to be taken from an, eventually
		 *changable, bundle.
		 *(exp factor is interpreted at drawing text)
		 */
		break;
	   case SG_FAI :
		frep = (AreaRep *)find_rep(ws->ws_area,sizeof(AreaRep),
					ws->ws_narea, *((Bindex*)bh2));
		ASS(wis->wi_frep , *frep)
		cur_wis_fl &= ~016000;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sfai)(ws,frep->fa_ix);
		}
#endif
		break;
	   case SG_FAIS :
		_gkss->gk_fais = wis->wi_frep.fa_is = *((Istyle *)bh2);
		cur_wis_fl |= 02000;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sfais)(ws,_gkss->gk_fais);
		}
#endif
		break;
	   case SG_FASI :
		_gkss->gk_fasi = wis->wi_frep.fa_si = *((Sindex *)bh2);
		cur_wis_fl |= 04000;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sfasi)(ws,_gkss->gk_fasi);
		}
#endif
		break;
	   case SG_FACI :
		_gkss->gk_faci = wis->wi_frep.fa_ci = *((Cindex *)bh2);
		cur_wis_fl |= 010000;
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sfaci)(ws,_gkss->gk_faci);
		}
#endif
		break;
	   case SG_PASZ :
		/*2 blocks are stored in the segment for this value!*/
		nc_vec = (Nc *)bh2;
		vecrotate(&(nc_vec2.n_x), &(nc_vec->n_x),
			&seg->sg_mat[0][0]);
		ASS(gksis->gki_xpatsiz , nc_vec2)
		vecrotate(&(wis->wi_xpatsiz.d_x), &(nc_vec2.n_x),
			&wis->wi_mat[0][0]);

		bhead = bhead->sb_link;
		bh2 = bhead + 1;
		nc_vec = (Nc *)bh2;
		vecrotate(&(nc_vec2.n_x), &(nc_vec->n_x),
			&seg->sg_mat[0][0]);
		ASS(gksis->gki_ypatsiz , nc_vec2)
		vecrotate(&(wis->wi_ypatsiz.d_x), &(nc_vec2.n_x),
			&wis->wi_mat[0][0]);
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_spa)(ws,
				gksis->gki_xpatsiz,gksis->gki_ypatsiz);
		}
#endif
		break;
	   case SG_PARP :
		nc_vec = (Nc *)bh2;
		vecmat(&(nc_vec2.n_x), &(nc_vec->n_x),
			&seg->sg_mat[0][0]);
		ASS(gksis->gki_patref, nc_vec2)
		vecmat(&(wis->wi_patref.d_x), &(nc_vec2.n_x),
			&wis->wi_mat[0][0]);
#ifdef METAFILE
		if (WSCAT == MO){
			(*MfScrn->m_sparf)(ws,
				gksis->gki_patref);
		}
#endif
		break;

	   default:
	        /*
		 *mssge( "default;  case %d\n",bhead->sb_typ);
		 */
		break;
	   }/******end switch****************************/

	   bhead = bhead->sb_link;
	} /*****end while loop***************************/
	 
	wis->wi_sgmat = (Tmat *)(&u_mat[0][0]);

	ASS(*_gkss , gksold)
	ASS(*gksis , gksisold)
	ASS(*ws , wssold)
}

Nc *
nc_trans(mat, ncold, n, fun)
Real	*mat;
Nc	*ncold;
Int	n, fun;
{	Int	i;
	Nc	*nc, *nc0;

	CALLOC(nc, Nc, (Int)n, fun)
	nc0 = nc;
	for (i = 0; i < n; i++) {
		vecmat((Real *)nc0, (Real *)ncold, mat); 
		ncold++; nc0++;
	}
	return(nc);
}
