/* @(#) u_ensure.c  version:1.11  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_ensure.c
 * SCCS id :	u_ensure.c 1.11
 * Last edited:	11/20/84 10:37:37
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * This file contains the code of the following functions:
 *	ensure()
 * 	ch_mark()
 *	st_mark()
 *	tr_mark()
 *	cl_mark()
 * Bool	sure()
 *	sg_mark()
 *	static sg_ensure()
 *	setcurmat()
 *	
 */

#define GKS 2
#define GKS1
#define GKS2
#define GKS8

#include "cgksincl.h"

/*
 * The following functions and variables are used here,
 * but are externally defined:
 */
extern	Nrect	 ndc;
extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	Bhead	*lastbh;

extern		 msk_openws();
extern		 ntransf();
extern		 scale();
extern	char	*seg_block();
extern		 set_mat();
extern	double	 sqrt();


/*Int 	attmark[]= ; some systems wants to have the size */
Int 	attmark[33]= {
		 /* 0*/0777, 0777, 0777, 0777, 0777,
		 /* 5*/0777, 0777, 0777, 0777, 0777,
		 /*10*/0777, 0777, 0777, 0777, 0777,
		 /*15*/0777, 0777, 0777, 0777, 0777,
		 /*20*/0777, 0777, 0777, 0777, 0777,
		 /*25*/0777, 0777, 0777, 0777, 0777,
		 /*30*/0777, 0777, 0777 
		};


/*
 * SURE checks if a segment block must be created for
 * the attribute of type TYP.
 * the typedef of TYP is STRYP.
 * L is the number of TYPs that is going to be stored.
 * SOURCE points to the place where the info to be stored
 * is currently located.
 */
#define SURE(TYP, STRYP, L, SOURCE) \
	{   if(sure(TYP)) {\
		STRYP *str = (STRYP *)seg_block(sizeof(STRYP), TYP, L);\
		ASS(*str , SOURCE)\
		attmark[TYP] = ID; \
	    }\
	}

/*
 * indicate that the specified attribute is changed 
 */
ch_mark(typ)
Int typ;
{
	attmark[typ] |= CH;
}

/*
 * indicate that the specified attribute is to be stored during ensure
 */
st_mark(typ)
Int typ;
{
	attmark[typ] |= ST;
}

/*
 * indicate that the specified attribute is to be 
 * transformed during ensure()
 */
tr_mark(typ)
Int typ;
{
	attmark[typ] |= TR;
}

/*
 * clear specified attribute marks in attmark[]
 */
cl_mark(typ)
Int typ;
{
	attmark[typ] = ID;
}

/*
 * sure() returns TRUE if (one of) the attribute marks for
 * type typ is != 0,
 * i.e. is changed, transformed and/or stored
 */
Bool
sure(typ)
Int typ;
{
	return((Bool)(attmark[typ] != ID));
}

/*
 * If segment is open, sg_mark() marks that the specified
 * attribute type is changed.
 * (causing eventually a new block to be stored)
 */
sg_mark(att_typ) 
Int att_typ;
{
	if (gkstate == SGOP) attmark[att_typ] |= CH;
}

/*
 * ensure() takes care that for the outputprimitives of type `prt'
 * all the attribute settings in the global internal
 * statelist etc. are correct.
 */
ensure(prt)
Int	prt;
{
	Real	x, y, labda;
	Wc	wht;   
	
	if(attmark[NTR] != ID) {
		setcurmat(_gkss->gk_curnt);
		if (_gkss->gk_clip == TRUE) msk_openws(WS_CLP);
		tr_mark(SG_TXI);
		tr_mark(SG_CHV);
		tr_mark(SG_PASZ);
		tr_mark(SG_PARP);
		/* for OP level > 0 more marks */
		if ((attmark[SG_CLP] & CH) == 0) ch_mark(SG_CLP);
		attmark[NTR] = ID;
	}

	/*following not executed for input functions*/

	if (prt==POL || prt==POM || prt==TXT || prt==GDP || prt==FAR) {
	     switch (prt) {
	     case FAR:
		/*transform gks->gk_patsz and gks->gk_patref, 
	 	 *and store into gksis fields.
	 	 *pattern size is not translated, only scaled.
	 	 */
		if((attmark[SG_PASZ] & TR) != 0 ||
		   (attmark[SG_PASZ] & CH) != 0) { 
			/*due to the fact that an inserted segment
			 *may cause a rotation on SX and SY of
			 *s_patsiz() a seperate vector must be kept
			 *for both SX and SY
			 */
			gksis->gki_xpatsiz.n_x =
			    _gkss->gk_patsiz.w_x * gksis->gki_mat[0][0];
			gksis->gki_xpatsiz.n_y = 0.0;

			gksis->gki_ypatsiz.n_x = 0.0;
			gksis->gki_ypatsiz.n_y =
			    _gkss->gk_patsiz.w_y * gksis->gki_mat[1][1];

			st_mark(SG_PASZ);
			attmark[SG_PASZ] &= ~TR;
			attmark[SG_PASZ] &= ~CH;
			msk_openws(WS_PASZ);
		}
		if((attmark[SG_PARP] & TR) != 0 ||
		   (attmark[SG_PARP] & CH) != 0) { 
			ntransf(&_gkss->gk_patref, &gksis->gki_patref);
			st_mark(SG_PARP);
			attmark[SG_PARP] &= ~TR;
			attmark[SG_PARP] &= ~CH;
			msk_openws(WS_PARP);
		}
		break;
	    case TXT:
		if((attmark[SG_CHV] & TR) != 0 ||
		   (attmark[SG_CHV] & CH) != 0) { 
		   /*can be refined*/
			x = _gkss->gk_chup.w_x;
			y = _gkss->gk_chup.w_y;
			labda = _gkss->gk_chht / 
				sqrt((double)(x * x + y * y));
			wht.w_x = labda * x;
			wht.w_y = labda * y;
			scale(gksis->gki_mat, &wht, &gksis->gki_chvec);
			wht.w_x = labda * y; 
			wht.w_y = labda * x * -1.0;
			scale(gksis->gki_mat, &wht, &gksis->gki_cwvec);
			attmark[SG_CHV] &= ~TR;
			attmark[SG_CHV] &= ~CH;
			st_mark(SG_CHV);
			msk_openws(WS_CHV);
			msk_openws(WS_CWV);
			/*char exp fac can't be interpreted here
			 *(because you still don't known if it will
			 *be taken global or local)
			 */
		}
		break;
	    default:
		break;
	    }

	    if(gkstate == SGOP && gksis->gki_sgact == TRUE)
		sg_ensure(prt);
	}
}

/*
 * sg_ensure() creates segment blocks for the appropriate attributes 
 * for an output primitive of type `prt'.
 * this creation is only done if the attribute is changed
 * since the last time the attribute is stored in this segment, or
 * the attribute is not yet stored at all.
 */
static
sg_ensure(prt)
Int prt;
{
	static Int flags;
	Int markold;

	if (_gkss->gk_clip == TRUE) {
		SURE(SG_CLP, Nrect, 1, _gkss->gk_curnt->nt_view)
	}
	else {
		SURE(SG_CLP, Nrect, 1, ndc)
	}

	SURE(SG_PID, Pickid, 1, _gkss->gk_pikid)

	flags = _gkss->gk_asf;
	SURE(SG_ASF, Int, 1, flags)
	switch(prt) {
	case POL:
		if ((flags & 07) != 07) 
			SURE(SG_PLI, Bindex, 1, _gkss->gk_line)
		if (flags & 01) 
			SURE(SG_LT,  Ltype,  1, _gkss->gk_lrlt)
		if (flags & 02) 
			SURE(SG_LW,  Lwidth, 1, _gkss->gk_lrlw)
		if (flags & 04) 
			SURE(SG_LCI, Cindex, 1, _gkss->gk_lrci)
		break;
	case POM:
		if ((flags & 070) != 070)
			SURE(SG_PMI, Bindex, 1, _gkss->gk_mark)
		if (flags & 010)
			SURE(SG_MT,  Mtype,  1, _gkss->gk_mrmt)
		if (flags & 020) 
			SURE(SG_MSZ, Msize,  1, _gkss->gk_mrms)
		if (flags & 040) 
			SURE(SG_MCI, Cindex, 1, _gkss->gk_mrci)
		break;
	case TXT:
		if ((flags & 01700) != 01700) 
			SURE(SG_TXI, Bindex, 1, _gkss->gk_text)
		if (flags & 0100) 
			SURE(SG_TXFP, FoPr,   1, _gkss->gk_txfp)
		if (flags & 0200) 
			SURE(SG_CHEF, Charef, 1, _gkss->gk_chef)
		if (flags & 0400) 
			SURE(SG_CHSP, Charsp, 1, _gkss->gk_chsp)
		if (flags & 01000) 
			SURE(SG_TXCI, Cindex, 1, _gkss->gk_txci)

		markold = attmark[SG_CHV];
		SURE(SG_CHV, Nc, 1, gksis->gki_chvec)
		attmark[SG_CHV] = markold;
		SURE(SG_CHV, Nc, 1, gksis->gki_cwvec)
		break;
	case FAR:
		if ((flags & 016000) != 016000)	 
			SURE(SG_FAI, Bindex, 1, _gkss->gk_area)
		if (flags & 02000) 
			SURE(SG_FAIS, Istyle, 1, _gkss->gk_fais)
		if (flags & 04000) 
			SURE(SG_FASI, Sindex, 1, _gkss->gk_fasi)
		if (flags & 010000) 
			SURE(SG_FACI, Cindex, 1, _gkss->gk_faci)
		/*If style index is taken from the (changable)
		 *bundle, always store, if necessary, the pattern info,
		 *as it is not possible here to find out if 
		 *style index used for the fillarea is PATTERN:
		 */
		if ((flags & 02000) == 0/*interior style from bundle*/||
		    _gkss->gk_fais == PATTERN) {
			/*as SURE clears the attmark[] the first time
			 *attmark value is saved temporarily
			 */
			markold = attmark[SG_PASZ];
			SURE(SG_PASZ, Nc, 1, gksis->gki_xpatsiz)
			attmark[SG_PASZ] = markold;
			SURE(SG_PASZ, Nc, 1, gksis->gki_ypatsiz)
			SURE(SG_PARP, Nc, 1, gksis->gki_patref)
		}

		break;
	default:
		break;
	}
}

setcurmat(nt)
Ntran *nt;
{
	set_mat((Real *)(&nt->nt_wind),(Real *)(&nt->nt_view),
		&gksis->gki_mat[0][0], FALSE);
}
