/* @(#) u_free.c  version:1.3  dated:84/11/23 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.u_free.c
 * SCCS id :	u_free.c 1.3
 * Last edited:	11/23/84 08:26:11
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 10
#define GKS10
#define GKS1
#include "cgksincl.h"

extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	GksState gkstate;
extern	Gksd	*gksd;
extern	Gkse	*gkse;
extern	Bhead	*lastbh;

/*
 * emergency actions.
 * emer_actions() also performed at a call of GKS emergency() .
 * code is here to prevent loop in UNIX tsort between emergency.o and
 * er_hand.o
 */
emer_actions() /*clean and close*/
{
	Int	i;
	Wss	*ws;

	/*a)*/
	if (gkstate == SGOP) {
		/*close segment*/
		_gkss->gk_opsg->sg_lastbh = lastbh;
		_gkss->gk_opsg = NULL;
		lastbh = NULL;
		gkstate = WSAC;
	}

	/*b) and c)*/
	if (gkstate == WSAC){
		i = 0;
		while ((ws = _gkss->gk_actv[i++]) != NULL) {
			ws->ws_actv = FALSE;
		}
		gkstate = WSOP;
	}

	/*c)*/

	/*d)*/
	if (gkstate == WSOP) {
		i = 0;
		while ((ws = _gkss->gk_opws[i++]) != NULL) {
			   /* free all entries of ws gotten
			    * dynamically with [mcre]alloc() :
			    */
			   free_wss(ws);

		    	   if (ws->ws_wsd->wd_cat != WISS &&
		    	       ws->ws_wsd->wd_cat != MO &&
		    	       ws->ws_wsd->wd_cat != MI) {
				  if (WsScrn->s_clos)
					{
					(*WsScrn->s_clos)(ws);
				}
			   }
#ifdef METAFILE
			   if (ws->ws_wsd->wd_cat == MO) {
				(*MfScrn->m_clwk)(ws);
				/* route end item to metafile */
			   }
#endif
			   FREE(ws)
	   	}

		/* e) */
		/*close gks*/
		free_gkslists();
		/* rm_msgfile();   /*see er_handi.h. */
		/* call not include to prevent tsort to find a loop*/
	   	gkstate = GKCL;
	}
}

/*
 * code of the following function here to prevent lorder;tsort to
 * give a loop
 */
free_gkslists()
{
/*Actually, at opening a statelist, all the pointers should be
 *initialized at NULL, to prevent them causing errors
 *being not NULL, although they are not pointing to
 *memory allocated via malloc/calloc.
 */
	Int i, j, k;
	register Wsd	*wsd;

	for (i = 0; i< gksd->gd_nrwt; i++) {
		wsd = gksis->gki_wsd[i];
		/*when adding new alloc's in u_wsdinit.c
		 *add new free's here
		 */
		if (wsd->wd_cat == OUTPUT || wsd->wd_cat == OUTIN) {
			PattRep *patt;
			FREE(wsd->wd_line)
			FREE(wsd->wd_mark)
			FREE(wsd->wd_text)
			FREE(wsd->wd_area)
			patt = wsd->wd_patt;
			for (j = 0; j < wsd->wd_npatt; j++) {
				FREE(patt->pa_ci)
				patt++;
			}
			FREE(wsd->wd_patt)
			FREE(wsd->wd_fopr)
			FREE(wsd->wd_col)
			if (wsd->wd_ngdp != 0) 
				FREE(wsd->wd_gdp) 
			FREE(wsd->wd_istyl)
			FREE(wsd->wd_hatst)
		}
		if (wsd->wd_cat == INPUT || wsd->wd_cat == OUTIN) {
			for (j = 0; j < 6; j++) {
			     	for (k=0; k != wsd->wd_ndevs[j]; k++)
				    FREE(wsd->wd_ddesc[j] [k].idd_pets)
			     	FREE(wsd->wd_ddesc[j])
			}
		}
		FREE(wsd)
	}
	FREE(gksis->gki_wsd)
	FREE(gksis->gki_ntp)

	for (i = 0; i< gksd->gd_nntran; i++) FREE(_gkss->gk_ntran[i])
	FREE(_gkss->gk_opws)
	FREE(_gkss->gk_actv)
	FREE(_gkss->gk_ntran)
	/*the ws statelists itself(!) are already freed
	 *after closing the workstation
	 */
	FREE(gksd->gd_avwt)
	FREE(gksis)
	/*No need to free gk_opsg, and gk_curnt.
	 *No need to free gk_segs as they are all gone
	 *after closing the last workstation.
	 */
	FREE(_gkss)
	FREE(gksd)
	FREE(gkse)
#ifdef  MALL_DBG
	mad_rest(C_GKS);
#endif
}

free_wss(ws)
Wss	*ws;
{
	Int i, j;

	if (ws->ws_wsd->wd_cat == OUTIN ||
	    ws->ws_wsd->wd_cat == INPUT) {
		for (j = 0; j != ws->ws_wsd->wd_ndevs[5]; j++)  {
			FREE(ws->ws_devs[5] [j].id_ival.ev_str)/*ok?*/
		}
		for (i = 0; i < 6; i++) FREE(ws->ws_devs[i])
	}
	FREE(ws->ws_colr)
	FREE(ws->ws_wsis)
	if (ws->ws_wsd->wd_cat == OUTIN ||
	    ws->ws_wsd->wd_cat == OUTPUT) {
		FREE(ws->ws_line)
		FREE(ws->ws_mark)
		FREE(ws->ws_text)
		FREE(ws->ws_area)

	}

	dl_sgs_ws(ws);
	/*for FREE(ws) see close_ws()*/
}

/*Delete all Seginst from ws.
 *If the ws associated with the segment belonging to
 *a Seginst was the last ws associated with that segment
 *then delete the segment and delete its Seginst
 *from global statelist:
 */
dl_sgs_ws(ws)
Wss	*ws;
{
	Seg	*seg;
	Seginst	*segi, *seginext;
	Int	i;

	seginext = ws->ws_segs;
	while (seginext) {
	    segi = seginext;
	    seginext = segi->si_next;
	    seg = segi->si_this;
	    FREE(segi)

	    if (seg != NULL) ws_sg_del(ws, seg);
	}

	ws->ws_segs = NULL;
}

/*
 * take workstation ws out of list of associated ws with segment seg.
 * if there isn't any ws left associated with seg, then
 * delete segment (fr_segi() and free_sg() ).
 */
ws_sg_del(ws, seg)
Wss	*ws;
Seg	*seg;
{
	register Int i;
	for (i = 0; i < gksd->gd_nwsas; i++)
		if (seg->sg_onws[i] == ws)
			seg->sg_onws[i] = NULL;

	for (i = 0; i < gksd->gd_nwsas && 
			seg->sg_onws[i] == NULL; i++)
		;

	if (i == gksd->gd_nwsas) {
		fr_segi(seg, &(_gkss->gk_segs));
		free_sg(seg);
	}
}
