/* @(#) u_freecheck.c  version:1.5  dated:84/11/23 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_freecheck.c
 * SCCS id :	u_freecheck.c 1.5
 * Last edited:	11/23/84 09:33:38
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#include "cgksincl.h"

#define NR_ADR 4000

static 	Bool full = FALSE;/*if full this test doesn't work any longer*/
static 	int last = -1;
static	Int addresses[NR_ADR];
static  Bool firstadd = TRUE;

mad_add(address, rout) /*add memory address */
Int address, rout;
{	int j = 0;

	if (firstadd == TRUE) {
		for (j = 0; j < NR_ADR; j++) addresses[j] = 0;
		firstadd = FALSE;
	}

	if (full == FALSE) {
		j = 0;
		while (j < NR_ADR && addresses[j] != 0) j++;
		if (j == NR_ADR) full = TRUE;
		else {
			addresses[j] = address;
			if (j > last) last = j;
		}
	}
}

mad_del(address, rout) /*delete memory address*/
Int address, rout;
{	int j = 0;

	if (full == FALSE) {
		while (j <= last && addresses[j] != address) j++;
		if (j > last) {
			mssge("in routine %d: j=%d, last=%d",
				rout,j,last);
			mssge("tried to free address %d not in list\n",
				address);
		}
		else { 	addresses[j] = 0;
			if (j == last) 
				while (last >= 0 && addresses[last] == 0)
					last--;
		}
	}
}

/*check if all is freed at this point*/
/*will be called from close_gks*/
mad_rest(rout)
Int	rout;
{
	int i;
	if (full == FALSE) {
		if (last >= 0) 
			for (i = 0; i <= last; i++) {	
				if (addresses[i] != 0) 
				    mssge("addresses[%d]=%d not free\n",
					i, addresses[i]);
			}
		/*
		else 	mssge("all freed; last = %d\n",last);
		*/
	}
}
