/* @(#) u_initinp.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_initinp.c
 * SCCS id :	u_initinp.c 1.5
 * Last edited:	11/19/84 19:24:24
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


/*
 * This file contains some utility functions used by the
 * "GKS initialize input" functions (section 6.1):
 *
 * int  ch_idev()
 * int  ch_petno()
 * int  ch_devno()
 * int  ch_er_id()
 *      st_idev()
 * Bool nc_in_nrect()
 */

#define GKS 6
#define GKS6

#include "cgksincl.h"

int
ch_idev(ws, dn, pet, ea, iclass, rout)
Wss	*ws;
Devno	dn;
Pet	pet;
Drect	*ea;
Iclass 	iclass;
Int 	rout;
{	int i;

	Ch_State(7, rout);
	Ch_Er_Ws(ws, 7, rout);

	if ((i=ch_er_id(ws, ea, dn, iclass, rout)) != 0)  return(i);
	if ((i=ch_devno(ws, iclass, dn, rout)) != 0)      return(i);
	if ((i=ch_petno(ws, iclass, dn, pet, rout)) != 0) return(i);
	return(0);
}

int
ch_er_id(ws, ea, dn, iclass, rout)
Wss	*ws;
Drect	*ea;
Devno	dn;
Iclass	iclass;
Int	rout;
{
	register Idevice *idev;
	Int class = (Int)iclass;

	idev = &(ws->ws_devs[class] [dn - 1]);

	if (IsntRect( ea) )  
		Rep_Er(51, rout);
	if (idev->id_mode != REQUEST) 
		Rep_Er(141, rout);
	if ( IsntRange(ea, &(ws->ws_wsd->wd_maxsurf)) ) 
		Rep_Er(145, rout);
	return(0);
}

int
ch_devno(ws, iclass, dn, rout)
Wss	*ws;
Iclass	iclass;
Devno	dn;
Int 	rout;
{
	if ( (Int)dn != 0 && 
	     (Int)dn <= ws->ws_wsd->wd_ndevs[(Int)iclass] )
		return(0);
	Rep_Er(140, rout);
}

int
ch_petno(ws, iclass, dn, pet, rout)
Wss	*ws;
Iclass	iclass;
Devno	dn;
Pet	pet;
{
	Int i;
	Iddescr	*idd = &(ws->ws_wsd->wd_ddesc[(Int)iclass] [dn-1]);
	for (i = 0; i < idd->idd_npet; i++) {
		if ( pet == idd->idd_pets[i]) return(0);
	}
	Rep_Er(144, rout);
}

Bool
nc_in_nrect(nrect, nc)
Nrect	*nrect;
Nc	*nc;
{
	return  (Bool) ((nc->n_x >= nrect->n_ll.n_x ) &&
		    (nc->n_y >= nrect->n_ll.n_y ) &&
		    (nc->n_x <= nrect->n_ur.n_x ) &&
		    (nc->n_y <= nrect->n_ur.n_y )
		   ); 
}

st_idev(idev, pet, ea, dr)
Idevice	*idev;
Pet	pet;
Drect	*ea;
Drecord	*dr;
{
	idev->id_pet  = pet;
	ASS(idev->id_area , *ea)
	ASS(idev->id_drec , *dr)
}
