/* @(#) u_itpetcatt.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itpetcatt.c
 * SCCS id :	u_itpetcatt.c 1.6
 * Last edited:	11/9/84 15:36:46
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#include "mi_itp.h"

#ifdef METAFILE

/*
 *	set fill area index
 */
i_sfai	(lrec, datrec)
Size lrec;
char **datrec;
{
	Bindex i;

	GET_INT(i,datrec,Bindex)

	s_fa_i(i);
}

/*
 *	set fill area interior style
 */
i_sfais	(lrec, datrec)
Size lrec;
char **datrec;
{
	Istyle i;

	GET_INT(i,datrec,Istyle)

	s_fa_is(i);
}

/*
 *	set fill area style index
 */
i_sfasi	(lrec, datrec)	
Size lrec;
char **datrec;
{
	Sindex i;

	GET_INT(i,datrec,Sindex)

	s_fa_si(i);
}

/*
 *	set fill area colour index
 */
i_sfaci	(lrec, datrec)
Size lrec;
char **datrec;
{
	Cindex i;

	GET_INT(i,datrec,Cindex)

	s_fa_ci(i);
}
 
/*
 *	set pattern size
 */
i_spa	(lrec, datrec)
Size lrec;
char **datrec;
{
	Int i;
	Wss *ws;
	Nc xpatsiz, ypatsiz;

	GET_REAL(xpatsiz.n_x,datrec,Real)
	GET_REAL(xpatsiz.n_y,datrec,Real)

	GET_REAL(ypatsiz.n_x,datrec,Real)
	GET_REAL(ypatsiz.n_y,datrec,Real)

	if (	xpatsiz.n_x != gksis->gki_xpatsiz.n_x ||
		xpatsiz.n_y != gksis->gki_xpatsiz.n_y ||
		ypatsiz.n_x != gksis->gki_ypatsiz.n_x ||
		ypatsiz.n_y != gksis->gki_ypatsiz.n_y ) {

		gksis->gki_xpatsiz = xpatsiz;
		gksis->gki_ypatsiz = ypatsiz;

		ch_mark(SG_PASZ);
	}

	/*
 	 * pattern sizes are routed to active workstations
 	 * of category MO:
 	 */
	for (i = 0; i<gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL &&
			ws->ws_wsd->wd_cat == MO) {
			(*MfScrn->m_spa)(ws,gksis->gki_xpatsiz,
					gksis->gki_ypatsiz);}

	}
}
 
/*
 *	set pattern reference point
 */
i_sparf	(lrec, datrec)
Size lrec;
char **datrec;
{
	Nc patref;

	GET_REAL(patref.n_x,datrec,Real)
	GET_REAL(patref.n_y,datrec,Real)

		
	if (	patref.n_x != gksis->gki_patref.n_x ||
		patref.n_y != gksis->gki_patref.n_y ) {

		gksis->gki_patref = patref;

		ch_mark(SG_PARP);
	}
/*
 *	patttern reference point is routed to all
 *	active workstations of category MO
 */
	MF_GEOMATT(m_sparf,gki_patref)
}
 
/*
 *	set ASPECT SOURCE FLAGs	
 */
i_sasf	(lrec, datrec)
Size lrec;
char **datrec;
{
	Int i, fac, term;

	term = 0;
	
	for (i = 0; i<13; i++){
		GET_INT(fac,datrec,Int)
		term = 2*term + fac;
	}

	s_asflags((Asflags)term);
}


 
i_spkid	(lrec, datrec)	/* set pick identifier	*/
Size lrec;
char **datrec;

{
	Pickid i;

	GET_INT(i,datrec,Pickid)


	s_pikid(i);
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /* METAFILE */
