/* @(#) u_itpoutpr.c  version:1.7  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itpoutpr.c
 * SCCS id :	u_itpoutpr.c 1.7
 * Last edited:	11/27/84 12:27:12
 *
 * Author:	Miente Bakker , Paul ten Hagen, Behr de Ruiter
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
#define GKS2
#define GKS7
#define GKS 7

#include	"mi_itp.h"

#ifdef METAFILE

extern Int attmark[];

extern	Fun 	pws_pline;
extern	Fun	pws_pmark;
extern 	Fun	pws_text;
extern	Fun	pws_farea;
extern	Fun	pws_cells;
extern	Fun	pws_gdp;

Nc	*sg_sp_pr();
char	*seg_block();

/*
 *	polyline
 */
i_pl(lrec, datrec)
Size lrec ;
char	**datrec;
{
	Nc *pr;
	Size n;
	Int i;

	GET_INT(n,datrec,Size)

	ensure(POL);
	pr = sg_sp_pr(n,POL);

	for (i=0; i<n; i++) {
		GET_REAL(pr[i].n_x,datrec,Real)
		GET_REAL(pr[i].n_y,datrec,Real)
	}

	sf_pline(pws_pline);/*this function sets the pws_pline to
			    *ws_pline, and causes inclusion of
			    *w_polyline.o
			    */

	pr_to_all_ws(n, NULL, NULL, pr, POL);
	fr_sgblock((char*)pr);
	cl_mark(PLATT);
}

/*
 *	polymarker
 */
i_pm(lrec, datrec)
Size lrec ;
char	**datrec;
{
	Nc *pr;
	Size n;
	Int i;

	GET_INT(n,datrec,Size)

	ensure(POM);
	pr = sg_sp_pr(n,POM);

	for (i=0; i<n; i++) {
		GET_REAL(pr[i].n_x,datrec,Real)
		GET_REAL(pr[i].n_y,datrec,Real)
	}

	sf_pmark(pws_pmark);

	pr_to_all_ws(n, NULL, NULL, pr, POM);
	fr_sgblock((char*)pr);
	cl_mark(PMATT);
}

/*
 *	text
 */
i_tx(lrec,datrec)
Size lrec ;
char	**datrec;
{
/*	
 *	auxiliary variables to prevent the geometrical text
 *	attributes from being overwrtiiten by ensure
 */
	Nc chvec, cwvec;
/*
 *	end of insertion
 */

	Nc *pr;
	String st;
	String str;
	String sg_st_str();
	Int i, slen;

/*
 *	the character vectors are written to the local
 *	vectors chvec and cwvec
 */
	chvec = gksis->gki_chvec;
	cwvec = gksis->gki_cwvec;
/*
 *	end copying
 */

	pr = sg_sp_pr(1,TXT);
	ensure(TXT);

	GET_REAL(pr->n_x,datrec,Real)
	GET_REAL(pr->n_y,datrec,Real)

	GET_INT(slen,datrec,Int)

	CALLOC(st,char,1+slen,TXT)


	for (i = 0; i<=slen; i++) {
		st[i] = datrec[0][i];
	}


	str = sg_st_str(st,TXT);

	sf_text(pws_text);
/*
 *	the character vectors are now copied back to gksis
 */
	gksis->gki_chvec = chvec;
	gksis->gki_cwvec = cwvec;
/*
 *	end back copying
 */

	pr_to_all_ws(1,NULL,str,pr,TXT);


	fr_sgblock((char *)pr);
	cl_mark(TXATT);
	fr_sgblock((char *)str);
	FREE(st)

}

/*
 *	fill area
 */
i_fa(lrec,datrec)
Size lrec ;
char	**datrec;
{
/*	
 *	auxiliary variables to prevent the geometrical fill area
 *	attributes from being overwrtiiten by ensure
 */
	Nc xpatsiz, ypatsiz, patref;	
/*
 *	end of insertion
 */
	Nc *pr;
	Size n;
	Int i;

	GET_INT(n,datrec,Size)

/*
 *	begin insertion
 */
	xpatsiz = gksis->gki_xpatsiz;
	ypatsiz = gksis->gki_ypatsiz;
	patref = gksis->gki_patref;
/*
 *	end insertion
 */
	ensure(FAR);
	pr = sg_sp_pr(n,FAR);

	for (i=0; i<n; i++) {
		GET_REAL(pr[i].n_x,datrec,Real)
		GET_REAL(pr[i].n_y,datrec,Real)
	}

	sf_farea(pws_farea);
	
/*
 *	begin insertion
 */
	gksis->gki_xpatsiz = xpatsiz;
	gksis->gki_ypatsiz = ypatsiz;
	gksis->gki_patref = patref;
/*
 *	end insertion
 */
	pr_to_all_ws(n, NULL, NULL, pr, FAR);
	fr_sgblock((char*)pr);
	cl_mark(FAATT);
}

/*
 *	cell array
 */
i_ca(lrec,datrec)
Size lrec ;
char	**datrec;
{
	Nc *p;
	Size *pri, *sgsp_cells();

	Cindex *ct;
	Size nrow, ncol;
	Int i, j;

	ensure(CELL);
	p = sg_sp_pr(4,CELL);

	GET_REAL(p[0].n_x,datrec,Real)
	GET_REAL(p[0].n_y,datrec,Real)
	
	GET_REAL(p[2].n_x,datrec,Real)
	GET_REAL(p[2].n_y,datrec,Real)
	
	GET_REAL(p[1].n_x,datrec,Real)
	GET_REAL(p[1].n_y,datrec,Real)

	p[3].n_x = p[2].n_x - p[1].n_x + p[0].n_x;
	p[3].n_y = p[2].n_y - p[1].n_y + p[0].n_y;

	GET_INT(nrow,datrec,Size)
	GET_INT(ncol,datrec,Size)

	CALLOC(ct,Cindex,nrow*ncol,CELL)

	for (i = 0; i<nrow; i++) {
		for (j = 0; j<ncol; j++) {
			GET_INT(*ct,datrec,Cindex)
			ct++;
		}
	}

	pri = sgsp_cells(nrow, ncol, ct);

	sf_cells(pws_cells);
	pr_to_all_ws(4,ct,NULL,p,CELL);

	fr_sgblock(p);
	fr_sgblock((Nc *)pri);

}
	
/*
 *	general drawing primitive
 */
i_gdp	(lrec,datrec)
Size lrec ;
char	**datrec;
{
	sf_gdp(pws_gdp);
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
