/* @(#) u_itprepr.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itprepr.c
 * SCCS id :	u_itprepr.c 1.6
 * Last edited:	11/9/84 15:37:03
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS7
#define GKS 7

#include	"mi_itp.h"

#ifdef METAFILE

/*
 *	set polyline representation
 */
i_splr	(lrec,datrec)	
Size	lrec;
char	**datrec;
{
	Int i;
	Wss *ws;
	LineRep lrep;

	GET_INT(lrep.lr_ix,datrec,Bindex)
	
	GET_INT(lrep.lr_lt,datrec,Ltype)
	GET_REAL(lrep.lr_lw,datrec,Lwidth)
	GET_INT(lrep.lr_ci,datrec,Cindex)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS) {
				pl_rep(ws,&lrep);
		}
	}

}

/*
 *	set polymarker representation
 */
i_spmr	(lrec,datrec) 
Size	lrec;
char	**datrec;
{
	Int i;
	Wss *ws;
	MarkRep mrep;

	GET_INT(mrep.mr_ix,datrec,Bindex)
	
	GET_INT(mrep.mr_mt,datrec,Mtype)
	GET_REAL(mrep.mr_ms,datrec,Msize)
	GET_INT(mrep.mr_ci,datrec,Cindex)


	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS) {
				pm_rep(ws,&mrep);
		}
	}
}
/*
 *	set fill area representation
 */
i_sfar	(lrec,datrec)
Size	lrec;
char	**datrec;
{
	Int i;
	Wss *ws;
	AreaRep farep;

	GET_INT(farep.fa_ix,datrec,Bindex)
	
	GET_INT(farep.fa_is,datrec,Istyle)
	GET_INT(farep.fa_si,datrec,Sindex)
	GET_INT(farep.fa_ci,datrec,Cindex)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS) {
				fa_rep(ws,&farep);
		}
	}
}

/*
 *	set pattern representation
 */

i_spar	(lrec,datrec)	
Size	lrec;
char	**datrec;
{}

/*
 *	set colour representation
 */
i_scr	(lrec,datrec)	
Size	lrec;
char	**datrec;
{
	Int i;
	Wss *ws;
	Cindex ci;
	Colour col;

	GET_INT(ci,datrec,Cindex)
	
	GET_REAL(col.c_red,datrec,Real)
	GET_REAL(col.c_green,datrec,Real)
	GET_REAL(col.c_blue,datrec,Real)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS) {
				col_rep(ws,ci,&col);
		}
	}
}

/*
 *	set text representation
 */
i_stxr	(lrec,datrec)
Size	lrec;
char	**datrec;
{
	Int i;
	Wss *ws;
	TextRep txrep;

	GET_INT(txrep.tx_ix,datrec,Bindex)
	
	GET_INT(txrep.tx_fp.fp_fo,datrec,Tfont)
	GET_INT(txrep.tx_fp.fp_pr,datrec,Tprec)
	GET_REAL(txrep.tx_chef,datrec,Charef)
	GET_REAL(txrep.tx_chsp,datrec,Charsp)
	GET_INT(txrep.tx_ci,datrec,Cindex)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS) {
				tx_rep(ws,&txrep);
		}
	}
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
