/* @(#) u_itpsegfns.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itpsegfns.c
 * SCCS id :	u_itpsegfns.c 1.5
 * Last edited:	11/9/84 15:37:07
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
/* interpretation of GKSMI segment functions */

#define GKS7

#include "mi_itp.h"

#ifdef METAFILE

/*
 *	create segment
 */
i_crsg	(lrec,datrec)
Size lrec;
char **datrec;
{
	Segname sn;
	Seg *sg, *newseg();
	GET_INT(sn,datrec,Segname)
	sg =newseg(sn);
}

/*
 *	close segment
 */
i_clsg	(lrec,datrec)
Size lrec;
char **datrec;
{	closeg();
}

/*
 *	rename segment
 */
i_rensg	(lrec,datrec)
Size lrec;
char **datrec;
{
	Segname old, new;

	GET_INT(old,datrec,Segname)
	GET_INT(new,datrec,Segname)

	renameseg(old,new);
}

/*
 *	delete segment
 */
i_dsg	(lrec,datrec)	/*	delete segment	*/
Size lrec;
char **datrec;
{
	Segname name;
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname);

	seg = segbyname(name,M_DSG);

	zapseg(seg);
}

/*
 *	set segment transformation
 */
i_ssgt	(lrec,datrec)
Size lrec;
char **datrec;
{
	Segname name;
	Real Mat [2][3];
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname)

	GET_REAL(Mat[0][0], datrec, Real)
	GET_REAL(Mat[0][1], datrec, Real)
	GET_REAL(Mat[0][2], datrec, Real)
	GET_REAL(Mat[1][0], datrec, Real)
	GET_REAL(Mat[1][1], datrec, Real)
	GET_REAL(Mat[1][2], datrec, Real)

	seg = segbyname(name,M_SSGT);

	transeg(seg,(Tmat *)Mat);
}

/*
 *	set segment visibility
 */
i_svis	(lrec,datrec)
Size lrec;
char **datrec;
{	
	Segname name;
	Bool vis;
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname)
	GET_INT(vis,datrec,Bool)

	seg = segbyname(name,M_SVIS);

	s_segvis(seg,vis);
}

/*
 *	set segment highlighting
 */
i_shlit	(lrec,datrec)	/*	set segment highlighting	*/
Size lrec;
char **datrec;
{	
	Segname name;
	Bool hlit;
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname)
	GET_INT(hlit,datrec,Bool)

	seg = segbyname(name,M_SHLIT);

	s_hilite(seg,hlit);
}

/*
 *	set segment priority
 */
i_ssgp	(lrec,datrec)	
Size lrec;
char **datrec;
{	
	Segname name;
	Segpri pri;
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname)
	GET_REAL(pri,datrec,Segpri)

	seg = segbyname(name,M_SSGP);

	s_segpri(seg,pri);
}

/*
 *	set segment detectability
 */
i_sdtec	(lrec,datrec)	
Size lrec;
char **datrec;
{	
	Segname name;
	Bool dtec;
	Seg *seg, *segbyname();

	GET_INT(name,datrec,Segname)
	GET_INT(dtec,datrec,Bool)

	seg = segbyname(name,M_SHLIT);

	s_detect(seg,dtec);
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
