/* @(#) u_newframe.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_newframe.c
 * SCCS id :	u_newframe.c 1.5
 * Last edited:	10/19/84 13:43:23
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


/*
 * This file contains utility functions for the GKS outputfunctions:
 * newframe()
 * ws_irg()
 */

#define GKS 2
#define GKS1
#define GKS2
#define GKS8

#include "cgksincl.h"

/*
 *externally defined functions:
 */
extern def_acts();	/*see file u_defacts.c*/

extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksi	*gksis;

/*
 * Either the value "newframe action neccessary at update" is 
 * set to TRUE, or the newframe action is performed.
 */
newframe(ws, fun)
Wss	*ws;
Int	fun;
{
	if (ws->ws_waitr == TRUE) {
		ws->ws_newfr = TRUE;
	}
	else { /*perform implicit regeneration */	
		def_acts(ws, fun);
	}
}

/*
 * ws_irg handles 3) i) on page 44 (GKS report 7.2)
 * ws_irg performs an implicit regeneration after a call
 * of polyline, polymark, text, fillarea, cellarray, gen.dr.primitive
 * or insert segment if:
 * 1) a segment is open (and active; see our manual section about
 *    extension of GKS).
 * 2) if the workstation description table entry for  
 *    "dynamic modification accepted for segment priority" 
 *    is IMM (5th bit from right in wd_dmas = 1)
 *
 * Not yet added is a test to see if primitives are added to
 * open segment overlapping a segment of higher priority.
 */
ws_irg(ws, fun)
Wss 	*ws;
Int	fun;
{
	if (gkstate == SGOP &&
	    gksis->gki_sgact == TRUE &&
	    ((ws->ws_wsd->wd_dmas & 020) != 0) 
	    /* && ws supports segment priority */ ) {
		/*(check if there is a seg with higher prio)*/
		/*add more checks to see if update is necessary*/
			newframe(ws, fun);
	}
}
