/* @(#) u_pixelscan.c  version:1.2  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.u_pixelscan.c
 * SCCS id :	u_pixelscan.c 1.2
 * Last edited:	11/13/84 13:41:15
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 2
#define GKS2

#include "cgksincl.h"

Bool
rotmat(mat)
Real	*mat;
{
	return((Bool)(*(mat + 1) != 0.0 || *(mat + 3) != 0.0));
}


/*
 * this function is called in w_cellarray.c and w_fillarea.c.
 * therefore it resides in a seperate file 
 */
Bool
pixelscan(ws, pr, n, m, ccols, nr_line, ic, pattern)
Wss	*ws;
Nc	*pr;	/*4 ndc corners of the boundary of cellarray,
 		 *or of the transformed pattern box,
		 *after segment transf, and insert transformation
		 */
Size	n, m;
Cindex	*ccols;	/* n*m colours */
Int	nr_line;/*number of pairs of Dc in ic */
Ic	*ic;	/*pairs of start/stop Dc endpoints */
Bool	pattern;/*false if this fun is used for cellarray(), true if fun
		 *is used for fillarea with interior style pattern*/
{
	register Int xcap, x;
	register int ihor, jver;
	register Real	xinv, yinv;
	register Cindex curcol, col;
	Cindex	*cols, *colsptr, *ci, *cifirst=NULL, *ciptr;
	Ic	*icb, *ice;
	Nc	np[4];
	Int	*runs, *runsptr, l, y, nr, xb, alternate;
	Tmat	ibothmat, Nc_to_grd, Dc_to_grd, isegmat, iwsmat;
	Bool	onepxlmode = FALSE, rotate;

	invers_mat(*(ws->ws_wsis->wi_sgmat), &isegmat[0][0], FAR);
	for (l = 0; l < 4; l++) {
	    TRANS(isegmat, pr[l].n_x, pr[l].n_y, np[l].n_x, np[l].n_y)
	}
	/* now np[] is supposed to be a rectangle.
	 * this is not true however if the GKS function insert-segment
	 * is used with some rotation in either the insert 
	 * transformations or the transf of the inserted segment.
	 * This bug will be fixed in the following release.
	 */

	Nc_to_grd[0][0] =              (Real)n /(np[2].n_x -np[1].n_x);
	Nc_to_grd[0][1] = 0;
	Nc_to_grd[0][2] = -np[1].n_x * (Real)n /(np[2].n_x -np[1].n_x);
	Nc_to_grd[1][0] = 0;
	Nc_to_grd[1][1] =              (Real)m /(np[0].n_y -np[1].n_y);
	Nc_to_grd[1][2] = -np[1].n_y * (Real)m /(np[0].n_y -np[1].n_y);

	invers_mat(ws->ws_wsis->wi_mat, &iwsmat[0][0], FAR);
	matmat(isegmat, iwsmat,  &ibothmat[0][0]);
	matmat(Nc_to_grd, ibothmat, &Dc_to_grd[0][0]);

	rotate = rotmat(&Dc_to_grd[0][0]);
	ci = ccols;
	CALLOC(runs, Int, (WsScrn->s_size.i_x+1), FAR)
	CALLOC(cols, Cindex, (WsScrn->s_size.i_x+1), FAR)

	l = 0;
	while (++l <= nr_line) {
		colsptr = cols;
		runsptr = runs;
		icb = ic++;
		ice = ic++;
		x = xb = xcap = icb->i_x ;
		if (x > ice->i_x) continue;
		y = icb->i_y ;
		if (rotate == FALSE)  {
			yinv = Dc_to_grd[1][1] * y + Dc_to_grd[1][2];
			if (pattern == FALSE) {
			    jver = (yinv < 0) ? 0 :
				(yinv >= (Real)m) ? m-1 : (Int)yinv;
			}
			else {
				if (yinv >= 0.0) 
					jver = ((int)yinv) % m;
				else {	jver = ((int)(yinv-1)) % (int)m;
					/* -1 to get floor */
					if (jver < 0) jver += m;
				}
			}
		}

		alternate = 0;

		while (x <= ice->i_x) {
			if (rotate == FALSE)
			    	xinv =
			          Dc_to_grd[0][0] * x + Dc_to_grd[0][2];
			else {
				TRANS(Dc_to_grd, x, y, xinv, yinv)
			}

			if (pattern == FALSE) {
			    ihor = (xinv < 0) ? 0 :
				(xinv >= (Real)n) ? n-1 : (Int)xinv;
			    if (rotate == TRUE)
			      jver = (yinv < 0) ? 0 :
				(yinv >= (Real)m) ? m-1 : (Int)yinv;
			}
			else {
				if (xinv >= 0.0) 
					ihor = ((int)xinv) % n;
				else  {	ihor = ((int)(xinv-1)) %(int)n;
					if (ihor < 0) ihor += n;
				}

				if (rotate == TRUE) {
				   if (yinv >= 0.0) 
					jver = ((int)yinv) % m;
				   else { jver = ((int)(yinv-1))%(int)m;
					  if (jver < 0) jver += m;
				   }
				}
			}
			col = ci[ihor + n * jver];

			if (onepxlmode == FALSE) {
			   if (x == xb) curcol = col;
			   else if (curcol != col) {
			   	/*draw colour curcol to (x-1, y): */
				*runsptr++ = x - xcap;
				*colsptr++ = curcol;
				curcol = col;
				xcap = x;
				alternate++;
			   }
			}
			else  	*(ciptr++) = col;

			x++;
		}
		/* now scanline is ended.
		 * call a DI/DD function:
		 */
		if (onepxlmode == FALSE) {
			*runsptr = x - xcap;
			*colsptr = curcol;
			alternate++;
			/* test on WsScrn->s_runl done before call
			 * pixelscan()
			 */
			(*WsScrn->s_runl)
			   	(ws, icb, alternate, runs, cols);
		}
		else {
			nr = (ice->i_x - icb->i_x + 1);
			/* test on WsScrn->s_pxst already done below*/
			(*WsScrn->s_pxst)
			   	(ws, icb, nr, cifirst, FALSE);
			ciptr = cifirst;
		}
		fflush(ws->ws_ofile);

		/* decide how to do the next scanline */
		if (onepxlmode == FALSE &&
		    alternate > (ice->i_x - icb->i_x)/ 2) {
			/*draw remaining scanlines with onepixelmode*/
			if (WsScrn->s_pxst)
				onepxlmode = TRUE;
			/* if s_pxst not available it has no sense to
			 * do it the one_pix_at_atime way 
			 */
			CALLOC(cifirst, Cindex, (WsScrn->s_size.i_x+1),
				FAR)
			ciptr = cifirst;
		}
	}
	FREE(cifirst)
	FREE(runs)
	FREE(cols)
}
		/*
			value8(255);
			nr = (ice->i_x - icb->i_x + 1);
			ciptr = cifirst;
			while (nr > 255) {
				value8(254);
				i = 254;
				while (i-- != 0) value8(*(ciptr++));
				nr -= 254;
				value8(0);
				prefix(ESC);
				command(AedWHU);
				value8(255);
			}
			value8(nr);
			while (nr-- != 0) value8(*(ciptr++));
			ciptr = cifirst;
		*/
