/* @(#) u_removesg.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_removesg.c
 * SCCS id :	u_removesg.c 1.5
 * Last edited:	10/19/84 13:43:15
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 5
#define GKS5
#include	"cgksincl.h"

extern	Gksd	*gksd;

/*Delete the Seginst associated with seg from the linked 
 *list of Seginst's.  If there isn't any Seginst with 
 *si_this = seg then FALSE is returned.
 */	
Bool
fr_segi(seg, firstsegi)
Seg	*seg;
Seginst	**firstsegi;
{	Seginst	*segi = *firstsegi;
	while (segi != NULL && segi->si_this != seg) 
		segi = segi->si_next;
	if (segi) {
		if (segi->si_next)
			segi->si_next->si_prev = segi->si_prev;

		if (segi->si_prev)
			segi->si_prev->si_next = segi->si_next;
		else	*firstsegi = segi->si_next;

		FREE(segi)
		return(TRUE);
	}
	else	return(FALSE);
}

/*Delete the Seginst having a pointer to seg, from all
 *workstations associated with the segment.
 */
sgioutws(seg)
Seg	*seg;
{
	Wss	*ws;
	Int	i;

	for (i = 0; i < gksd->gd_nwsas; i++)
		if ((ws = seg->sg_onws[i]) != NULL) {
			fr_segi(seg, &(ws->ws_segs));
		}
}

/*Free the segments memory */
free_sg(seg)
Seg	*seg;
{	Bhead	*bh, *bhnext;

	bhnext = seg->sg_firstbh;
	while (bhnext) {
		bh = bhnext;
		bhnext = bhnext->sb_link;
		FREE(bh)
	}
	FREE(seg->sg_onws) /*?*/
	FREE(seg)
}
