/* @(#) u_reqinp.c  version:1.9  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_reqinp.c
 * SCCS id :	u_reqinp.c 1.9
 * Last edited:	11/20/84 10:28:44
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


/*
 * This file contains some utility functions used by the
 * "GKS request input" functions (section 6.3):
 *
 * setinvnmat()
 * eras_inp_area()
 * setic()
 * fd_rct_dr_bnd()
 * faderect()
 *
 */

#define GKS 6
#define GKS6

#include "cgksincl.h"

#define INPC 200

extern	Gksi	*gksis;

setic(area, ic)
Drect	*area;
Ic	*ic;
{
	ic[0].i_x = ic[1].i_x = area->d_ll.d_x;
	ic[2].i_y = ic[1].i_y = area->d_ur.d_y;
	ic[2].i_x = ic[3].i_x = area->d_ur.d_x;
	ic[0].i_y = ic[3].i_y = area->d_ll.d_y;
}

fd_rct_dr_bnd(ws, ic, col)
Wss	*ws;
Ic	*ic;
Cindex	col;
{
	Screen *scr = WsScrn;
	Ic s[5];
	Int i;

	if ( scr->s_colr){
		(*scr->s_colr)(ws, 0);
		(*scr->s_rect)(ws, &ic[0], &ic[2]);
		(*scr->s_colr)(ws, col);
	}
	for (i = 0; i < 4; i++) ASS(s[i], ic[i])
	ASS(s[4], ic[0])
	(*scr->s_line)(ws, 5, s, SOLIDL, 1.0);
	/*keep in mind that current col ( s_ccol ) is now col */
}

faderect(ws, dcll, dcur)
Wss	*ws;
Dc	*dcll, *dcur;
{
	Ic icll, icur;
	Screen *scr = WsScrn;
	Cindex oldci = scr->s_ccol;

	dc_to_ic(&icll, dcll);
	dc_to_ic(&icur, dcur);
	if (scr->s_colr) {
		(*scr->s_colr)(ws, 0);
		if (scr->s_rect) (*scr->s_rect)(ws, &icll, &icur);
		(*scr->s_colr)(ws, oldci);
	}
	else {
		;
	}
}

eras_inp_area(ws, idev)
Wss	*ws;
Idevice	*idev;
{
	Drect	*area = &(idev->id_area);
	faderect(ws, &area->d_ll, &area->d_ur);
}

/*
 * store the inverse transformation of one of the
 * normalization transformations, specified by nt,
 * in the internal global statelist gksis.
 */
setinvnmat(nt)
Ntran *nt;
{
	register Real *mat;
	Real ux, vy;

	ux = (nt->nt_wind.w_ur.w_x - nt->nt_wind.w_ll.w_x) /
       	     (nt->nt_view.n_ur.n_x - nt->nt_view.n_ll.n_x);
	vy = (nt->nt_wind.w_ur.w_y - nt->nt_wind.w_ll.w_y) /
	     (nt->nt_view.n_ur.n_y - nt->nt_view.n_ll.n_y);
	mat = &(gksis->gki_imat[0][0]);
	*mat++ = ux;
	*mat++ = 0.0;
	*mat++ = nt->nt_wind.w_ll.w_x - ux * nt->nt_view.n_ll.n_x;
	*mat++ = 0.0;
	*mat++ = vy;
	*mat++ = nt->nt_wind.w_ll.w_y - vy * nt->nt_view.n_ll.n_y;
}
