/* @(#) u_scanlines.c  version:1.7  dated:84/11/23 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_scanlines.c
 * SCCS id :	u_scanlines.c 1.7
 * Last edited:	11/23/84 11:03:15
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 2
#define GKS2
#define GKS1

#include "cgksincl.h"
typedef struct edge {
	struct edge	*e_link;
	Int	 	e_ymax;
	Real		e_xmin, e_slope;
	} Edge;

int
creat_et(edge_table, s, nr_edges, lscl, uscl)
Edge	**edge_table;
Ic	*s;
Int	nr_edges, lscl, uscl;
{
	Int	i = 0, ymin;
	int	ret = 0;
	Ic	*start, *end, *prev;
	register Edge *nedge;
	register Edge	*pedge, **ppedge = &edge_table[0];

	end = s;
	prev = &s[nr_edges - 1];
	for (i = 0; i < uscl - lscl + 1; ppedge++, i++)
		*ppedge = NULL; 
	i = 0;
	while (i != nr_edges) {
		start = end;
		if (i == nr_edges - 1) 	end = s;
		else			end++;

		if (start->i_y != end->i_y) {
		  MALLOC(nedge, Edge, sizeof(Edge), RAS_SC+600)

		  nedge->e_link = NULL;
		  nedge->e_slope = (start->i_x - end->i_x) /
			 	 (Real)(start->i_y - end->i_y);
		  if (start->i_y > end->i_y) { 
			nedge->e_ymax = start->i_y;
			nedge->e_xmin = end->i_x;
			ymin = end->i_y - lscl;
			if (prev->i_y > start->i_y)
				(nedge->e_ymax)--;
			ret += (start->i_y - end->i_y + 1);
		  }
		  else {	nedge->e_ymax = end->i_y;
			nedge->e_xmin = start->i_x;
			ymin = start->i_y - lscl;
			if (prev->i_y < start->i_y) {
				ymin++;
				nedge->e_xmin += nedge->e_slope;
			}
			ret += (end->i_y - start->i_y + 1);
		  }

		  /* if (ymin != nedge->e_ymax) {  ?*/
		  ppedge = &edge_table[ymin];
		  while ((pedge = *ppedge) != NULL &&
		      pedge->e_xmin < nedge->e_xmin) {
			ppedge = &(pedge->e_link);
		  }
		  if (pedge == NULL) *ppedge = nedge;
		  else  {
			nedge->e_link = pedge;
			*ppedge = nedge; 
		  }
		  prev = start;
		}
		i++;
	}
	return(ret);/*total nr of lineends; probably little bit to large*/
}

merge_et_aet(pact_et, p_et)
Edge	**pact_et, *p_et;
{
	Edge 	*p_aet = *pact_et, **plink = pact_et;

	if (p_aet == NULL || p_et->e_xmin < p_aet->e_xmin)
		*pact_et = p_et;

	while (p_et != NULL && p_aet != NULL) {
		if (p_et->e_xmin < p_aet->e_xmin) {
			*plink = p_et;
			p_et = p_et->e_link;
			(*plink)->e_link = p_aet;
			plink = &((*plink)->e_link);
		}
		else {	
			plink = &(p_aet->e_link);
			p_aet = p_aet->e_link;
			if (p_aet == NULL) *plink = p_et;
		}
	}
}

upd_aet(pact_et, scl)
Edge	**pact_et;
Int	scl;
{	Edge	*pedge, **plink = pact_et;
	Int 	i = 0;

	while ((pedge = *plink) != NULL) {
		if (pedge->e_ymax == scl) {
			*plink = pedge->e_link;
			FREE(pedge)
		}
		else {	pedge->e_xmin += pedge->e_slope;
			plink = &(pedge->e_link);
			i++;
		}
	}
	if (*pact_et != NULL) x_sort(pact_et, i);
}

x_sort(pact_et, nr)
/*improve*/
Edge	**pact_et;
Int	nr;
{	register Int 	i, j;
	register Edge	**plink, **prevlink, *p_tmp;

	p_tmp = *pact_et;
	while (p_tmp->e_link != NULL &&
		p_tmp->e_xmin <= p_tmp->e_link->e_xmin)
			p_tmp = p_tmp->e_link;
	if (p_tmp->e_link != NULL) {
	   j = nr;
	   for (i = 1; i < nr; i++) {
		prevlink = pact_et;
		plink = &((*prevlink)->e_link);
		j = nr - i;
		while (j-- != 0) {
			if ((*prevlink)->e_xmin > (*plink)->e_xmin) {
				p_tmp = *prevlink;
				*prevlink = *plink; 
				*plink = (*plink)->e_link;
				(*prevlink)->e_link = p_tmp;
				prevlink = &((*prevlink)->e_link);
			}
			else if (j != 0) {
				prevlink = plink;
				plink = &((*plink)->e_link);
			}
		}
	    }
	}
}

/*According to F & vD :*/
/*scanlines() accepts nr_edges of corners (pointed to by s)
 *and returns *lines_nr of scanlines pointed to by the returned
 *value.
 */
Ic *
scanlines(ws, nr_edges, lines_nr, s, lscl, uscl)
Wss	*ws;
Size	nr_edges, *lines_nr;
Ic	*s;
register Int	lscl, uscl;
{
	Int	allc_nr ;
	register Int	scl;
	Ic	*ic_ret, *icp;
	Edge	**edge_table, *act_et, *pedge;

	CALLOC(edge_table, Edge *,  (uscl-lscl+1), RAS_SC+700)
	allc_nr = creat_et(edge_table, s, nr_edges, lscl, uscl);
	CALLOC(ic_ret, Ic,  allc_nr, RAS_SC)
	/* freeing of this ic_ret is done in w_fillarea.c */
	icp = ic_ret;

	scl = lscl;
	act_et = NULL;
	allc_nr = 0;

	do{
		if (edge_table[scl - lscl] != NULL)
			merge_et_aet(&act_et, edge_table[scl - lscl]);

		pedge = act_et;

		while (pedge != NULL && pedge->e_link != NULL) {
			icp->i_x     = (Int)(pedge->e_xmin+0.5);
			(icp+1)->i_x = (Int)(pedge->e_link->e_xmin+0.5);
			icp->i_y     = scl;
			(icp+1)->i_y = scl;

			pedge = pedge->e_link->e_link;
			icp += 2;
			allc_nr += 2;
		}
		upd_aet(&act_et, scl);
		scl++;
	} while (scl != uscl + 1);

	*lines_nr = allc_nr / 2;
	/*nr of endpoints is 2 times nr of lines*/

	FREE(edge_table) /*ok here?*/
	return(ic_ret);
}
