/* @(#) u_transf.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_transf.c
 * SCCS id :	u_transf.c 1.5
 * Last edited:	10/19/84 13:42:21
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


/*
 * The functions in this file:
 * isntrect()
 * isntrange()
 * are used among others by the GKS transformation functions.
 */

#define GKS 4
#define GKS4

#include "cgksincl.h"


/*
 * A rectangle is defined by lowerleft and upperright.
 * isntrect() returns 0 (FALSE) if lowerleft.x < upperright.x and
 * lowerleft.y < upperright.y
 */
isntrect(r)
Real *r;	/*pointer to lowerleft.x */
{	return ( r[0] >= r[2] || r[1] >= r[3] );
}

/*
 * A rectangle is defined by lowerleft and upperright.
 * isntrange() returns 1 (TRUE) if rectangle *r (r points to 
 * lowerleft.x of the first rectangle) is completely inside
 * rectangle *s (s points to lowerleft.x of the 2nd rectangle).
 */
isntrange(r,s)
Real *r, *s;
{
	return( s[0] > r[0] || s[1] > r[1] || 
		r[2] > s[2] || r[3] > s[3]  );
}
