/* @(#) u_wsdinit.c  version:1.9  dated:84/11/21 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_wsdinit.c
 * SCCS id :	u_wsdinit.c 1.9
 * Last edited:	11/21/84 14:04:06
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *This file contains functions to initialize the workstation
 *description tables.
 *These functions are called during open_gks().
 */
#define GKS1
#define GKS 1
#include "cgksincl.h"

Bool	getentry();
Bool	skptoinfo();
Int	getinfo();
Int	store();
Int	rd_wsdcap();
Int	get_int();
Int	get_oct();
Real	get_real();
Iddescr	*find_idd();

#define Skipchar(b)	(b)++;

/*wsd_creat() allocates memory for a ws. descr. table
 *of type wtype
 */
Int
wsd_creat(wsdpa, wtype)
Wsd	**wsdpa;	
String	wtype;
{
	File	*fp;
	Int 	i;

	MALLOC(*wsdpa, Wsd, sizeof(Wsd), O_GKS)

	if ((fp = fopen(WSDCAP, "r")) == NULL) 
		Rep_Er(900, O_GKS);
	/* by putting this statement in open_gks()
	 * and giving the filepointer to wsd_creat() as a
	 * parameter it is possible to open the wsdcap
	 * file just once. 
	 * However it is then necessary for the workstation
	 * entries to be in the proper order.
	 */

	i = rd_wsdcap(*wsdpa, fp, wtype);
	if (i != 0) Rep_Er(i, O_GKS);
	fclose(fp);
	return(i);
}

/*rd_wsdcap() reads the contents for the wsd of type `wstype'
 *from the file fp, containing all the capabilities
 *of all the ws.
 */
Int
rd_wsdcap(wsd, fp, wtype)
register Wsd *wsd;
File	*fp;
String 	wtype;
{
	char 	buff[128];
	register Int 	er;

	s_wsd_null(wsd);
	if (getentry(fp, wtype) == FALSE) return(905);
	if (skptoinfo(fp) == FALSE)	return(906);
	while (getinfo(fp, buff) != 0) {
		if ((er = store(wsd, buff)) != 0) return(er);
	}
	return(0);
}

/*To prevent a call of free at close_gks on a wsd pointer 
 *field being not allocated via calloc/malloc, but having 
 *a pointer not equal NULL, all relevant pointers are set to 
 *NULL.
 *If you are sure that these field are always initialized by the
 *system with NULL you can remove this function , and its call
 *in the function rd_wsdcap().
 */
s_wsd_null(wsd)
Wsd	*wsd;
{
	Int i;
	wsd->wd_nline = 0; wsd->wd_line = (LineRep *)NULL;
	wsd->wd_nmark = 0; wsd->wd_mark = (MarkRep *)NULL;
	wsd->wd_ntext = 0; wsd->wd_text = (TextRep *)NULL;
	wsd->wd_narea = 0; wsd->wd_area = (AreaRep *)NULL;
	wsd->wd_npatt = 0; wsd->wd_patt = (PattRep *)NULL;
	wsd->wd_ltyp  = NULL;
	wsd->wd_lwth  = NULL;
	wsd->wd_mktyp = NULL;
	wsd->wd_mksz  = NULL;
	wsd->wd_fopr  = NULL;
	wsd->wd_chef  = NULL;
	wsd->wd_chht  = NULL;
	wsd->wd_istyl = NULL;
	wsd->wd_hatst = NULL;
	wsd->wd_patt  = NULL;
	wsd->wd_col   = NULL;
	wsd->wd_gdp   = NULL;
	for ( i = 0; i < 6; i++) wsd->wd_ddesc[i] = NULL;
}

/*getentry search on the file *fp for a string `wtype'.
 *It presumes that only the first two characters are relevant,
 *and that the wtype comes at the beginning of a line.
 */
Bool
getentry(fp, wtype)
File *fp;
String wtype;
{
	register int c;
	while ( (((c=fgetc(fp)) != wtype[0]) && c != EOF) ||
	       	(((c=fgetc(fp)) != wtype[1]) && c != EOF) 
	      )
		while ((c=fgetc(fp)) != '\n' && c != EOF) 
		;

	return((Bool)(c != EOF));
}

Bool
skptoinfo(fp)
File *fp;
{
	register int c;

	while ((c=fgetc(fp)) != ':'  && c != EOF) ;
	return((Bool)(c != EOF));
}

Int
getinfo(fp, buff)
File	*fp;
String	buff;
{
	register Int i = 0;
	register int c;
	while ((c = fgetc(fp)) != ':' && c != EOF && c != '\n') { 
		if (c == '\\') {
			/*skip newline and other chars */
			while ((c = fgetc(fp)) != ':') 
				if (c == EOF) return(0);
				/*Returning from here is dirty.
				 *However a nice solution will need
				 *an (almost always failing) extra
				 *test in one of the above rules.
				 */
		}
		else {	buff[i++] = c;
		}
	}
	buff[i] = '\0';
	return(i);
}

/*
 * `buff' is supposed to contain a typical
 * character string: two letters, an `=' sign, and
 * some real(s)/int(s), eventually seperated by `#' signs. 
 * buff contains the contents for a wsd entry.
 * (to do: split 906 in more error numbers to make error message more
 * understandable).
 */
static
Int
store(wsd, buff)
Wsd	*wsd;
register String	buff;
{
	char	*b4 = &(buff[3]);
	Int	err = 0;
	Int	i;
	static	FoPr	*foprec;
	static 	Bindex	lix = 10, mix = 10, tix = 10 , fix = 10;
	static	Bindex  is_ix = 10, hs_ix = 10, fp_ix = 10, gd_ix = 10;
	/*10 is an arbitrary value */
	static	LineRep	*lr;
	static	MarkRep	*mr;
	static	TextRep	*tr;
	static	AreaRep	*fr;
	static	Colour	*cl;
	static	Gdp	*gd;
	static Istyle	*i_style;
	static Sindex	*hstyl;
	Iddescr	*iddptr;

	/*There isn't hardly any error checking on the format of  
	 *the wsdcap file, and the info is supposed to be correct, 
	 *and in the proper order. The category field, "wc", must be
	 *the first field of the entry.
	 */

	if (buff[2] != '=')  {
		err = 907;
	}
	else
	switch (buff[0]) {
	case 'w':
		switch (buff[1]) {
		case 'c': wsd->wd_cat = get_int(&b4); break;
		case 'r': wsd->wd_rov = get_int(&b4); break;
		default : err = 908; break;
		}
		break;
	case 'd':
		switch (buff[1]) {
		case 'r': wsd->wd_dmar = get_oct(&b4); break;
		case 's': wsd->wd_dmas = get_oct(&b4); break;
		case 'f': wsd->wd_defr = (Defmode)(get_int(&b4));break;
		case 'w': wsd->wd_waitr = (Bool)(get_int(&b4)); break;
		default : err = 908; break;
		}
		break;
	case 'x':
		switch (buff[1]) {
		case 's': get_rct(&(wsd->wd_maxsurf.d_ll.d_x), &b4);
			  break;
		default : err = 908; break;
		}
		break;
	case 'l':
		switch (buff[1]) {
		case 'n': break;
		case 't': break;
		case 'm': break;
		case 'w': break;
		case 'i': i = wsd->wd_nline = get_int(&b4); 
			  CALLOC(wsd->wd_line, LineRep, i, O_GKS)
			  lr = wsd->wd_line;
			  lix = 1;
			  break;
		case 'r': 
			  if (lix > wsd->wd_nline) {
				err = 909; break;
			  }
			  getlrep(lr, &b4);
			  lr->lr_ix = lix++;
			  lr++;
			  break;
		default : err = 908; break;
		}
		break;
	case 'm':
		switch (buff[1]) {
		case 'n': break;
		case 'a': break;
		case 's': break;
		case 'z': break;
		case 'i': i = wsd->wd_nmark = get_int(&b4); 
			  CALLOC(wsd->wd_mark, MarkRep, i, O_GKS)
			  mr = wsd->wd_mark;
			  mix = 1;
			  break;
		case 'r':
			  if (mix > wsd->wd_nmark) {
				err = 909; break;
			  }
			  getmrep(mr, &b4); mr->mr_ix = mix++;
			  mr++;

			  break;
		default : err = 908; break;
		}
		break;
	case 't':
		switch (buff[1]) {
		case 'f': i = wsd->wd_nfopr = get_int(&b4);
			  CALLOC(wsd->wd_fopr, FoPr, i, O_GKS)
			  fp_ix = 1;
			  foprec = &(wsd->wd_fopr[0]);
			  break;
		case 'p':
			  if (fp_ix++ > wsd->wd_nfopr) {
				err = 909; break;
			  }
			  foprec->fp_fo = (Tfont)(get_int(&b4));
			  foprec->fp_pr = (Tprec)(get_int(&b4));
			  foprec++;
			  break;
		case 'e': break;
		case 'x': break;
		case 'n': break;
		case 'h': break;
		case 'i':  i = wsd->wd_ntext = get_int(&b4); 
			  CALLOC(wsd->wd_text, TextRep, i, O_GKS)
			  tr = wsd->wd_text;
			  tix = 1;
			  break;
		case 'r': 
			  if (tix > wsd->wd_ntext) {
				err = 909; break;
			  }
			  gettrep(tr, &b4);
			  tr->tx_ix = tix++;
			  tr++;
			  break;
		default : err = 908; break;
		}
		break;
	case 'f':
		switch (buff[1]) {
		case 's': i = wsd->wd_nistyl = get_int(&b4);
			  CALLOC(wsd->wd_istyl, Istyle, i, O_GKS)
			  i_style = wsd->wd_istyl;
			  is_ix = 1;
			  break;
		case 't':
			  if (is_ix++ > wsd->wd_nistyl) {
				err = 909; break;
			  }
			  *i_style = (Istyle)(get_int(&b4));
			  i_style++;
			  break;
		case 'h':
			  i = wsd->wd_nhatst = get_int(&b4);
			  CALLOC(wsd->wd_hatst, Sindex, i, O_GKS)
			  hstyl = wsd->wd_hatst;
			  hs_ix = 1;
			  break;
		case 'c':
			  if (hs_ix++ > wsd->wd_nhatst) {
				err = 909; break;
			  }
			  *hstyl = get_int(&b4);
			  hstyl++;
			  break;
		case 'i': i = wsd->wd_narea = get_int(&b4); 
			  CALLOC(wsd->wd_area, AreaRep, i, O_GKS)
			  fr = wsd->wd_area;
			  fix = 1;
			  break;
		case 'r':
			  if (fix > wsd->wd_narea) {
				err = 909; break;
			  }
			  getfrep(fr, &b4); 
			  fr->fa_ix = fix++;
			  fr++;
			  break;
		default : err = 908; break;
		}
		break;
	case 'p':
		switch (buff[1]) {
		case 'i': break;
		case 'r': break;
		default : err = 908; break;
		}
		break;
	case 'c':
		switch (buff[1]) {
		case 'x': wsd->wd_ncix = get_int(&b4); break;
		case 'a': wsd->wd_colav  = (Bool)get_int(&b4); break;
		case 'n': i = wsd->wd_ncol = get_int(&b4);
			  CALLOC(wsd->wd_col, Colour, i, O_GKS)
			  cl = wsd->wd_col;
			  break;
		case 'c':
			  getcol(cl, &b4); cl++;
			  break;
		default : err = 908; break;
		}
		break;
	case 'g':
		switch (buff[1]) {
		case 'n': i = wsd->wd_ngdp = get_int(&b4); 
			  CALLOC(wsd->wd_gdp, Gdp, i, O_GKS)
			  gd = wsd->wd_gdp;
			  gd_ix = 1;
			  break;
		case 'g':
			  if (gd_ix++ > wsd->wd_ngdp) {
				err = 909; break;
			  }
			  getgdp(gd, &b4); gd++;
			  break;
		default : err = 908; break;
		}
		break;
	case 'a':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 0, &b4); break;
		case 'd': iddptr = find_idd(wsd, LOCATOR, &b4);
			  get_crd(&(iddptr->idd_idev.id_ival.ev_loc.loc_pt.w_x), &b4);
			  iddptr->idd_idev.id_drec.loc_rec.loc_col =
				get_int(&b4);
			  break;
		default : err = 908; break;
		}
		break;
	case 'o':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 1, &b4); break;
		case 'd': iddptr = find_idd(wsd, STROKE, &b4);
			  iddptr->idd_idev.id_drec.stk_rec.stk_col =
				get_int(&b4);
			  break;
		default : err = 908; break;
		}
		break;
	case 'u':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 2, &b4); break;
		case 'd': iddptr = find_idd(wsd, VALUATOR, &b4);
			  iddptr->idd_idev.id_ival.ev_val =
				get_real(&b4);
			  iddptr->idd_idev.id_drec.val_rec.val_min =
				get_real(&b4);
			  iddptr->idd_idev.id_drec.val_rec.val_max =
				get_real(&b4);
			  iddptr->idd_idev.id_drec.val_rec.val_col =
				get_int(&b4);
			  break;
		default : err = 908; break;
		}
		break;
	case 'e':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 3, &b4); break;
		case 'd': iddptr = find_idd(wsd, CHOICE, &b4);
			  iddptr->idd_idev.id_drec.cho_rec.cho_col =
				get_int(&b4);
		/*where to store max nr of choice alternatives?*/
			  break;
		default : err = 908; break;
		}
		break;
	case 'y':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 4, &b4); break;
		case 'd': iddptr = find_idd(wsd, PICK, &b4);
			  iddptr->idd_idev.id_drec.pik_rec.pik_rat =
				get_real(&b4);
			  iddptr->idd_idev.id_drec.pik_rec.pik_col =
				get_int(&b4);
			  break;
		default : err = 908; break;
		}
		break;
	case 'i':
		switch (buff[1]) {
		case 'n': allc_ddescr(wsd, 5, &b4); break;
		case 'd': iddptr = find_idd(wsd, STRING, &b4);
			  iddptr->idd_idev.id_drec.str_rec.str_size =
				get_int(&b4);
			  iddptr->idd_idev.id_drec.str_rec.str_posn =
				get_int(&b4);
			  iddptr->idd_idev.id_drec.str_rec.str_col =
				get_int(&b4);
			  break;
		default : err = 908; break;
		}
		break;
	default : err = 908; break;
	}

	if (err != 0) {
		err_msg(
		"string %s with length %d in wsdcap not recognized\n",
			buff, strlen(buff));
	}
	return(err);
}

Int
get_int(b)
register char **b;
{
	Int ret;

	if (**b == '#') Skipchar(*b) 
	sscanf(*b, "%d",&ret);
	skptonond(b);
	return(ret);
}

Int
get_oct(b)
char **b;
{
	Int ret;

	if (**b == '#') Skipchar(*b) 
	sscanf(*b, "%o",&ret);
	skptonond(b);
	return(ret);
}

Real
get_real(b)
register char **b;
{
	Real ret;

	if (**b == '#') Skipchar(*b) 
	sscanf(*b, "%f",&ret);
	skptonond(b);
	return(ret);
}

skptonond(b)
char	**b;
{	while (**b != '#' && **b != ':') Skipchar(*b)
}

getlrep(lr, b)
LineRep	*lr;
char	**b;
{	sscanf(*b, "%d#%f#%d",&(lr->lr_lt),&(lr->lr_lw),&(lr->lr_ci));
}

getmrep(mr, b)
MarkRep	*mr;
char	**b;
{	sscanf(*b, "%d#%f#%d",&(mr->mr_mt),&(mr->mr_ms),&(mr->mr_ci));
}

gettrep(tr, b)
TextRep	*tr;
char	**b;
{	sscanf(*b, "%d#%d#%f#%f#%d", &(tr->tx_fp.fp_fo),
	&(tr->tx_fp.fp_pr),&(tr->tx_chef),&(tr->tx_chsp),&(tr->tx_ci));
}

getfrep(fr, b)
AreaRep	*fr;
char	**b;
{	sscanf(*b, "%d#%d#%d",&(fr->fa_is),&(fr->fa_si),&(fr->fa_ci));
}

getcol(col, b)
Colour	*col;
char	**b;
{	sscanf(*b, "%f#%f#%f",
		&(col->c_red),&(col->c_green),&(col->c_blue));
}

getgdp(gdp, b)
Gdp	*gdp;
char	**b;
{	sscanf(*b, "%d#%o", &(gdp->gd_id), &(gdp->gd_satt));
}

get_rct(rct, b)
Real	*rct;
char	**b;
{	Int i;
	for (i = 0; i < 4; i++) *rct++ = get_real(b);
}

get_crd(crd, b)
Real	*crd;
char	**b;
{	*crd = get_real(b); crd++;
	*crd = get_real(b);
}

allc_ddescr(wsd, icl, b)
Wsd	*wsd;
Int 	icl;
char	**b;
{
	wsd->wd_ndevs[icl] = get_int(b);
	CALLOC(wsd->wd_ddesc[icl], Iddescr, wsd->wd_ndevs[icl], O_GKS)
}

Iddescr *
find_idd(wsd, iclass, b)
Wsd	*wsd;
Iclass	iclass;
char	**b;
{	Int	j, i;
	Iddescr	*idd;

	i = get_int(b);
	if (i > wsd->wd_ndevs[(int)iclass]) {
		rep_er(909, O_GKS);
		return(NULL);
	}

	idd = &(wsd->wd_ddesc[(Int)iclass] [i - 1]);
	idd->idd_idev.id_clas = iclass;

	/*initial echo area:*/
	get_rct(&(idd->idd_idev.id_area.d_ll.d_x), b);

	i = idd->idd_npet = get_int(b);

	if (i != 0) CALLOC(idd->idd_pets, Pet, i, O_GKS)
	for (j = 0; j < i; j++) idd->idd_pets[j] = get_int(b);
	return(idd);
}
