/* @(#) u_wsensure.c  version:1.9.1.1  dated:85/01/02 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_wsensure.c
 * SCCS id :	u_wsensure.c 1.9.1.1
 * Last edited:	1/2/85 14:15:20
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * This file contains utility functions for the GKS output functions.
 * Especially those on lazy evaluation of the attributes.
 */

#define GKS 2
#define GKS1
#define GKS2
#define GKS8

#define SURE(TYP, STRYP, L, SOURCE) \
	{   if(sure(TYP)) {\
		STRYP *str = (STRYP *)seg_block(sizeof(STRYP), TYP, L);\
		ASS(*str , SOURCE)\
		attmark[TYP] = ID; \
	    }\
	}

#include "cgksincl.h"

char	*seg_block();
char	*find_rep();
Nc	*sg_sp_pr();

extern	Int	attmark[];
extern	Nrect	ndc;
extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	Bhead	*lastbh;

/*
 * ws_ensure sets all attributes, used by output primitive of
 * type `prt', on wss internal statelist.
 * This statelist contains amongst others the current setting of the
 * geometric attributes in DC coordinates.
 * For the non-geometric attributes the aspect source flags
 * are `solved', so the wi_lrep for example contains both local
 * and global polyline attributes.
 * This function is also called from the get input functions.
 * For workstations of type INPUT only the transformation matrix is
 * to be set.
 */
ws_ensure(ws, prt)
Wss *ws;
Int prt;
{	
	char 	*ptr;
	register Wsis	*wis = ws->ws_wsis;

	/*if (ws->ws_cat != INPUT) { ?*/
	if ((wis->wi_attm & WS_MAT) !=0) {
		setwsmat(ws);
		mark_ws(ws, WS_CHV);
		mark_ws(ws, WS_CWV);
		mark_ws(ws, WS_CLP);
		mark_ws(ws, WS_PASZ);
		mark_ws(ws, WS_PARP);

		cl_wsmark(ws, WS_MAT);
	}

	if ((wis->wi_attm & WS_CLP) !=0) {
		st_clipw(ws); /*set wi_clipr*/
		cl_wsmark(ws, WS_CLP);
	}

	ws->ws_empty = FALSE;

	if ((wis->wi_attm & WS_COL)  != 0) { 
		if (WsScrn->s_colt != NULL)
			(*WsScrn->s_colt) (ws, ws->ws_colr);
		cl_wsmark(ws, WS_COL);
	}

 	switch (prt) {
	case POL:
	     if (sure(PLATT) || ((wis->wi_attm & WS_POL)  != 0)) { 
		if ((_gkss->gk_asf & 07) != 07) {
			ptr =
			  find_rep((char *)ws->ws_line, sizeof(LineRep),
				ws->ws_nline, _gkss->gk_line);
			ASS(wis->wi_lrep , *((LineRep *)ptr))
		}
		if ((_gkss->gk_asf & 01) != 0)
			wis->wi_lrep.lr_lt = _gkss->gk_lrlt; 
		if ((_gkss->gk_asf & 02) != 0)
			wis->wi_lrep.lr_lw = _gkss->gk_lrlw; 
		if ((_gkss->gk_asf & 04) != 0)
			wis->wi_lrep.lr_ci = _gkss->gk_lrci; 
		cl_wsmark(ws, WS_POL);
	     }
	     break;
	case POM:
	     if (sure(PMATT) || ((wis->wi_attm & WS_POM)  != 0)) { 
		if ((_gkss->gk_asf & 070) != 070) {
			ptr =
			  find_rep((char *)ws->ws_mark, sizeof(MarkRep),
				ws->ws_nmark, _gkss->gk_mark);
			ASS(wis->wi_mrep , *((MarkRep *)ptr))
		}
		if ((_gkss->gk_asf & 010) != 0)
			wis->wi_mrep.mr_mt = _gkss->gk_mrmt; 
		if ((_gkss->gk_asf & 020) != 0)
			wis->wi_mrep.mr_ms = _gkss->gk_mrms; 
		if ((_gkss->gk_asf & 040) != 0)
			wis->wi_mrep.mr_ci = _gkss->gk_mrci; 
		cl_wsmark(ws, WS_POM);
	     }
	     break;
	case TXT:
	     if (sure(TXATT) || ((wis->wi_attm & WS_TXT)  != 0)) { 
		if ((_gkss->gk_asf & 01700) != 01700) {
			ptr =
			  find_rep((char *)ws->ws_text, sizeof(TextRep),
				ws->ws_ntext, _gkss->gk_text);
			ASS(wis->wi_trep , *((TextRep *)ptr))
		}
		if ((_gkss->gk_asf & 0100) != 0)
			ASS(wis->wi_trep.tx_fp, _gkss->gk_txfp)
		if ((_gkss->gk_asf & 0200) != 0)
			wis->wi_trep.tx_chef = _gkss->gk_chef; 
		if ((_gkss->gk_asf & 0400) != 0)
			wis->wi_trep.tx_chsp = _gkss->gk_chsp; 
		if ((_gkss->gk_asf & 01000) != 0)
			wis->wi_trep.tx_ci   = _gkss->gk_txci; 
		cl_wsmark(ws, WS_TXT);
		mark_ws(ws, WS_CHSP);/*setting can be more precise*/
		mark_ws(ws, WS_CWV);/*setting can be more precise, i.e.
				     *only if char exp fact is changed
				     */
	     }

	     if ((wis->wi_attm & WS_CHV) != 0) {
		wis->wi_chvec.d_x= wis->wi_mat[0][0] * 
			gksis->gki_chvec.n_x;
		wis->wi_chvec.d_y= wis->wi_mat[1][1] * 
			gksis->gki_chvec.n_y;
		cl_wsmark(ws, WS_CHV);
		mark_ws(ws, WS_CHSP);
	     }
	     if ((wis->wi_attm & WS_CWV) != 0) {
		/*interpret here character exp factor: */
		wis->wi_cwvec.d_x= wis->wi_mat[0][0] * 
			gksis->gki_cwvec.n_x ;
		wis->wi_cwvec.d_y= wis->wi_mat[1][1] * 
			gksis->gki_cwvec.n_y ;
		cl_wsmark(ws, WS_CWV);
	     }

	     if ((wis->wi_attm & WS_CHSP) != 0) {
		s_wi_cspvec(wis);
		cl_wsmark(ws, WS_CHSP);
	     }
	     break;
	case FAR:
	     if (sure(FAATT) || ((wis->wi_attm & WS_FAR)  != 0)) { 
		if ((_gkss->gk_asf & 016000) != 016000) {
			ptr =
			  find_rep((char *)ws->ws_area, sizeof(AreaRep),
				ws->ws_narea, _gkss->gk_area);
			ASS(wis->wi_frep , *((AreaRep *)ptr))
		}
		if ((_gkss->gk_asf & 02000) != 0)
			wis->wi_frep.fa_is = _gkss->gk_fais; 
		if ((_gkss->gk_asf & 04000) != 0)
			wis->wi_frep.fa_si = _gkss->gk_fasi; 
		if ((_gkss->gk_asf & 010000) != 0)
			wis->wi_frep.fa_ci = _gkss->gk_faci; 
		cl_wsmark(ws, WS_FAR);
	     }
	     if (wis->wi_frep.fa_is == PATTERN &&
		 ((wis->wi_prep == NULL) ||
		  (wis->wi_frep.fa_si != wis->wi_prep->pa_ix))) {
		/*a new style index is to be interpreted*/
			mark_ws(ws, WS_PAT);
	     }
	     if ((wis->wi_attm & WS_PAT) != 0) {
	        /*style index or pattern table is changed*/
		if (ws->ws_npatt != 0) {
		   ptr = find_rep((char *)ws->ws_patt, sizeof(PattRep),
				ws->ws_npatt, wis->wi_frep.fa_si);
		   wis->wi_prep = (PattRep *)ptr;
		}
		else wis->wi_prep = NULL;

		cl_wsmark(ws, WS_PAT);
	     }
	     
	     if (wis->wi_frep.fa_is == PATTERN) {
	        if ((wis->wi_attm & WS_PASZ) != 0) { 
		vecrotate((Real *)&wis->wi_xpatsiz,
		 	(Real *)&gksis->gki_xpatsiz,
			(Real *)&wis->wi_mat[0][0]);
		vecrotate((Real *)&wis->wi_ypatsiz,
		 	(Real *)&gksis->gki_ypatsiz,
			(Real *)&wis->wi_mat[0][0]);
			cl_wsmark(ws, WS_PASZ);
	   	}

	        if ((wis->wi_attm & WS_PARP) != 0) { 
			ws_transf(ws, &gksis->gki_patref,
				&wis->wi_patref);
			cl_wsmark(ws, WS_PARP);
		}
	     }
	     break;
	default:
	     break;
	}
}

/*
 *s_wi_cspvec() sets the character spacing vector.
 *wi_cspvec is a vector parrallel to wi_cwvwc (the
 *character width vector) however with the proper
 *length, being a fraction of the height vector :
 */
s_wi_cspvec(wis)
Wsis	*wis;
{
	Real uplngth, widthlngth;

	if (wis->wi_trep.tx_chsp == 0.0) {
		wis->wi_cspvec.d_x = wis->wi_cspvec.d_y = 0.0;
	}
	else {
		uplngth = sqrt((double)(
			wis->wi_chvec.d_x * wis->wi_chvec.d_x +
			wis->wi_chvec.d_y * wis->wi_chvec.d_y));
		widthlngth = sqrt((double)(
			wis->wi_cwvec.d_x * wis->wi_cwvec.d_x +
			wis->wi_cwvec.d_y * wis->wi_cwvec.d_y));

		if (widthlngth != 0.0) {
		     wis->wi_cspvec.d_x =
		    	wis->wi_trep.tx_chsp * wis->wi_cwvec.d_x *
		    	uplngth / widthlngth;
		     wis->wi_cspvec.d_y =
		    	wis->wi_trep.tx_chsp * wis->wi_cwvec.d_y *
			uplngth / widthlngth;
		}
		else ;
	}
}

/*Find_rep returns ptr to representation with bundle index ix.
 *If there is none available with this index it returns
 *the first representation.
 */
char *
find_rep(first, repsize, nr, ix)
char	*first;
Int	repsize, nr;
Bindex	ix;
{	register char *repptr = first;
	while (nr != 0 && *((Bindex *)repptr) != ix) {
		repptr += repsize;
		nr--;
	}
	if (nr == 0) repptr = first;
	return (repptr);
}

Nc *
outprim(n, wc, prt)
Size	n;
Wc	*wc;
Int	prt;
{	Nc	*ps, *nc;
	Int	i;

	if (ch_state(5, prt) != 0) return((Nc *)NULL);
	ensure(prt);
	ps = sg_sp_pr(n, prt);
	nc = ps; 
	for(i = 0; i < n; i++) ntransf(wc++, nc++);
	return(ps);
}

cl_wsmark(ws, typ)
Wss	*ws;
Int	typ;
{	ws->ws_wsis->wi_attm &= ~typ;
}
