/* @(#) u_wsprim.c  version:1.9  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_wsprim.c
 * SCCS id :	u_wsprim.c 1.9
 * Last edited:	11/12/84 13:17:49
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 2
#define GKS2
#define GKS5 /* for IN_SG*/

#include "cgksincl.h"

Bool	b_insseg;
	/*
	 * This boolean indicates whether or not pr_to_all_ws() is
	 * called from the insert_segment function.
	 * (see inssegi.h)
	 */

extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksd	*gksd;
extern	Gksi	*gksis;

extern	Fun 	pws_pline;
extern	Fun	pws_pmark;
extern 	Fun	pws_text;
extern	Fun	pws_farea;
extern	Fun	pws_cells;
extern	Fun	pws_gdp;
Nc *nc_trans(); /* code in u_defacts.c */


/*
 * Send output primitive to all workstations, being active,
 * and not being of type WISS.
 * Output primitive is only sent if either ws is of type MO,
 * or ws cliprectangle is a real rectangle and segment is visible.
 * Keep in mind that segment storage is done only outside
 * workstation; if storage is done inside workstation, then
 * doe not check at this! point on visibility of segment.
 */

pr_to_all_ws(n, nptr, s, nc, prt)
Size	n;	/* used for POL, POM, FAR */
Size	*nptr;	/* used for CELL */
String	s;	/* used for TXT */
Nc	*nc;	/* used for prt, except IN_SG */
Int	prt;
{
	Int i; 
	Wss *ws; 
	Bool seg_invis = FALSE; 
	Nc *nc_sgtr = NULL, *nc2;

	if (gkstate == SGOP && gksis->gki_sgact == TRUE) {
		if (_gkss->gk_opsg->sg_vis == FALSE) {
			seg_invis = TRUE; 
		}
		else {
			/*
			 * segment is open and visible.
			 * therefore it is necessary to
			 * apply segment transformation before
			 * sending coordinates to device:
			 */
			nc_sgtr =
				nc_trans(&_gkss->gk_opsg->sg_mat[0][0],
					 nc, n, prt);
		}
	}

	nc2 = (nc_sgtr != NULL) ? nc_sgtr : nc;

	/*
	 *Primitives are sent to all active workstations
	 *not being of type WISS, MI or INPUT.
	 *If open segment is invisible and ws is not of type MO,
	 *output is not displayed on ws.
	 */
	i = 0;
	while ((ws = _gkss->gk_actv[i++]) != NULL) {
		if (ws->ws_wsd->wd_cat != WISS) {
		    /* 
		     * active ws can't be of MI or INPUT type
		     * so no check on that 
		     */
			ws_ensure(ws, prt);
			if (ws->ws_wsd->wd_cat == MO ||
			    (!IsntRect(&ws->ws_wsis->wi_clipr) && 
			     seg_invis == FALSE)){ 
			     /* if segment is open apply first
			      * segment transformation:
			      */

				switch (prt) {
				case POL:
					(*pws_pline)(ws, n, nc2);
					break;
				case POM:
					(*pws_pmark)(ws, n, nc2);
					break;
				case FAR:
					(*pws_farea)(ws, n, nc2);
					break;
				case TXT:
					(*pws_text)(ws, s, nc2);
					break;
				case CELL:
					(*pws_cells)(ws, nptr, nc2);
					break;
				case GDP:
				/*not (yet) arranged via this function*/
					break;
				case IN_SG:
				/*
				 * no action here.
				 * this fun called at the end of insert
				 * segment to perform ws_irg()
				 */
					break;
				default:
					break;
				}
				if (b_insseg == FALSE)
					ws_irg(ws, prt); /* see 4.5.3*/ 
				/*
				 *for insert_segment this function
				 *is called only once at the end
				 *of the insertion.
				 */
			} 
	  	}
	  } 

	  FREE(nc_sgtr) /* FREE checks on NULL ptr */
}
