/* @(#) verdraw.h  version:1.6  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.verdraw.h
 * SCCS id :	verdraw.h 1.6
 * Last edited:	10/19/84 13:40:27
 */

	/* This file contains the basic VERSATEC routines
	for drawing in screen space */

#include	<ctype.h>
#include	<sgtty.h>
#include	<errno.h>
#include	<setjmp.h>
#include	<signal.h>


Bool atbeam();


extern int	errno;

#define	prefix	putchar

static struct sgttyb ggttyb;
static struct sgttyb ggttyb2;
static Ic	beam = { -1, -1 };

STATIC Bool
drawline(ws,n,s,ltype,lwidth)	/* Draw line in screen space */
Wss	*ws;
Size	n;
Ic	*s;
Ltype	ltype;
Lwidth	lwidth;
{
	setltyp(ltype);

	while (--n) {
		line((int)s->i_x, (int)s->i_y, 
			(int)(s+1)->i_x, (int)(s+1)->i_y);
		s++;
	}
}


STATIC Bool
drawhard(ws, s, ic)	/* Draw hard char str s at ic in screen space */
Wss	*ws;
String	s;
Ic *ic;
{
	Screen *sc = WsScrn;
	char *s2 = s, *st2;
	String st;

	/* if (!atbeam(ic) ) { moveto(ic); } */
	moveto(ic);
	ASS(beam, *ic)
	if ((st = (String)malloc(strlen(s) + 1)) == NULL) {
		fprintf(stderr,"malloc exhausted in versatec driver\n");
		exit(-1);
	};
	st2 = st;
	while(*s2 != '\0') {
		if (*s2 > '\037') {
			*st2 = *s2;
			st2++;
			beam.i_x += sc->s_chsz.i_x;
		}
		s2++;
	}
	*st2 = '\0';
	label(st);
	if (st != 0) free(st);
}


static Bool	inited = FALSE;

char	vtc_rast[16];
File	*verout;

/*
 * create a new file name
 */
crt_fname(fname)
char *fname;
{	sprintf(fname,"/tmp/vertc%d",(rand() % 10000));
}

/*#define DO_FORK /**/

/*
 * send file to versatec with a call of UNIX program plot
 */
route(filename)
String filename;
{	char 	commandstr[64];

	sprintf(commandstr, "plot -Tver < %s", filename);
#ifdef DO_FORK
	/* Doesn't work fine.
	 * Among others file `filename' is not unlinked.
	 */
	if (fork() == 0)  {
	   execl("/bin/sh", "sh", "-c", commandstr, 0);
	}
#else
	system(commandstr);
	unlink(filename);
#endif
}

/*
 * Erase screen
 */
Bool
erasever(ws)
Wss *ws;
{
	int fd;
	if (inited == FALSE) {
		srand(getpid());/*rand() is initialized with
				 *process id number
				 */
		crt_fname(vtc_rast);
		if ((verout = fopen(vtc_rast, "w")) == NULL) {
			rep_er(310, 0);
			exit(1);
		}
		inited = TRUE;
		openpl();
	}
	else {
		if ((fd = open(vtc_rast, 0)) != -1) {
			closepl();
			route(vtc_rast);
			fclose(verout);
			close(fd);
		}

		crt_fname(vtc_rast);
		if ((verout=fopen(vtc_rast, "w"))==NULL) {
			rep_er(310, 0);
			exit(1);
		}
		openpl();

		beam.i_x = 0;
		beam.i_y = 0;
		/*
		curltype = 0;
		*/
	}
	return(TRUE);
}


Bool
closever(ws)
Wss	*ws;
{
	int fd;
	if ((fd = open(vtc_rast, 0)) != -1) {
		closepl();
		route(vtc_rast);
		fclose(verout);
		close(fd);
		inited = FALSE;
	}
}


STATIC
flush(i)
int	i;
{
	while (i--)
		putchar('\0');
/*	ioctl(fileno(stdout),TIOCFLUSH,(struct sgttyb *) NULL); */
}

STATIC Bool
atbeam(s)
Ic	*s;
{
	return (Bool) ((s->i_x == beam.i_x) && (s->i_y == beam.i_y));
}

/*
 * Get into graph mode with CAP at *s
 */
STATIC
moveto(s)
Ic	*s;
{
	move((int)s->i_x, (int)s->i_y);
}

/*
 * Line from CAP to *s
 */
STATIC
lineto(s)
Ic	*s;
{
	cont((int)s->i_x, (int)s->i_y);
}


STATIC
Bool rectan(ws,ll,ur)
Wss	*ws;
Ic	*ll;
Ic	*ur;
{
	/* not filled*/
	Int i;
	Int xl = ll->i_x, xr = ur->i_x;
	for (i = ll->i_y; i <= ur->i_y; i++) 
		line((int)xl, (int)i, (int)xr, (int)i);
}

