/* @(#) vertc.c  version:1.14  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.vertc.c
 * SCCS id :	vertc.c 1.14
 * Last edited:	11/13/84 14:58:14
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define	TRMTYP	VERSATEC

#include	"cgksincl.h"
#include	<signal.h>
#include	"vertc.h"
#include 	"verplot.h"

STATIC Bool	drawline(), drawhard();
Bool		erasever();
STATIC Bool	drawmark();
Bool		closever();
STATIC Bool	rectan();
STATIC Bool	vergdp();
STATIC Bool	setlatt(), setmatt(), settatt(), setfatt();

Screen	g_versatec[] = {
	MAXX, MAXY,	/* Main screen size */
	CHARX, CHARY,	/* Character size */
	CHARHT,		/* Hard character height */
	0, 0,		/* Hit location */
	0,		/* s_code: Hit code */
	0,		/* Colour */
	S_CHANGED,	/* s_flag */
	'\0',		/* s_timo */
	erasever,	/* Total erase */
	NULL,		/* No line erase */
	closever,
	NULL,		/* Set clip rectangle*/
	NULL,		/* GKS Message */
	NULL,		/* Escape  functions*/

	drawline,	/* Line drawing */
	drawmark,	/* Polymark */
	drawhard,	/* Hard characters */
	NULL,		/* No Raster Scan */
	NULL,		/* No pixelscan facility */
	NULL,		/* No cellarray facility */
	vergdp,		/* General drawing prim*/
	rectan,		/* No rectangle erase */

	NULL,		/* Set polyline att*/
	NULL,		/* Set polymark att*/
	NULL,		/* Set text att*/
	NULL,		/* Set fill area att*/
	NULL,		/* Set Colour */
	NULL,		/* Set Colour Table */
	NULL,		/* Inquire pixel */
#ifndef	HIGH_INPUT /*for a simple device, with only request input:*/
	NULL,		/* no input from cursor */
	NULL,		/* no input from keyboard */
#else
	NULL,	 /*init loc,val,cho,pik,str or stk inp dev*/
	NULL,	 /*set loc,val,cho,pik,str or stk idev mod*/
	NULL,	 /*get req. or sample input from loc dev */
	NULL,	 /*get req. or sample input from val dev */
	NULL,	 /*get req. or sample input from cho dev */
	NULL,	 /*get req. or sample input from str dev */
	NULL,	 /*get req. or sample input from stke dev */
	NULL,	 /*get req. or sample input from pick dev */
	NULL,	 /*await event*/
#endif
	NULL,		/* Hilite */
	};

Screen *verscrn = g_versatec;

int
versatec()
{	return(inst_scr("ver", verscrn));
}

#include	"verdraw.h"
#include	"verpmk.h"
#include	"vergdp.h"
#include	"veratt.h"
