/* @(#) w_cellarray.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_cellarray.c
 * SCCS id :	w_cellarray.c 1.4
 * Last edited:	11/13/84 00:37:11
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#define GKS 2
#define GKS2
#include "cgksincl.h"

extern	Gks	*_gkss;
extern	GksState gkstate;
extern	Gksd	*gksd;
extern	Gksi	*gksis;
extern 	Fun	pws_cells;
extern 	Tmat 	u_mat;

Nc	*outprim();
Bool	suthalg();
Int	clip2d();
Bool 	isdrect();
Bool 	exactmap();
Bool 	no_cellclip();
Bool	unit_mat();
Bool	dc_in_drect();

ws_cells(ws, ccols, pr)
Wss	*ws;
Size	*ccols;
Nc	*pr;
{
	Screen	*scr = WsScrn;
	Real	dhigh, dlow;
	Nc	*nptr;
	Dc	*dcnew, *dptr, dparr[4];
	Ic	*ic;
	Drect	*clip_w = &(ws->ws_wsis->wi_clipr);
	Size	newn, line_nr;
	Int	i;
	Bool	ca_is_rect;
	Bool	no_clip, exact, s_cell_use;
	Size	n, m;

	if (ws->ws_wsd->wd_cat == MO){
#ifdef METAFILE
/* item is sent to metafile */
		(*MfScrn->m_ca)(ws,pr[0],pr[2],pr[3],
			ccols[0],ccols[1],&(ccols[2]));
#endif
	}
	else {
		n = *ccols++; /* for DX */
		m = *ccols++; /* for DY */
		/*ccols now points to first colour*/
		/*now we do have a problem: if the cellarray is
		 *from (0.0,0.0) to (482.0,511.0)  (= maxsize of aed) 
		 *with n = 482 and m = 511, then actually the
		 *cellarray doesn't cover the screen completely,
		 *because screensize from 0 to 482 pixs means an n of 483,
		 *and screensize from 0 to 511 means an m of 512!
		 *At this moment although not correct 
		 *the aed512 is considered as having size 482 by 511.
		 */

		nptr = pr;
		dptr = dparr;
		for (i = 0; i < 4; i++)
			ws_transf(ws, nptr++, dptr++);

		no_clip = no_cellclip(dparr, clip_w);
		exact = exactmap(ws, dparr, n, m); 

		s_cell_use = (Bool)(exact == TRUE &&
				no_clip == TRUE && 
		    		ws->ws_wsd->wd_rov == RASTER &&
				scr->s_cell != 0);
		    /*with some extra calculation this case can also
		     *be used when clipping is to be done*/

		if (s_cell_use == TRUE) {
			Ic	icul;
			/*icul is screen pixel where first
			 *cell of cellarray (upper left) is mapped to*/
			icul.i_x = dparr[1].d_x + 0.5;
			icul.i_y = dparr[1].d_y - 0.5;
			(*scr->s_cell)(ws, &icul, n, m, (Cindex *)ccols);
		}

		else if (ws->ws_wsd->wd_rov == RASTER && scr->s_runl) {
			CALLOC(dcnew, Dc, 12, CELL)

			if (suthalg(4, dparr, clip_w, &newn, dcnew) == TRUE &&
			    newn > 1) {
				ca_is_rect = (Bool)((newn == 4) &&
						    (isdrect(dcnew) == TRUE));
				dptr = dcnew;
				dhigh = dlow = dptr->d_y;
				dptr++;
				for (i = 1; i < newn; i++, dptr++) {
			  		if (dhigh < dptr->d_y)
						dhigh =dptr->d_y;
					else if (dlow  > dptr->d_y)
						dlow = dptr->d_y;
				}

				line_nr = 
				   (Int)dhigh - (Int)(ceil((double)dlow)) + 1;
				if (line_nr != 0 && dhigh != dlow) {
					CALLOC(ic, Ic, (2 * line_nr), CELL)
					lines(dcnew,newn,dhigh,dlow,ic,ca_is_rect);
					/*now ic points to line_nr paires of
					 *line ends 
					 */

					pixelscan(ws, pr, n, m,
					    (Cindex *)ccols, line_nr, 
					    ic, FALSE);
					/*pixelscan calls di/dd entry
					 *s_runl
					 */
					FREE(ic)
				}
			}
			FREE(dcnew)
		}
		else {	
			/* slow implementation. */
			/* cell array not mentioned for this situation */
			/* colours not used*/
			Real	x1, y1, x3, y3;
			Dc	beg, end;

			x1 = (dparr[1].d_x - dparr[0].d_x) / (Real) n;
			y1 = (dparr[1].d_y - dparr[0].d_y) / (Real) n;
			x3 = (dparr[3].d_x - dparr[0].d_x) / (Real) m;
			y3 = (dparr[3].d_y - dparr[0].d_y) / (Real) m;

			ASS(beg , dparr[0])
			ASS(end , dparr[3])
			for (i = 0; i <= n; i++) {
				drawl(ws, scr, beg, end, clip_w);
			   	beg.d_x += x1;
				end.d_x += x1;
				beg.d_y += y1;
				end.d_y += y1;
			}

			ASS(beg , dparr[0])
			ASS(end , dparr[1])
			for (i = 0; i <= m; i++) {
				drawl(ws, scr, beg, end, clip_w);
				beg.d_x += x3;
				end.d_x += x3;
				beg.d_y += y3;
				end.d_y += y3;
			}
		}
	}
}

sf_cells()
{
	pws_cells = ws_cells;
}

drawl(ws, scr, beg, end, clipw)
Wss	*ws;
Screen	*scr;
Dc	beg, end;
Drect	*clipw;
{
	Ic	ic[2];
	if (clip2d(&beg ,&end, clipw) != 0) {
		ic[0].i_x = beg.d_x + 0.5;
		ic[0].i_y = beg.d_y + 0.5;
		ic[1].i_x = end.d_x + 0.5;
		ic[1].i_y = end.d_y + 0.5;
		(*scr->s_line)(ws, 2, ic, SOLIDL, 1.0);
	}
}

Size *
sgsp_cells(n, m, ci)
Size	n, m;
Cindex	*ci;
{	Int	i;
	Cindex	*prci;
	Size	*ccols, *pri;

	ccols = (Size *)seg_block(sizeof(Size), CELL, n * m + 2);
	/*2 extra to store n and m*/
	pri = ccols;
	*pri++ = n;
	*pri++ = m;
	prci = (Cindex *)pri;
	for (i = 0; i < n * m; i++) *prci++ = *ci++;
	return (ccols);
}

static
lines(dc, newn, dhigh, dlow, ic, ca_is_rect)
Dc	*dc;
Real	dlow, dhigh;
Ic	*ic;
Size	newn;
Bool	ca_is_rect;
{
	Int	up, down;
	register Int	il, ir, jl, jr, iy;
	double	db;

	up	= (Int)dhigh;
	down	= (Int)ceil((double)dlow);
	if (up < down) return;/*security check*/

	if (ca_is_rect == TRUE) {
		ir = (Int)floor((double)dc[2].d_x);
		il = (Int)ceil ((double)dc[0].d_x);
		iy = up;
		do {	ic->i_y = iy;
			(ic++)->i_x = il;
			ic->i_y = iy;
			(ic++)->i_x = ir;
		} while (iy-- != down);
	}
	else {
		ir = 0; jr = 1;
		while (!((dc[ir].d_y == dhigh) &&
			 (dc[jr].d_y < dhigh)) ) {
			ir= jr; 
			jr= (ir == newn - 1) ? 0 : jr+1;
		}

		il = 1; jl = 0;
		while (!((dc[il].d_y == dhigh) &&
			 (dc[jl].d_y < dhigh)) ) {
			il= jl; 
			jl= (il == 0) ? newn - 1 : jl-1;
		}

		for (iy = up; iy >= down; iy--) {
		   while (dc[jl].d_y > iy) {
		   	il = jl;
		   	jl = (jl == 0) ? newn - 1 : jl-1;
		   }
		   ic->i_y = iy;
		   if (fabs(dc[jl].d_y - dc[il].d_y) < 1.0e-6)
		   	db = (double)(dc[il].d_x); 
		   else	db = (double)(dc[il].d_x +
		   	(iy	    - dc[il].d_y) *
		   	(dc[jl].d_x - dc[il].d_x) /
		   	(dc[jl].d_y - dc[il].d_y)
		    	);
		   (ic++)->i_x = (Int)ceil(db);

		   while (dc[jr].d_y > iy) {
		   	ir = jr;
		   	jr = (jr == newn - 1) ? 0 : jr+1;
		   }
		   ic->i_y = iy;
		   if (fabs(dc[jr].d_y - dc[ir].d_y) < 1.0e-06)
		   	db = (double)(dc[ir].d_x); 
		   else	db = (double)(dc[ir].d_x +
		   	(iy	    - dc[ir].d_y) *
		   	(dc[jr].d_x - dc[ir].d_x) /
		   	(dc[jr].d_y - dc[ir].d_y)
		   	);
		   (ic++)->i_x = (Int)floor(db);
		}
	}
}

Bool
isdrect(s)
Dc	*s;
{
	if ((s[0].d_x == s[1].d_x) &&
	    (s[2].d_x == s[3].d_x) &&
	    (s[0].d_y == s[3].d_y) &&
	    (s[1].d_y == s[2].d_y)) return(TRUE);
	else return (FALSE);
}

/*exactmap() checks if the resulting rectangle
 *(in device coordinates) maps exactly on a device grid.
 *At this moment the function gives only TRUE if the 
 *cellarray cells are exactly 1 by 1.
 *However if each cellarray cell is an exact number 
 *of pixels, both in x and y direction, then too,
 *with some extra calculation, a direct memory access
 *routine to address the screen can be used.
 */

Bool
exactmap(ws, dptr, n, m) 
Wss	*ws;
register Dc	*dptr;
Size 	n, m;
{
	Real eps = 0.000051;

	/*is rectangle rotated by a segment transformation?:*/
	if (dptr[1].d_x != dptr[0].d_x ||
	    dptr[3].d_y != dptr[0].d_y ||
	    dptr[2].d_x <= dptr[0].d_x || 
	    dptr[2].d_y <= dptr[0].d_y ) 
		return(FALSE);
	else 
	if ((fabs(dptr[2].d_x - dptr[0].d_x - n) > eps) ||
	    (fabs(dptr[2].d_y - dptr[0].d_y - m) > eps)) 
		return(FALSE);
	else	return(TRUE);
}

Bool
no_cellclip(dcptr, clipw)
Dc	*dcptr;
Drect	*clipw;
{
	return((Bool)  (dc_in_drect(clipw, dcptr++) == TRUE &&
	    		dc_in_drect(clipw, dcptr++) == TRUE &&
	    		dc_in_drect(clipw, dcptr++) == TRUE &&
	    		dc_in_drect(clipw, dcptr  ) == TRUE
		       )
	      );
}

/*
Bool
unit_rect(rect)
Real	*rect;
{
	return((Bool) (
		*rect       == 0.0 && 
		*(rect + 1) == 0.0 &&
	      	*(rect + 2) == 1.0 && 
		*(rect + 3) == 1.0
	      ));
}
*/
