/* @(#) w_fillarea.c  version:1.8.1.1  dated:85/01/02 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_fillarea.c
 * SCCS id :	w_fillarea.c 1.8.1.1
 * Last edited:	1/2/85 14:18:30
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 2
#define GKS2

#include "cgksincl.h"

static Dc	F[4], S[4], I[4];
static Bool	_first[4];

Nc	*outprim();
Bool	suthalg();
Bool	isrect();
Bool	self_sect();
Bool	line_cross();
Bool	pxl_streams();
Ic	*scanlines();
Bool	pixelscan();

extern	Gks	*_gkss;
extern	GksState gkstate;
extern	Gksi	*gksis;
extern	Gksd	*gksd;
extern 	Fun	pws_farea;

/*
 * By calling the function ws_farea() you enters the workstation driver.
 * So ws_farea() is part of the VDI.
 *
 * Inside this function a check is done to see how intelligent 
 * the device is by looking at the device driver entries concerning
 * a fillarea, being part of the DI/DD interface.
 * An entry unequal NULL means that the device driver is able to
 * handle the situation from that point. If so control is handed over
 * to the device driver by calling the specific routine ( via
 * an entry in the Screen structure).
 * Modern intelligent devices, able of doing the workstation
 * transformation and the clipping themselve, are called practically
 * immediately after ws_farea() is called.
 * This counts also for a workstation of type Metafile.
 */
ws_farea(ws, n, pr)
Wss	*ws;
Nc	*pr;
Size	n;
{
	AreaRep	*frep = &ws->ws_wsis->wi_frep;
	Screen	*scr = WsScrn;
	Nc	*ncptr;
	Drect	*clip_w = &(ws->ws_wsis->wi_clipr);
	Dc	*dc, *dcptr, *dcsh;
	Ic	*ic, *ic1, *ic2, ll, ur;
	Size	newn;
	Istyle	is  = frep->fa_is;
	Sindex	si  = frep->fa_si;
	Int 	i, uscl, lscl, line_nr;
	PattRep *prep;
	Nc	ncp[4];

	/* call either direct or after some calculations 
	 * the device driver for this ws:
	 */
	if (ws->ws_wsd->wd_cat == MO){ ;
#ifdef METAFILE
/*
 * item is routed to METAFILE
 */
	 	(*MfScrn->m_fa)(ws,n,pr);
#endif
	}
	else {
	/* device seems to be not that intelligent. so therefore
	 * some calculation is done first to simulate fillarea()
	 */
		CALLOC(dc, Dc, n, FAR)
		CALLOC(dcsh, Dc, (4 * n), FAR)

		ncptr = pr;
		dcptr = dc;
		for (i = 0; i < n; i++) ws_transf(ws, ncptr++, dcptr++);

		dcptr = dc;
		if (suthalg(n, dcptr, clip_w, &newn, dcsh) == FALSE) 
			return;
		/* now dcsh points to newn Dc points inside 
		 * Dc clip window 
		 */

		FREE(dc)
		CALLOC(ic1, Ic, (newn + 1), FAR)
		ic2 = ic1;
		dcptr = dcsh;
		uscl = lscl = (Int)dcsh->d_y ;
		for (i = 0; i < newn; i++, dcptr++, ic2++) {
			dc_to_ic(ic2, dcptr);
			if	 (ic2->i_y > uscl) uscl = ic2->i_y;
			else  if (ic2->i_y < lscl) lscl = ic2->i_y;
		}
		
		if (scr->s_fatt)  (*scr->s_fatt)(ws, *frep);

		switch (is) {
		case HOLLOW:
		   /* (*scr->s_fill)(ws, ic1, newn, is, si); */
		   ASS(*(ic1 + newn), *ic1)
		   (*scr->s_line)(ws, newn + 1, ic1, SOLIDL, 1.0);
		   break;

		case SOLID :
		   if (newn == 4 && (isrect(ic1) == TRUE) && 
		       (scr->s_colr) && (scr->s_rect)) { 
			Int x0 = ic1[0].i_x, x2 = ic1[2].i_x,
			    y0 = ic1[0].i_y, y2 = ic1[2].i_y;
			ll.i_x = (x0 > x2) ? x2 : x0;
			ur.i_x = (x0 < x2) ? x2 : x0;
			ll.i_y = (y0 > y2) ? y2 : y0;
			ur.i_y = (y0 < y2) ? y2 : y0;
			(*scr->s_rect)(ws, &ll, &ur);
		   }
		   else {
			ic =
			 scanlines(ws, newn, &line_nr, ic1, lscl, uscl);
			pxl_streams(ws, line_nr, ic);
			FREE(ic)
		   }
		   /*
		   else {
		   	ASS(*(ic1 + newn), *ic1)
		   	(*scr->s_line)(ws, newn + 1, ic1, SOLIDL, 1.0);
		   }
		   */
		   break;

		case PATTERN:
			ic =
			 scanlines(ws, newn, &line_nr, ic1, lscl, uscl);

			for (i = 0; i < 4; i++) 
				ASS(ncp[i] , gksis->gki_patref)

			ncp[1].n_x += gksis->gki_ypatsiz.n_x;
			ncp[1].n_y += gksis->gki_ypatsiz.n_y;

			ncp[2].n_x += (gksis->gki_ypatsiz.n_x +
			             gksis->gki_xpatsiz.n_x);
			ncp[2].n_y += (gksis->gki_ypatsiz.n_y +
			             gksis->gki_xpatsiz.n_y);

			ncp[3].n_x += gksis->gki_xpatsiz.n_x;
			ncp[3].n_y += gksis->gki_xpatsiz.n_y;

			prep = ws->ws_wsis->wi_prep;
			if (prep == NULL) {
				pxl_streams(ws, line_nr, ic);
			}
			else {
			   if (scr->s_runl != NULL)
			    pixelscan(ws, ncp, prep->pa_n, prep->pa_m,
				prep->pa_ci, line_nr, ic, TRUE);
			   else ; /* nothing */
			}

			FREE(ic)
		  break;
		case HATCH:
		  break;
		}
		FREE(ic1)
		FREE(dcsh)
	}
}

sf_farea()
{
	pws_farea = ws_farea;
}

Bool visible(dclip, side, s)
Drect	*dclip;
Int	side;
Dc	*s;
{	Bool vi;
	switch (side) {
	case 0 :vi = (Bool)(s->d_y >= dclip->d_ll.d_y); break; 
	case 1 :vi = (Bool)(s->d_x <= dclip->d_ur.d_x); break; 
	case 2 :vi = (Bool)(s->d_y <= dclip->d_ur.d_y); break; 
	case 3 :vi = (Bool)(s->d_x >= dclip->d_ll.d_x); break; 
	}
	return (vi);
}

#define CALCI(YX, XY, DIV, WIND, LU, I, S, P) \
	I-> YX = WIND->LU.YX; \
	DIV = S.YX - P.YX; \
	if (fabs(DIV) < 1.0e-6) DIV = 1.0e-6; \
	I->XY = P.XY + (S.XY - P.XY) * (WIND->LU.YX - P.YX) / DIV;

Bool sect(dclip, side, I, S, P)
Drect	*dclip;
Int	side;
Dc	*I, S, P;
{ 	Bool sct;
	Real div;
	if ((visible(dclip, side, &S)) == (visible(dclip, side, &P)))
		sct = FALSE;
	else { switch (side) {
		case 0 : CALCI(d_y, d_x, div, dclip, d_ll, I, S, P); 
			 break; 
		case 1 : CALCI(d_x, d_y, div, dclip, d_ur, I, S, P); 
			 break; 
		case 2 : CALCI(d_y, d_x, div, dclip, d_ur, I, S, P); 
			 break; 
		case 3 : CALCI(d_x, d_y, div, dclip, d_ll, I, S, P); 
			 break; 
		}
		sct = TRUE;
	}
	return(sct);
}

/* Suth Hodg algorithm, as in Newman Spr. */

Bool suthalg(n, p1, dclip, ntot, shptr)
Size 	n;
Dc	*p1, *shptr;
Drect	*dclip;
Size	*ntot;
{
	Int i;

	*ntot = 0;
	for (i=0; i<4; i++) _first[i] = TRUE;
	while (p1->d_x == p1[n-1].d_x  &&  p1->d_y == p1[n-1].d_y)
		n--;
	while (n--) {
		suthloop(*p1,0,dclip,ntot,shptr,F,S,I,_first);
		p1++;
	}
	suthclose(0, dclip, ntot, shptr, F, S, I, &(_first[0]));
	if (*ntot == 0) return(FALSE); 
	else return(TRUE);
}

suthloop(P, side, dclip, ntot, shptr, F, S, I, _first)
Bool	*_first;
Dc	P, *shptr, *F, *S, *I;
Int	side;
Size	*ntot;
Drect	*dclip;
{
	if (side == 4) {
	    shptr += (*ntot);
	    ASS(*shptr , P)
	    (*ntot)++;
	}
	else {	
	    if (_first[side] == TRUE) {
	    	_first[side] = FALSE; ASS(F[side] , P);
	    	}
	    else if (sect(dclip, side, &I[side], S[side], P)) 
	     suthloop(I[side],side+1,dclip,ntot,shptr,F,S,I,_first);
	    ASS(S[side] , P)
	    if (visible(dclip, side, &(S[side])))
	     suthloop(S[side],side+1,dclip,ntot,shptr,F,S,I,_first);
	}
}

suthclose(side, dclip, ntot, shptr, F, S, I, _first)
Int	side;
Drect	*dclip;
Size	*ntot;
Dc	*shptr, *F, *S, *I;
Bool	*_first;
{	if (side<4) {
	     if (sect(dclip, side, &I[side], S[side], F[side]))
		 suthloop(I[side],side+1,dclip,ntot,shptr,F,S,I,_first);
	     suthclose(side+1, dclip, ntot, shptr, F, S, I, _first);
	}
}

Bool isrect(s)
Ic	*s;
{
	if ((s[0].i_x == s[1].i_x) &&
	(s[2].i_x == s[3].i_x) &&
	(s[0].i_y == s[3].i_y) &&
	(s[1].i_y == s[2].i_y)) return(TRUE);
	if ((s[0].i_x == s[3].i_x) &&
	(s[2].i_x == s[1].i_x) &&
	(s[0].i_y == s[1].i_y) &&
	(s[3].i_y == s[2].i_y)) return(TRUE);
	return (FALSE);
}

Bool 
pxl_streams(ws, nr_lines, s)
Wss	*ws;
Size	nr_lines;
Ic	*s;
{
	Screen *screen = WsScrn;
	register int	i, lngth;
	register Ic	*ic;
	register Int	color;

	color = (Int)screen->s_ccol;
	ic = s;

	for (i = 0; i < nr_lines; i++) {
		if ((ic + 1)->i_y != ic->i_y)
			return(FALSE);
		lngth = (ic + 1)->i_x - ic->i_x + 1;
		if (lngth > 0) {
			if (WsScrn->s_pxst) {
			     (*WsScrn->s_pxst)
				(ws, ic, lngth, NULL, TRUE/*1 col*/);
			}
			else {
			     (*WsScrn->s_line)(ws, 2, ic, SOLIDL, 1.0);
			}
		}
		ic += 2;
	}
	return(TRUE);
}

