/* @(#) w_gdraw.c  version:1.4.1.1  dated:84/12/19 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_gdraw.c
 * SCCS id :	w_gdraw.c 1.4.1.1
 * Last edited:	12/19/84 15:13:25
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#define GKS 2
#define GKS2
#include "cgksincl.h"

extern 	Gks	*_gkss;
extern	Gksi	*gksis;
extern	GksState gkstate;
extern 	Gksd	*gksd;
extern 	Int	attmark[];
extern 	Fun	pws_gdp;

Bool	ic_in_drect();
Bool	circ_in_clipr();
Bool	arc_in_clipr();
char 	*seg_block();


ws_gdp(ws, gdp, n, pr, m, gdr)
Wss	*ws;
Gdp	*gdp;
Int	n;
Nc	*pr;
Size	m;
Grecord	*gdr;
{
	LineRep *lrep = NULL;
	MarkRep *mrep = NULL;
	TextRep *trep = NULL;
	AreaRep *frep = NULL;
	Screen	*scr = WsScrn;
	Nc 	*nptr;
	Dc	*dc, *dptr;
	Ic	*ic;
	Drect	*clip_w = &ws->ws_wsis->wi_clipr;
	/*Bool	eral = FALSE;*/
	Int	i;

	gdp_reps(ws, gdp->gd_satt, &lrep, &mrep, &trep, &frep);

	CALLOC(dc, Dc, n, GDP)
	nptr = pr;
	dptr = dc;
	for (i = 0; i < n; i++) ws_transf(ws, nptr++, dptr++);

	CALLOC(ic, Ic, n, GDP)
	switch (gdp->gd_id) {
	case CIRCLE:
		if (circ_in_clipr(clip_w, dc) != FALSE) { 
		  	for (i = 0; i < n; i++) {
				ic[i].i_x = dc[i].d_x + 0.5;
				ic[i].i_y = dc[i].d_y + 0.5;
			}

			(*scr->s_gdpr)(ws, gdp->gd_id, n, ic,
				lrep, mrep, trep, frep, m, gdr);
		}
		break;
	case ARC:
		if (arc_in_clipr(clip_w, dc) != FALSE) { 
			for (i = 0; i < n; i++) {
				ic[i].i_x = dc[i].d_x + 0.5;
				ic[i].i_y = dc[i].d_y + 0.5;
			}

			(*scr->s_gdpr)(ws, gdp->gd_id, n, ic,
				lrep, mrep, trep, frep, m, gdr);
		}
		break;
	default:
		break;
	}

	FREE(dc)
	FREE(ic)
}

sf_gdp()
{
	pws_gdp = ws_gdp;
}


Gdpi *
sg_st_gdp(id, gdr, m)
Gdpi	id;
Grecord	*gdr;
Size	m;
{
	Gdpi	*gdpi, *tmp;
	char	*gr, *gdrptr;
	Size	*size;
	Int	sz;
		
	sz = sizeof(Gdpi) + sizeof(m) + m;
	gdpi = (Gdpi *)seg_block(sz, GDP, 1);

	tmp = gdpi;
	*tmp++ = id;
	size = (Size *)tmp;
	*size++ = m;  
	if (m != 0) {
		gdrptr = (char *)(*gdr);
		gr = (char *)size;
		while (m-- != 0) {
			*gr++ = *gdrptr++;
		}
	}
	return (gdpi);
}

gdp_ensure(id)
Gdpi 	id;
{
	switch(id) {
	case CIRCLE:
		ensure(FAR);
		break;
	case ARC:
		ensure(POL);
		break;
	default:
		Rep_Er(102, GDP);
		break;
	}
	return(0);
}

gdp_cl_mark(id)
Gdpi	id;
{	switch(id) {
	case CIRCLE:
		cl_mark(FAATT);
		break;
	case ARC:
		cl_mark(PLATT);
		break;
	}
}

gdp_ws_ensure(ws, gdp)
Wss	*ws;
Gdp	*gdp;
{	Int satt = gdp->gd_satt;
	if ((satt & 010) != 0) ws_ensure(ws, POL);
	if ((satt & 04)  != 0) ws_ensure(ws, POM);
	if ((satt & 02)  != 0) ws_ensure(ws, TXT);
	if ((satt & 01)  != 0) ws_ensure(ws, FAR);
}

Gdp *gdp_on_ws(ws, id)
Wss	*ws;
Gdpi	id;
{	Int 	i;
	Wsd	*wsd = ws->ws_wsd;

	for (i = 0; i < wsd->wd_ngdp; i++)
		if (wsd->wd_gdp[i].gd_id == id)
			return(&wsd->wd_gdp[i]);
	return(NULL);
}

gdp_reps(ws, satt, lrepp, mrepp, trepp, frepp)
Wss	*ws;
Int	satt;
LineRep	**lrepp;
MarkRep	**mrepp;
TextRep	**trepp;
AreaRep	**frepp;
{
	if ((satt & 010) != 0) *lrepp = &ws->ws_wsis->wi_lrep;
	if ((satt & 04) != 0)  *mrepp = &ws->ws_wsis->wi_mrep;
	if ((satt & 02) != 0)  *trepp = &ws->ws_wsis->wi_trep;
	if ((satt & 01) != 0)  *frepp = &ws->ws_wsis->wi_frep;
}

Bool
circ_in_clipr(clip_w, dc)
Drect	*clip_w;
Dc	*dc;
{	Real	rad, x, y;
	x = dc[1].d_x - dc[0].d_x;
	y = dc[1].d_y - dc[0].d_y;
	rad = sqrt((double)(x * x + y * y));
	if (dc->d_x + rad <= clip_w->d_ur.d_x &&
	    dc->d_y + rad <= clip_w->d_ur.d_y &&
	    dc->d_x - rad >= clip_w->d_ll.d_x &&
	    dc->d_y - rad >= clip_w->d_ll.d_y)
		return(TRUE);
	else 	return(FALSE);
}

Bool
arc_in_clipr(clip_w, dc)
Drect	*clip_w;
Dc	*dc;
{
	/*ARGSUSED*/
	/*to do*/
	return(TRUE);
}

