/* @(#) w_polyline.c  version:1.2.1.1  dated:85/01/11 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_polyline.c
 * SCCS id :	w_polyline.c 1.2.1.1
 * Last edited:	1/11/85 12:30:52
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 2
#define GKS2

#include "cgksincl.h"

Nc	*sg_sp_pr();
Nc	*outprim();
Bool	sure();
Int	clip2d();
char	*seg_block();
Bool	dc_in_drect();

extern	GksState gksst;
extern	Gks	*_gkss;
extern	Gksd	*gksd;
extern	Gksi	*gksis;

ws_pline(ws, n, pr)
Wss	*ws;
Size	n;
Nc	*pr;
{
	LineRep *lrep = &ws->ws_wsis->wi_lrep;
	Ltype	lt = lrep->lr_lt;
	Lwidth	lw = lrep->lr_lw;
	Screen	*scr = WsScrn;
	Nc 	*nptr;
	Dc	*dc, *dptr, d1, d2;
	Ic	*ic, *iptr, ic2[2];
	Drect	*clip_w = &(ws->ws_wsis->wi_clipr);
	Bool	eral = FALSE;
	Int	i, n_ic;
#ifdef METAFILE
	Mf_screen	*mfscr = MfScrn;
#endif

	if (ws->ws_wsd->wd_cat != MO) {
		if (scr->s_latt) (*scr->s_latt)(ws, *lrep);
		if (lrep->lr_ci == 0 && scr->s_colr == NULL) {
			if (scr->s_eral) {
		  		(*scr->s_eral)(ws, TRUE);
				eral = TRUE;
			}
			/*
			 *else scr_msg("\n no line erase");
			 */
		}

		CALLOC(dc, Dc, n, POL)
		CALLOC(ic, Ic, n, POL)
		nptr = pr;
		dptr = dc;
		for (i = 0; i < n; i++)
			ws_transf(ws, nptr++, dptr++);
		
		i = 0;
		dptr = dc;
		iptr = ic;
		while (i != n && dc_in_drect(clip_w, dptr)) {
			dc_to_ic(iptr++, dptr++);
			i++;
		}
		if (i == n)  /*all dc in clipwindow, no clipping*/
			(*scr->s_line) (ws, n, ic, lt, lw);
		else {
		   /*draw first not-clipped linepieces:*/
		   if (i > 0) {
			if ( i > 1)
			     (*scr->s_line)(ws, i, ic, lt, lw);
			dptr--;
			i--;
		   }
		   n_ic = 0;
		   iptr = ic;

		   while (++i != n) {
			ASS(d1, *dptr)
			dptr++;
			ASS(d2, *dptr)
			switch(clip2d(&d1, &d2, clip_w)) {
			case 0: if (n_ic != 0) {
				   (*scr->s_line)(ws, n_ic, ic, lt, lw);
				   n_ic = 0;
				   iptr = ic;
				}
				break;
			case 1: if (n_ic != 0) {
				   (*scr->s_line)(ws, n_ic, ic, lt, lw);
				   iptr = ic;
				}
				dc_to_ic(iptr++, &d1);
				dc_to_ic(iptr++, &d2);
				n_ic = 2;
				break;
			case 2: if (n_ic == 0) {
					dc_to_ic(iptr++, &d1);
					n_ic++;
				}
				dc_to_ic(iptr, &d2);
				n_ic++;
				(*scr->s_line)(ws, n_ic, ic, lt, lw);
				iptr = ic;
				n_ic = 0;
				break;
			case 3: if(n_ic != 0) {
				   (*scr->s_line)(ws, n_ic, ic, lt, lw);
				   n_ic = 0;
				   iptr = ic;
				}
				dc_to_ic(iptr++, &d1);
				dc_to_ic(iptr,   &d2);
				(*scr->s_line)(ws, 2, ic, lt, lw);
				iptr = ic;
				break;
			case 4: if (n_ic == 0) {
					dc_to_ic(iptr++, &d1);
					n_ic++;
				}
				dc_to_ic(iptr++, &d2);
				n_ic++;
				break;
			default: break;
			}
		    }
		    if (n_ic != 0)
			(*scr->s_line)(ws, n_ic, ic, lt, lw);
		}

		FREE(ic)
		FREE(dc)

		if (eral == TRUE) (*scr->s_eral)(ws, FALSE);
	}
	else {;
/*calls a driver for ws of cat MO */

#ifdef METAFILE
#ifdef LAZY
		(*mfscr->m_sln)(ws, lrep->lr_lt);
		(*mfscr->m_slwsc)(ws, lrep->lr_lw);
		(*mfscr->m_slplci)(ws, lrep->lr_ci);
#endif
		(*mfscr->m_pl)(ws, n, pr);
#endif
	}
}

extern Fun pws_pline;

sf_pline()
{
	pws_pline = ws_pline;
}


/* to do: if ltype not present in the polyline bundle table
   use index 1; see page 109 version 7.2 */
